# Automa.jl

[![Unit tests Status](https://github.com/BioJulia/Automa.jl/actions/workflows/UnitTests.yml/badge.svg)](https://github.com/BioJulia/Automa.jl/actions/workflows/UnitTests.yml)
[![Downstream tests Status](https://github.com/BioJulia/Automa.jl/actions/workflows/Downstream.yml/badge.svg)](https://github.com/BioJulia/Automa.jl/actions/workflows/Downstream.yml)
[![Docs Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://biojulia.github.io/Automa.jl/stable/)
[![codecov.io](http://codecov.io/github/BioJulia/Automa.jl/coverage.svg?branch=master)](http://codecov.io/github/BioJulia/Automa.jl?branch=master)

Automa is a regex-to-Julia compiler.
By compiling regex to Julia code in the form of `Expr` objects,
Automa provides facilities to create efficient and robust regex-based lexers, tokenizers and parsers using Julia's metaprogramming capabilities. 
You can view Automa as a regex engine that can insert arbitrary Julia code into its input matching process, which will be executed when certain parts of the regex matches an input.

![Schema of Automa.jl](docs/src/figure/Automa.png)

Automa is designed to generate very efficient code to scan large text data, often much faster than handcrafted code.

For more information [read the documentation](https://biojulia.github.io/Automa.jl/stable/), or read the examples below and in the `examples/` directory in this repository.

## Examples
### Validate some text is composed only of ASCII alphanumeric characters
```julia
using Automa

generate_buffer_validator(:validate_alphanumeric, re"[a-zA-Z0-9]*") |> eval

for s in ["abc", "aU81m", "!,>"]
    println("$s is alphanumeric? $(isnothing(validate_alphanumeric(s)))")
end
```

### Making a lexer
```julia
using Automa

tokens = [
    :identifier => re"[A-Za-z_][0-9A-Za-z_!]*",
    :lparens => re"\(",
    :rparens => re"\)",
    :comma => re",",
    :quot => re"\"",
    :space => re"[\t\f ]+",
];
@eval @enum Token errortoken $(first.(tokens)...)
make_tokenizer((errortoken, 
    [Token(i) => j for (i,j) in enumerate(last.(tokens))]
)) |> eval

collect(tokenize(Token, """(alpha, "beta15")"""))
```

### Make a simple TSV file parser
```julia
using Automa

machine = let
    name = onexit!(onenter!(re"[^\t\r\n]+", :mark), :name)
    field = onexit!(onenter!(re"[^\t\r\n]+", :mark), :field)
    nameline = name * rep('\t' * name)
    record = onexit!(field * rep('\t' * field), :record)
    compile(nameline * re"\r?\n" * record * rep(re"\r?\n" * record) * rep(re"\r?\n"))
end

actions = Dict(
    :mark => :(pos = p),
    :name => :(push!(headers, String(data[pos:p-1]))),
    :field => quote
        n_fields += 1
        push!(fields, String(data[pos:p-1]))
    end,
    :record => quote
        n_fields == length(headers) || error("Malformed TSV")
        n_fields = 0
    end
)

@eval function parse_tsv(data)
    headers = String[]
    fields = String[]
    pos = n_fields = 0
    $(generate_code(machine, actions))
    (headers, reshape(fields, length(headers), :))
end

header, data = parse_tsv("a\tabc\n12\t13\r\nxyc\tz\n\n")
```

# Code Generator
# ==============

"""
Struct used to store variable names used in generated code.
Contained in a `CodeGenContext`.
Create a custom `Variables` for your `CodeGenContext` if you
want to customize the variables used in Automa codegen, typically
if you have conflicting variables with the same name.

Automa generates code with the following variables, shown below
with their default names:
- `p::Int`: current position of data
- `p_end::Int`: end position of data
- `is_eof::Bool`: Whether `p_end` marks end file stream
- `cs::Int`: current state
- `data::Any`: input data
- `mem::SizedMemory`: Memory wrapping `data`
- `byte::UInt8`: current byte being read from `data`
- `buffer::TranscodingStreams.Buffer`: (`generate_reader` only)

# Example
```julia
julia> ctx = CodeGenContext(vars=Variables(byte=:u8));

julia> ctx.vars.byte
:u8
```
"""
struct Variables
    p::Symbol
    p_end::Symbol
    is_eof::Symbol
    cs::Symbol
    data::Symbol
    mem::Symbol
    byte::Symbol
    buffer::Symbol
end

function Variables(
    ;p=:p,
    p_end=:p_end,
    is_eof=:is_eof,
    cs=:cs,
    data=:data,
    mem=:mem,
    byte=:byte,
    buffer=:buffer
)
    Variables(p, p_end, is_eof, cs, data, mem, byte, buffer)
end

struct CodeGenContext
    vars::Variables
    generator::Function
    getbyte::Function
    clean::Bool
end

# Add these here so they can be used in CodeGenContext below
function generate_table_code end
function generate_goto_code end

"""
    CodeGenContext(;
        vars=Variables(:p, :p_end, :is_eof, :cs, :data, :mem, :byte, :buffer),
        generator=:table,
        getbyte=Base.getindex,
        clean=false
    )

Create a `CodeGenContext` (ctx), a struct that stores options for Automa code generation.
Ctxs are used for Automa's various code generator functions.
They currently take the following options (more may be added in future versions)

- `vars::Variables`: variable names used in generated code. See the `Variables` struct.
- `generator::Symbol`: code generator mechanism (`:table` or `:goto`).
  The table generator creates smaller, simpler code that uses a vector of integers to
  determine state transitions. The goto-generator uses a maze of `@goto`-statements,
  and create larger, more complex code, that is faster.
- `getbyte::Function` (table generator only): function `f(data, p)` to access byte from data.
  Default: `Base.getindex`.
- `clean`: Whether to remove some `QuoteNode`s (line information) from the generated code

# Example
```julia
julia> ctx = CodeGenContext(generator=:goto, vars=Variables(buffer=:tbuffer));

julia> generate_code(ctx, compile(re"a+")) isa Expr
true
```
"""
function CodeGenContext(;
        vars::Variables=Variables(:p, :p_end, :is_eof, :cs, :data, :mem, :byte, :buffer),
        generator::Symbol=:table,
        getbyte::Function=Base.getindex,
        clean::Bool=false)
    # special conditions for simd generator
    if generator == :goto && getbyte != Base.getindex
        throw(ArgumentError("GOTO generator only support Base.getindex"))
    end
    # check generator
    if generator == :table
        generator = generate_table_code
    elseif generator == :goto
        generator = generate_goto_code
    else
        throw(ArgumentError("invalid code generator: $(generator)"))
    end
    return CodeGenContext(vars, generator, getbyte, clean)
end

const DefaultCodeGenContext = CodeGenContext()

"""
    generate_buffer_validator(name::Symbol, regexp::RE; goto=true; docstring=true)

Generate code that, when evaluated, defines a function named `name`, which takes a
single argument `data`, interpreted as a sequence of bytes.
The function returns `nothing` if `data` matches `Machine`, else the index of the first
invalid byte. If the machine reached unexpected EOF, returns `0`.

If `goto`, the function uses the faster but more complicated `:goto` code.\\
If `docstring`, automatically create a docstring for the generated function.

See also: [`generate_io_validator`](@ref)
"""
function generate_buffer_validator(
    name::Symbol,
    regex::RegExp.RE;
    goto::Bool=true,
    docstring::Bool=true
)
    ctx = goto ? CodeGenContext(generator=:goto) : DefaultCodeGenContext
    machine = compile(RegExp.strip_actions(regex))
    code = quote
        function $(name)(data)
            $(generate_init_code(ctx, machine))
            $(generate_exec_code(ctx, machine))
            # By convention, Automa lets cs be 0 if machine executed correctly.
            return if iszero($(ctx.vars.cs))
                nothing
            # Else if EOF
            elseif $(ctx.vars.p) > $(ctx.vars.p_end)
                0
            else
                p
            end
        end
    end
    if docstring
        code = quote
            """
                $($(name))(data)::Union{Int, Nothing}

            Checks if `data`, interpreted as a bytearray, conforms to the given `Automa.Machine`.
            Returns `nothing` if it does, else the byte index of the first invalid byte.
            If the machine reached unexpected EOF, returns `0`.
            """
            $code
        end
    end
    code
end

"""
    generate_code([::CodeGenContext], machine::Machine, actions=nothing)::Expr

Generate init and exec code for `machine`.
The default code generator function for creating functions, preferentially use
this over generating init and exec code directly, due to its convenience. 
Shorthand for producing the concatenated code of:

* `generate_init_code(ctx, machine)`
* `generate_action_code(ctx, machine, actions)`
* `generate_input_error_code(ctx, machine)` [elided if actions == :debug]

# Examples
```
@eval function foo(data)
    # Initialize variables used in actions
    data_buffer = UInt8[]
    \$(generate_code(machine, actions))
    return data_buffer
end
```

See also: [`generate_init_code`](@ref), [`generate_exec_code`](@ref)
"""
function generate_code(ctx::CodeGenContext, machine::Machine, actions=nothing)
    # If actions are :debug, the user presumably wants to programatically
    # check what happens to the machine, which is not made easier by
    # throwing an error.
    error_code = if actions != :debug
        generate_input_error_code(ctx, machine)
    else
        quote nothing end
    end
    code = quote
        $(generate_init_code(ctx, machine))
        $(generate_exec_code(ctx, machine, actions))
        $(error_code)
    end
    ctx.clean && Base.remove_linenums!(code)
    return code
end
generate_code(machine::Machine, actions=nothing) = generate_code(DefaultCodeGenContext, machine, actions)

"""
    generate_init_code([::CodeGenContext], machine::Machine)::Expr

Generate variable initialization code, initializing variables such as `p`,
and `p_end`. The names of these variables are set by the `CodeGenContext`.
If not passed, the context defaults to `DefaultCodeGenContext`

Prefer using the more generic `generate_code` over this function where possible.
This function should be used if the initialized data should be modified before
the execution code.

# Example
```julia
@eval function foo(data)
    \$(generate_init_code(machine))
    p = 2 # maybe I want to start from position 2, not 1
    \$(generate_exec_code(machine, actions))
    return cs
end
```

See also: [`generate_code`](@ref), [`generate_exec_code`](@ref)
"""
function generate_init_code(ctx::CodeGenContext, machine::Machine)
    vars = ctx.vars
    code = quote
        $(vars.byte)::UInt8 = 0x00
        $(vars.p)::Int = 1
        $(vars.p_end)::Int = sizeof($(vars.data))
        $(vars.is_eof)::Bool = true
        $(vars.cs)::Int = 1
    end
    ctx.clean && Base.remove_linenums!(code)
    return code
end
generate_init_code(machine::Machine) = generate_init_code(DefaultCodeGenContext, machine)



"""
    generate_exec_code([::CodeGenContext], machine::Machine, actions=nothing)::Expr

Generate machine execution code with actions. This code should be run after the
machine has been initialized with `generate_init_code`.
If not passed, the context defaults to `DefaultCodeGenContext`

Prefer using the more generic `generate_code` over this function where possible.
This function should be used if the initialized data should be modified before
the execution code.

# Examples
```
@eval function foo(data)
    \$(generate_init_code(machine))
    p = 2 # maybe I want to start from position 2, not 1
    \$(generate_exec_code(machine, actions))
    return cs
end
```

See also: [`generate_init_code`](@ref), [`generate_exec_code`](@ref)
"""
function generate_exec_code(ctx::CodeGenContext, machine::Machine, actions=nothing)
    # make actions
    actions_dict::Dict{Symbol, Expr} = if actions === nothing
        Dict{Symbol,Expr}(a => quote nothing end for a in machine_names(machine))
    elseif actions == :debug
        debug_actions(machine)
    elseif isa(actions, AbstractDict{Symbol,Expr})
        d = Dict{Symbol,Expr}(collect(actions))

        # check the set of actions is same as that of machine's
        machine_acts = machine_names(machine)
        dict_actions = Set(k for (k,v) in d)
        for act in machine_acts
            if act ∈ dict_actions
                delete!(dict_actions, act)
            else
                error("Action \"$act\" of machine not present in input action Dict")
            end
        end
        if length(dict_actions) > 0
            error("Action \"$(first(dict_actions))\" not present in machine")
        end
        d
    else
        throw(ArgumentError("invalid actions argument"))
    end

    # generate code
    code = ctx.generator(ctx, machine, actions_dict)
    ctx.clean && Base.remove_linenums!(code)
    return code
end

function generate_exec_code(machine::Machine, actions=nothing)
    generate_exec_code(DefaultCodeGenContext, machine, actions)
end

function generate_table_code(ctx::CodeGenContext, machine::Machine, actions::Dict{Symbol,Expr})
    action_dispatch_code, set_act_code = generate_action_dispatch_code(ctx, machine, actions)
    trans_table = generate_transition_table(machine)
    getbyte_code = generate_getbyte_code(ctx)
    set_cs_code = :(@inbounds $(ctx.vars.cs) = Int($(trans_table)[($(ctx.vars.cs) - 1) << 8 + $(ctx.vars.byte) + 1]))
    eof_action_code = generate_eof_action_code(ctx, machine, actions)
    final_state_code = generate_final_state_mem_code(ctx, machine)
    return quote
        # Preserve data because SizedMemory is just a pointer
        GC.@preserve $(ctx.vars.data) begin
        $(ctx.vars.mem)::Automa.SizedMemory = $(SizedMemory)($(ctx.vars.data))
        # For each input byte...
        while $(ctx.vars.p) ≤ $(ctx.vars.p_end) && $(ctx.vars.cs) > 0
            # Load byte
            $(getbyte_code)
            # Get an integer corresponding to the set of actions that will be taken
            # for this particular input at this stage (possibly nothing)
            $(set_act_code)
            # Update state by a simple lookup in a table based on current state and input
            $(set_cs_code)
            # Go through an if-else list of all actions to match the action integet obtained
            # above, and execute the matching set of actions
            $(action_dispatch_code)
            $(ctx.vars.p) += 1
        end
        # If we're out of bytes and in an accept state, find the correct EOF action
        # and execute it, then set cs to 0 to signify correct execution
        if is_eof && $(ctx.vars.p) > $(ctx.vars.p_end) && $(final_state_code)
            $(eof_action_code)
            $(ctx.vars.cs) = 0
        elseif $(ctx.vars.cs) < 0
            # If cs < 0, the machine errored. The code above incremented p regardless,
            # but on error, we want p to be where the machine errored, so we reset it.
            $(ctx.vars.p) -= 1
        end
        end # GC.@preserve block
    end
end

# Smallest int type that n fits in
function smallest_int(n::Integer)
    for T in [Int8, Int16, Int32, Int64]
        n <= typemax(T) && return T
    end
    @assert false
end

# The table is a 256xnstates byte lookup table, such that table[input,cs] will give
# the next state.
function generate_transition_table(machine::Machine)
    nstates = machine.n_states
    trans_table = Matrix{smallest_int(nstates)}(undef, 256, nstates)
    for j in 1:size(trans_table, 2)
        trans_table[:,j] .= -j
    end
    for s in traverse(machine.start), (e, t) in s.edges
        # Preconditions work by inserting if/else statements into the code.
        # It's hard to see how we could fit it into the table-based generator
        if !isempty(e.precond)
            error("precondition is not supported in the table-based code generator; try code=:goto")
        end
        for l in e.labels
            trans_table[l+1,s.state] = t.state
        end
    end
    return trans_table
end

function generate_action_dispatch_code(ctx::CodeGenContext, machine::Machine, actions::Dict{Symbol,Expr})
    nactions = length(actions)
    T = smallest_int(nactions)
    action_table = fill(zero(T), (256, machine.n_states))
    # Each edge with actions is a Vector{Symbol} with action names.
    # Enumerate them, by mapping the vector to an integer.
    # This way, each set of actions is mapped to an integer (call it: action int)
    action_ids = Dict{Vector{Symbol},T}()
    for s in traverse(machine.start)
        for (e, t) in s.edges
            if isempty(e.actions)
                continue
            end
            id = get!(action_ids, action_names(e.actions), length(action_ids) + 1)
            # In the action table, the current state as well as the input byte gives the
            # action int (see above) to execute on this transition
            for l in e.labels
                action_table[l+1,s.state] = id
            end
        end
    end
    act = gensym()
    default = :()
    # This creates code of the form: If act == 1 (actions in action int == 1)
    # else if act == 2 (... etc)
    action_dispatch_code = foldr(default, action_ids) do names_id, els
        names, id = names_id
        action_code = rewrite_special_macros(;
            ctx=ctx,
            ex=generate_action_code(names, actions),
            at_eof=false,
            cs=nothing
        )
        return Expr(:if, :($(act) == $(id)), action_code, els)
    end
    # Action code is: Get the action int from the state and current input byte
    # Action dispatch code: The thing made above
    action_code = :(@inbounds $(act) = Int($(action_table)[($(ctx.vars.cs) - 1) << 8 + $(ctx.vars.byte) + 1]))
    return action_dispatch_code, action_code
end

function generate_goto_code(ctx::CodeGenContext, machine::Machine, actions::Dict{Symbol,Expr})
    # All the sets of actions (each set being a vector) on edges leading to a
    # given machine node.
    actions_in = Dict{Node,Set{Vector{Symbol}}}()
    for s in traverse(machine.start), (e, t) in s.edges
        push!(get!(actions_in, t, Set{Vector{Symbol}}()), action_names(e.actions))
    end
    # Assign each action a unique name based on the destination node the edge is on,
    # and an integer, e.g. state_2_action_5
    action_label = Dict{Node,Dict{Vector{Symbol},Symbol}}()
    for s in traverse(machine.start)
        action_label[s] = Dict()
        if haskey(actions_in, s)
            for (i, names) in enumerate(actions_in[s])
                action_label[s][names] = Symbol("state_", s.state, "_action_", i)
            end
        end
    end

    # Main loop expression blocks
    blocks = Expr[]
    for s in traverse(machine.start)
        block = Expr(:block)
        for (names, label) in action_label[s]
            # These blocks are goto'd directly, when encountering the right edge. Their content
            # if of the form execute action, then go to the state the edge was pointing to
            if isempty(names)
                continue
            end
            append_code!(block, quote
                @label $(label)
                $(rewrite_special_macros(;
                    ctx=ctx,
                    ex=generate_action_code(names, actions),
                    at_eof=false,
                    cs=s.state)
                )
                @goto $(Symbol("state_", s.state))
            end)
        end

        # This is the code of each state. The pointer is incremented, you @goto the exit
        # if EOF, else continue to the code created below
        append_code!(block, quote
            @label $(Symbol("state_", s.state))
            $(ctx.vars.p) += 1
            if $(ctx.vars.p) > $(ctx.vars.p_end)
                $(ctx.vars.cs) = $(s.state)
                @goto exit
            end
        end)

        # SIMD code is special: If a node has a self-edge with no preconditions or actions,
        # then the machine can skip ahead until the input is no longer in that edge's byteset.
        # This can be effectively SIMDd
        # If such an edge is detected, we treat it specially with code here, and leave the
        # non-SIMDable edges for below

        # SIMD code temporarily disabled.
        simd, non_simd = peel_simd_edge(s)
        if simd !== nothing
            push!(non_simd, (simd, s))
        end
        simd = nothing
        simd_code = :()

        #=
        simd_code = if simd !== nothing
            quote
                $(generate_simd_loop(ctx, simd.labels))
                if $(ctx.vars.p) > $(ctx.vars.p_end)
                    $(ctx.vars.cs) = $(s.state)
                    @goto exit
                end
            end
        else
            :()
        end
        =#
        
        # If no inputs match, then we set cs = -cs to signal error, and go to exit
        default = :($(ctx.vars.cs) = $(-s.state); @goto exit)

        # For each edge in optimized order, check if the conditions for taking that edge
        # is met. If so, go to the edge's actions if it has any actions, else go directly
        # to the destination state
        dispatch_code = foldr(default, optimize_edge_order(non_simd)) do edge, els
            e, t = edge
            if isempty(e.actions)
                then = :(@goto $(Symbol("state_", t.state)))
            else
                then = :(@goto $(action_label[t][action_names(e.actions)]))
            end
            return Expr(:if, generate_condition_code(ctx, e, actions), then, els)
        end

        # Here we simply add the code created above to the list of expressions
        append_code!(block, quote
            @label $(Symbol("state_case_", s.state))
            $(simd_code)
            $(ctx.vars.byte) = @inbounds getindex($(ctx.vars.mem), $(ctx.vars.p))
            $(dispatch_code)
        end)
        push!(blocks, block)
    end

    # In the beginning of the code generated here, the machine may not be in start state 1.
    # E.g. it may be resuming. So, we generate a list of if-else statements that simply check
    # the starting state, then directly goto that state.
    # In cases where the starting state is hardcoded as a constant, (which is quite often!)
    # hopefully the Julia compiler will optimize this block away.
    enter_code = foldr(:(@goto exit), 1:machine.n_states) do s, els
        return Expr(:if, :($(ctx.vars.cs) == $(s)), :(@goto $(Symbol("state_case_", s))), els)
    end

    # When EOF, go through a list of if/else statements: If cs == 1, do this, elseif
    # cs == 2 do that etc
    eof_action_code = rewrite_special_macros(;
        ctx=ctx,
        ex=generate_eof_action_code(ctx, machine, actions),
        at_eof=true,
        cs=nothing
    )

    # Check the final state is an accept state, in an efficient manner
    final_state_code = generate_final_state_mem_code(ctx, machine)

    # This is an overview of the final code structure
    return quote
        $(ctx.vars.mem) = $(SizedMemory)($(ctx.vars.data))
        if $(ctx.vars.p) > $(ctx.vars.p_end)
            @goto exit
        end
        $(enter_code)
        $(Expr(:block, blocks...))
        @label exit
        if is_eof && $(ctx.vars.p) > $(ctx.vars.p_end) && $(final_state_code)
            $(eof_action_code)
            $(ctx.vars.cs) = 0
        end
    end
end


function append_code!(block::Expr, code::Expr)
    @assert block.head == :block
    @assert code.head == :block
    append!(block.args, code.args)
    return block
end

# Note: This function has been carefully crafted to produce (nearly) optimal
# assembly code for AVX2-capable CPUs. Change with great care.

# Temporarily disabled because I've come to the realization that Julia does not
# yet make it possible to robustly check what CPU instructions the user has available
# See related issue
#=
function generate_simd_loop(ctx::CodeGenContext, bs::ByteSet)
    # ScanByte finds first byte in a byteset. We want to find first
    # byte NOT in this byteset, as this is where we can no longer skip ahead to
    byteset = ~ScanByte.ByteSet(bs)
    bsym = gensym()
    quote
        # We wrap this in an Automa function, because otherwise the generated code
        # would have a reference to ScanByte, which the user may not have imported.
        # But they surely have imported Automa.
        $bsym = Automa.loop_simd(
            $(ctx.vars.mem).ptr + $(ctx.vars.p) - 1,
            ($(ctx.vars.p_end) - $(ctx.vars.p) + 1) % UInt,
            Val($byteset)
        )
        $(ctx.vars.p) = if $bsym === nothing
            $(ctx.vars.p_end) + 1
        else
            $(ctx.vars.p) + $bsym - 1
        end
    end
end

# Necessary wrapper function, see comment in `generate_simd_loop`
@inline function loop_simd(ptr::Ptr, len::UInt, valbs::Val)
    ScanByte.memchr(ptr, len, valbs)
end
=#

# Make if/else statements for each state that is an acceptable end state, and execute
# the actions attached with ending in this state.
function generate_eof_action_code(ctx::CodeGenContext, machine::Machine, actions::Dict{Symbol,Expr})
    return foldr(:(), machine.eof_actions) do s_as, els
        s, as = s_as
        action_code = rewrite_special_macros(;
            ctx=ctx,
            ex=generate_action_code(action_names(as), actions),
            at_eof=true,
            cs=nothing
        )
        Expr(:if, state_condition(ctx, s), action_code, els)
    end
end

function generate_action_code(list::ActionList, actions::Dict{Symbol,Expr})
    return generate_action_code(action_names(list), actions)
end

function generate_action_code(names::Vector{Symbol}, actions::Dict{Symbol,Expr})
    return Expr(:block, (actions[n] for n in names)...)
end

function generate_getbyte_code(ctx::CodeGenContext)
    return generate_getbyte_code(ctx, ctx.vars.byte, 0)
end

function generate_getbyte_code(ctx::CodeGenContext, varbyte::Symbol, offset::Int)
    :($(varbyte) = $(ctx.getbyte)($(ctx.vars.mem), $(ctx.vars.p) + $(offset)))
end

function state_condition(ctx::CodeGenContext, s::Int)
    return :($(ctx.vars.cs) == $(s))
end

function generate_condition_code(ctx::CodeGenContext, edge::Edge, actions::Dict{Symbol,Expr})
    labelcode = generate_membership_code(ctx.vars.byte, edge.labels)
    precondcode = foldr(:(true), edge.precond) do p, ex
        name, value = p
        if value == BOTH
            ex1 = :(true)
        elseif value == TRUE
            ex1 = :( $(actions[name]))
        elseif value == FALSE
            ex1 = :(!$(actions[name]))
        else
            ex1 = :(false)
        end
        return Expr(:&&, ex1, ex)
    end
    return :($(labelcode) && $(precondcode))
end

# Check whether the final state belongs to `machine.final_states`.
# We simply unroll a bitvector and check for membership in that
function generate_final_state_mem_code(ctx::CodeGenContext, machine::Machine)
    # First create the bitvector, a dense vector of bits that are 1 for being
    # an accept state, and 0 for not. It's offset by `offset` bits.
    offset = minimum(machine.final_states)
    NBITS = 8*sizeof(UInt)
    len = length(offset:maximum(machine.final_states))
    uints = zeros(UInt, cld(len, NBITS))
    for state in machine.final_states
        arr_off, bit_off = divrem(state - offset, 8*sizeof(UInt))
        uints[arr_off + 1] = uints[arr_off + 1] | (1 << bit_off)
    end
    # For each uint in the vector, we check if CS in in the corresponding state
    ors = foldr(:(false), enumerate(uints)) do (i, u), oldx
        newx = quote
            (&)(
                $(ctx.vars.cs) < $(i * NBITS + offset),
                isodd($u >>> (($(ctx.vars.cs) - $offset) & $(NBITS-1)))
            )
        end
        Expr(:||, newx, oldx)
    end
    # Current state is at least minimum final state
    return Expr(:&&, :($(ctx.vars.cs) > $(offset - 1)), ors)
end

# Be careful trying to optimize this, LLVM creates insanely efficient code
# using this. Be sure to benchmark any improvements
function generate_membership_code(var::Symbol, set::ByteSet)
    min, max = minimum(set), maximum(set)
    @assert min isa UInt8 && max isa UInt8
    if max - min + 1 == length(set)
        # contiguous
        if min == max
            return :($(var) == $(min))
        else
            return :($(var) in $(min:max))
        end
    else
        return foldr((range, cond) -> Expr(:||, :($(var) in $(range)), cond),
                     :(false),
                     sort(range_encode(set), by=length, rev=true))
    end
end

# Create a user-friendly informative error if a bad input is seen.
# Defined in machine.jl, see that file.
function generate_input_error_code(ctx::CodeGenContext, machine::Machine)
    byte_symbol = gensym()
    vars = ctx.vars
    return quote
        if $(vars.cs) != 0
            $(vars.cs) = -abs($(vars.cs)) 
            $byte_symbol = $(vars.p) > $(vars.p_end) ? nothing : $(vars.byte)
            $(Automa.throw_input_error)($(machine), -$(vars.cs), $byte_symbol, $(vars.mem), $(vars.p))
        end
    end
end

# Add a warning if users go down a rabbit hole trying to figure out what these macros
# expand to.
# See the function `rewrite_special_macros` below, where the expansion happens
const WARNING_STRING = """This string comes from the expansion of a fake macro in Automa.jl.
It is intercepted and expanded by Automa's own compiler, not by the Julia compiler.
Search for this string in the Automa source code to learn more."""

"""
    @escape()

Pseudomacro. When encountered during `Machine` execution, the machine will stop executing.
This is useful to interrupt the parsing process, for example to emit a record during parsing
of a larger file.
`p` will be advanced as normally, so if `@escape` is hit on `B` during parsing of `"ABC"`,
the next byte will be `C`.
"""
macro escape()
    :($WARNING_STRING)
end

"""
    @mark()

Pseudomacro, to be used with IO-parsing Automa functions.
This macro will "mark" the position of `p` in the current buffer.
The marked position will not be flushed from the buffer after being consumed.
For example, Automa code can call `@mark()` at the beginning of a large string,
then when the string is exited at position `p`,
it is guaranteed that the whole string resides in the buffer at positions `markpos():p-1`.
"""
macro mark()
    :($WARNING_STRING)
end

"""
    unmark()

Pseudomacro. Removes the mark from the buffer. This allows all previous data to
be cleared from the buffer.

See also: [`@mark`](@ref), [`@markpos`](@ref)
"""
macro unmark()
    :($WARNING_STRING)
end

"""
    markpos()

Pseudomacro. Get the position of the mark in the buffer.

See also: [`@mark`](@ref), [`@markpos`](@ref)
"""
macro markpos()
    :($WARNING_STRING)
end

"""
    bufferpos()

Pseudomacro. Returns the integer position of the current `TranscodingStreams`
buffer (only used with the `generate_reader` function).

# Example
```
# Inside some Automa action code
@setbuffer()
description = sub_parser(stream)
p = @bufferpos()
```

See also: [`@setbuffer`](@ref)
"""
macro bufferpos()
    :($WARNING_STRING)
end

"""
    relpos(p)

Automa pseudomacro. Return the position of `p` relative to `@markpos()`.
Equivalent to `p - @markpos() + 1`.
This can be used to mark additional points in the stream when the mark is set,
after which their action position can be retrieved using `abspos(x)`.

Behaviour is undefined if mark has not yet been set.

# Example usage:
```
# In one action
identifier_pos = @relpos(p)

# Later, in a different action
identifier = data[@abspos(identifier_pos):p]
```

See also: [`@abspos`](@ref)
"""
macro relpos(p)
    :($WARNING_STRING)
end

"""
    abspos(p)

Automa pseudomacro. Used to obtain the actual position of a relative position
obtained from `@relpos`. See [`@relpos`](@ref) for more details.

Behaviour is undefined if mark has not yet been set.
"""
macro abspos(p)
    :($WARNING_STRING)
end

"""
    setbuffer()

Updates the buffer position to match `p`.
The buffer position is syncronized with `p` before and after calls to
functions generated by `generate_reader`.
`@setbuffer()` can be used to the buffer before calling another parser.

# Example
```
# Inside some Automa action code
@setbuffer()
description = sub_parser(stream)
p = @bufferpos()
```

See also: [`@bufferpos`](@ref)
"""
macro setbuffer()
    :($WARNING_STRING)
end

# The reason we have this function is because we don't want to expose too deep
# internals of TranscodingStream buffers to the final user, but the user needs to
# inject code that operates on buffers into Automa. So, we need to abstract it.
# Maybe they should have been ordinary functions... (TODO)
# @escape is an exception, this does require code generation that touches into
# the internals of machine execution
function rewrite_special_macros(;
    ctx::CodeGenContext,
    ex::Expr,
    # nothing if code is expanded outside machine execution.
    at_eof::Union{Bool, Nothing},
    # nothing if table generator, else Int
    cs::Union{Int, Nothing}
)
    args = []
    for arg in ex.args
        special_macro = special_macro_type(arg)
        if special_macro isa Symbol
            expr = if special_macro == Symbol("@escape")
                if at_eof === nothing
                    error(
                        "Special macro @escape can only be used in `actions`, ",
                        "and not in e.g. `initcode` or other such user-injected code"
                    )
                # If we're at eof, machine is already stopped. 
                elseif at_eof
                    quote nothing end
                else
                    # If machine is a table generator, cs is already set, and the machine
                    # execution is a while loop we need to break
                    if cs === nothing
                        quote
                            $(ctx.vars.p) += 1
                            break
                        end
                    # If machine is a goto generator, cs is only set when we exit the
                    # machine, and we must exit it by @goto exit
                    else
                        quote
                            $(ctx.vars.cs) = $(cs)
                            $(ctx.vars.p) += 1
                            @goto exit
                        end
                    end
                end
            elseif special_macro == Symbol("@mark")
                quote $(ctx.vars.buffer).markpos = $(ctx.vars.p) end
            elseif special_macro == Symbol("@unmark")
                quote $(ctx.vars.buffer).markpos = 0 end
            elseif special_macro == Symbol("@markpos")
                quote $(ctx.vars.buffer).markpos end
            elseif special_macro == Symbol("@bufferpos")
                quote $(ctx.vars.buffer).bufferpos end
            elseif special_macro == Symbol("@setbuffer")
                quote $(ctx.vars.buffer).bufferpos = $(ctx.vars.p) end
            else
                @assert false
            end
            push!(args, expr)
        elseif special_macro isa Tuple{Symbol, Any}
            (sym, arg) = special_macro
            expr = if sym == Symbol("@relpos")
                quote $(arg) - $(ctx.vars.buffer).markpos + 1 end
            elseif sym == Symbol("@abspos")
                quote $(arg) + $(ctx.vars.buffer).markpos - 1 end
            else
                @assert false
            end
            push!(args, expr)
        elseif isa(arg, Expr)
            push!(args, rewrite_special_macros(;ctx=ctx, ex=arg, at_eof=at_eof, cs=cs))
        else
            push!(args, arg)
        end
    end
    return Expr(ex.head, args...)
end

function special_macro_type(arg)
    (arg isa Expr && arg.head == :macrocall) || return nothing
    sym = arg.args[1]
    if sym == Symbol("@escape") ||
        sym == Symbol("@mark") ||
        sym == Symbol("@unmark") ||
        sym == Symbol("@markpos") ||
        sym == Symbol("@bufferpos") ||
        sym == Symbol("@setbuffer")

        if any(view(arg.args, 2:lastindex(arg.args))) do a
                !(a isa LineNumberNode)
            end
            error("Automa pseudomacro $(sym) used with arguments: Use it like this: `$(sym)()`")
        end
        return sym
    elseif sym == Symbol("@relpos") || sym == Symbol("@abspos")
        non_linenumber_args = filter!(a -> !(a isa LineNumberNode), arg.args[2:end])
        if length(non_linenumber_args) != 1
            error(
                "Automa pseudomacro $(sym) should be used with exactly 1 argument, " *
                "got $(non_linenumber_args)"
            )
        end
        return (sym, only(non_linenumber_args))
    end
    return nothing
end

function isescape(arg)
    return arg isa Expr && arg.head == :macrocall && arg.args[1] == Symbol("@escape")
end

# Debug actions just pushes the action names into a vector called "logger".
# this exists as a convenience method to allow the user to set actions = :debug
# in generate_exec_code
function debug_actions(machine::Machine)
    function log_expr(name)
        return :(push!(logger, $(QuoteNode(name))))
    end
    return Dict{Symbol,Expr}(name => log_expr(name) for name in machine_names(machine))
end

"If possible, remove self-simd edge."
function peel_simd_edge(node)::Tuple{Union{Nothing, Edge}, Vector{Tuple{Edge, Node}}}
    non_simd = Tuple{Edge, Node}[]
    simd = nothing
    # A simd-edge has no actions or preconditions, and its source is same as destination.
    # that means the machine can just skip ahead
    for (e, t) in node.edges
        if t === node && isempty(e.actions) && isempty(e.precond)
            # There should only be 1 SIMD edge possible, if not, the machine
            # was not properly optimized by Automa, since SIMD edges should be
            # collapsable, as they have the same actions, preconditions and target node,
            # namely none, none and self.
            @assert simd === nothing
            simd = e
        else
            push!(non_simd, (e, t))
        end
    end
    return simd, non_simd
end
    
# Sort edges by its size in descending order.
function optimize_edge_order(edges)
    return sort!(copy(edges), by=e->length(e[1].labels), rev=true)
end

# Generic foldr. We have this here because using Base's foldr requires the iterator
# to have a reverse method, whereas this one doesn't (but is much less efficient)
function foldr(op::Function, x0, xs)
    function rec(xs, s)
        if s === nothing
            return x0
        else
            return op(s[1], rec(xs, iterate(xs, s[2])))
        end
    end
    return rec(xs, iterate(xs))
end

module Test08

using Automa
using Test

@testset "Test08" begin
    re = Automa.RegExp
    int = re"[-+]?[0-9]+"
    prefloat = re"[-+]?([0-9]+\.[0-9]*|[0-9]*\.[0-9]+)"
    float = prefloat | re.cat(prefloat | re"[-+]?[0-9]+", re"[eE][-+]?[0-9]+")
    number = int | float
    spaces = re.rep(re.space())
    numbers = re.cat(re.opt(spaces * number), re.rep(re.space() * spaces * number), spaces)

    onenter!(number, :mark)
    onexit!(int, :int)
    onexit!(float, :float)

    machine = Automa.compile(numbers)

    actions = Dict(
        :mark  => :(mark = p),
        :int   => :(push!(tokens, (:int, String(data[mark:p-1])))),
        :float => :(push!(tokens, (:float, String(data[mark:p-1])))),
    )

    ctx = Automa.CodeGenContext()

    @eval function tokenize(data)
        tokens = Tuple{Symbol,String}[]
        mark = 0
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine, actions))
        return tokens, cs == 0 ? :ok : cs < 0 ? :error : :incomplete
    end

    @test tokenize(b"") == ([], :ok)
    @test tokenize(b"  ") == ([], :ok)
    @test tokenize(b"42") == ([(:int, "42")], :ok)
    @test tokenize(b"3.14") == ([(:float, "3.14")], :ok)
    @test tokenize(b"1 -42 55") == ([(:int, "1"), (:int, "-42"), (:int, "55")], :ok)
    @test tokenize(b"12. -22. .1 +10e12") == ([(:float, "12."), (:float, "-22."), (:float, ".1"), (:float, "+10e12")], :ok)
    @test tokenize(b" -3 -1.2e-3  +54 1.E2  ") == ([(:int, "-3"), (:float, "-1.2e-3"), (:int, "+54"), (:float, "1.E2")], :ok)

    @test tokenize(b"e") == ([], :error)
    @test tokenize(b"42,") == ([], :error)
    @test tokenize(b"42 ,") == ([(:int, "42")], :error)

    @test tokenize(b".") == ([], :incomplete)
    @test tokenize(b"1e") == ([], :incomplete)
    @test tokenize(b"1e-") == ([], :incomplete)
end

end

module Test17

using Automa
using Test

@testset "Test17" begin
    re1 = re"[a\-c]"
    onenter!(re1, :enter)
    onexit!(re1, :exit)
    machine1 = Automa.compile(re1)
    @test occursin(r"^Automa.Machine\(<.*>\)$", repr(machine1))

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        code = Automa.generate_code(ctx, machine1, :debug)
        validate = @eval function (data)
            logger = Symbol[]
            $(code)
            return cs == 0, logger
        end

        @test validate(b"-") == (true, [:enter, :exit])
        @test validate(b"b") == (false, Symbol[])
    end

    re2 = re"[a-c]"
    onenter!(re2, :enter)
    onexit!(re2, :exit)
    machine2 = Automa.compile(re2)
    @test occursin(r"^Automa.Machine\(<.*>\)$", repr(machine2))

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        code = Automa.generate_code(ctx, machine2, :debug)
        validate = @eval function (data)
            logger = Symbol[]
            $(code)
            return cs == 0, logger
        end

        @test validate(b"-") == (false, [])
        @test validate(b"b") == (true, Symbol[:enter, :exit])
    end
end

end

module Test18

using Automa
using Automa.RegExp: @re_str
using Test

@testset "Test18" begin
    regex = re"\0\a\b\t\n\v\r\x00\xff\xFF[\\][^\\]"
    for goto in (false, true)
        @eval $(Automa.generate_buffer_validator(:validate, regex; goto=goto, docstring=false))

        # Bad input types
        @test_throws Exception validate(18)
        @test_throws Exception validate('a')
        @test_throws Exception validate(0x01:0x02)

        @test validate(b"\0\a\b\t\n\v\r\x00\xff\xFF\\!") === nothing
        bad_input = b"\0\a\b\t\n\v\r\x00\xff\xFF\\\\\\"
        @test validate(bad_input) == lastindex(bad_input)
        bad_input = b"\0\a\b\t\n\v\r\x00\xff\xFF\\"
        @test validate(bad_input) == 0
    end
end

end

# Machine
# =======

struct Node
    state::Int
    edges::Vector{Tuple{Edge,Node}}
end

function Node(state::Int)
    return Node(state, Tuple{Edge,Node}[])
end

function Base.show(io::IO, node::Node)
    print(io, summary(node), "(<state=$(node.state),#edges=$(length(node.edges))>)")
end

function findedge(s::Node, b::UInt8)
    for (e, t) in s.edges
        if b ∈ e.labels
            return (e, t)
        end
    end
    error("$(b) ∈ label not found")
end

"""
    Machine

An `Automa.Machine` represents a compiled regular expression in `Automa.jl`.
Its fields are considered internal. Its only use it to use as arguments in
Automa's code generation functions.

To visualise the DFA represented by a `Machine`, use `Automa.machine2dot`
to construct a DOT file, then visualise it using the `graphviz` software.
"""
struct Machine
    start::Node
    n_states::Int
    final_states::Set{Int}
    eof_actions::Dict{Int,ActionList}
end

function action_names(machine::Machine)
    actions = Set{Symbol}()
    for s in traverse(machine.start)
        for (e, t) in s.edges
            union!(actions, a.name for a in e.actions)
        end
    end
    for as in values(machine.eof_actions)
        union!(actions, a.name for a in as)
    end
    return actions
end

function machine_names(machine::Machine)
    actions = action_names(machine)
    for node in traverse(machine.start), (e, _) in node.edges
        union!(actions, e.precond.names)
    end
    return actions
end

function Base.show(io::IO, machine::Machine)
    print(io,
        summary(machine),
        "(<n_states=", machine.n_states,
        ",final_states=[", join(map(string, collect(machine.final_states)), ','), "]>)"
    )
end

# Reorder machine states so the states are in a completely deterministic manner.
# solves #19, see issue #106.
function reorder_machine(machine::Machine)
    # old state index => new state index, in a deterministic manner
    old2new = Dict(machine.start.state => 1)
    remaining = [machine.start]
    while !isempty(remaining)
        node = pop!(remaining)
        for (_, target) in sort(node.edges; lt=in_sort_order, by=first)
            if !haskey(old2new, target.state)
                old2new[target.state] = length(old2new) + 1
                push!(remaining, target)
            end
        end
    end

    # Make new nodes complete with edges
    new_nodes = Dict(i => Node(i) for i in 1:length(old2new))
    for old_node in traverse(machine.start)
        for (e, t) in old_node.edges
            new_node = new_nodes[old2new[old_node.state]]
            push!(
                new_node.edges,
                (e, new_nodes[old2new[t.state]])
            )
            sort!(new_node.edges; by=first, lt=in_sort_order)
        end
    end

    # Rebuild machine and return it
    Machine(
        new_nodes[1],
        machine.n_states,
        Set([old2new[i] for i in machine.final_states]),
        Dict{Int, ActionList}(old2new[i] => act for (i, act) in machine.eof_actions)
    )
end

"""
    compile(re::RE; optimize::Bool=true, unambiguous::Bool=true)::Machine

Compile a finite state machine (FSM) from `re`.
If `optimize`, attempt to minimize the number of states in the FSM.
If `unambiguous`, disallow creation of FSM where the actions are not deterministic.

# Examples
```
machine = let
    name = re"[A-Z][a-z]+"
    first_last = name * re" " * name
    last_first = name * re", " * name
    compile(first_last | last_first)
end
```
"""
function compile(re::RegExp.RE; optimize::Bool=true, unambiguous::Bool=true)
    nfa2machine(re2nfa(re); optimize=optimize, unambiguous=unambiguous)
end

function nfa2machine(nfa::NFA; optimize::Bool=true, unambiguous::Bool=true)
    dfa = nfa2dfa(nfa, unambiguous)
    if optimize
        dfa = reduce_nodes(dfa)
    end
    validate(dfa)
    machine = dfa2machine(dfa)
    return reorder_machine(machine)
end

function dfa2machine(dfa::DFA)
    newnodes = Dict{DFANode,Node}()
    new(s) = get!(() -> Node(length(newnodes) + 1), newnodes, s)
    final_states = Set{Int}()
    eof_actions = Dict{Int,ActionList}()
    for s in traverse(dfa.start)
        s′ = new(s)
        if s.final
            push!(final_states, s′.state)
            eof_actions[s′.state] = s.eof_actions
        end
        for (e, t) in s.edges
            push!(s′.edges, (e, new(t)))
        end
    end
    start = new(dfa.start)
    @assert start.state == 1
    return Machine(start, length(newnodes), final_states, eof_actions)
end

function execute(machine::Machine, data::Vector{UInt8})
    s = machine.start
    cs = s.state
    actions = Symbol[]
    for d in data
        try
            e, s = findedge(s, d)
            cs = s.state
            append!(actions, action_names(e.actions))
        catch ex
            if !isa(ex, ErrorException)
                rethrow()
            end
            cs = -cs
            break
        end
    end
    if cs ∈ machine.final_states && haskey(machine.eof_actions, s.state)
        append!(actions, action_names(machine.eof_actions[s.state]))
    end
    if cs > 0
        if cs ∈ machine.final_states
            cs = 0
        else
            cs = -cs
        end
    end
    return cs, actions
end

function execute(machine::Machine, data::String)
    return execute(machine, convert(Vector{UInt8}, codeunits(data)))
end

function throw_input_error(
    machine::Machine,
    state::Integer,
    byte::Union{UInt8, Nothing}, # nothing if input is unexpected EOF
    memory, # SizedMemory
    index::Integer
)
    buf = IOBuffer()
    @assert index <= lastindex(memory) + 1
    # Print position in memory
    is_eof = index > lastindex(memory)
    @assert byte isa (is_eof ? Nothing : UInt8)
    slice = max(1,index-100):index - is_eof
    bytes = repr(String([memory[i] for i in slice]))
    write(
        buf,
        "Error during FSM execution at buffer position ",
        string(index),
        ".\nLast ",
        string(length(slice)),
        " byte(s) were:\n\n"
    )
    write(buf, bytes, "\n\n")

    # Print header
    input = byte isa UInt8 ? repr(first(String([byte]))) : "EOF"
    write(buf, "Observed input: $input at state $state. Outgoing edges:\n")

    # Print edges
    nodes = collect(traverse(machine.start))
    node = nodes[findfirst(n -> n.state == state, nodes)::Int]
    for (edge, _) in node.edges
        print(buf, " * ", replace(edge2str(edge), "\\\\"=>"\\"), '\n')
    end
    if state in machine.final_states
        print(buf, " * ", eof_label(machine.eof_actions[state]), '\n')
    end

    # Print footer
    write(buf, "\nInput is not in any outgoing edge, and machine therefore errored.")

    str = String(take!(buf))
    error(str)
end

module Test13

using Automa
using Test

# Some cases of regex I've seen fail
@testset "Test13" begin
    for (regex, good_strings, bad_strings) in [
        (re"[AB]" & re"A", ["A"], ["B", "AA", "AB"]),
        (re"(A|B|C|D)" \ re"[A-C]", ["D"], ["AC", "A", "B", "DD"]),
        (!re"A[BC]D?E", ["ABCDE", "ABCE"], ["ABDE", "ACE", "ABE"])
    ]
        for goto in (false, true)
            @eval $(Automa.generate_buffer_validator(:validate, regex; goto=goto, docstring=false))
            for string in good_strings
                @test validate(string) === nothing
            end
            for string in bad_strings
                @test validate(string) !== nothing
            end
        end
    end
end

end # module

module Test04

using Automa
using Test

@testset "Test04" begin
    re = Automa.RegExp
    beg_a = re.cat('a', re"[ab]*")
    end_b = re.cat(re"[ab]*", 'b')
    beg_a_end_b = re.isec(beg_a, end_b)

    machine = Automa.compile(beg_a_end_b)

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        init_code = Automa.generate_init_code(ctx, machine)
        exec_code = Automa.generate_exec_code(ctx, machine)
        validate = @eval function (data)
            $(init_code)
            $(exec_code)
            return cs == 0
        end
        @test validate(b"") == false
        @test validate(b"a") == false
        @test validate(b"aab") == true
        @test validate(b"ab") == true
        @test validate(b"aba") == false
        @test validate(b"abab") == true
        @test validate(b"abb") == true
        @test validate(b"abbb") == true
        @test validate(b"b") == false
        @test validate(b"bab") == false
    end
end

end

using Automa

using Test

@testset "SizedMemory" begin
    # Vector{UInt8}
    mem = Automa.SizedMemory(b"bar")
    @test lastindex(mem) === length(mem) === 3
    @test mem[1] === UInt8('b')
    @test mem[2] === UInt8('a')
    @test mem[3] === UInt8('r')
    @test_throws BoundsError mem[0]
    @test_throws BoundsError mem[4]

    # String
    mem = Automa.SizedMemory("bar")
    @test lastindex(mem) === length(mem) === 3
    @test mem[1] === UInt8('b')
    @test mem[2] === UInt8('a')
    @test mem[3] === UInt8('r')
    @test_throws BoundsError mem[0]
    @test_throws BoundsError mem[4]

    # SubString
    mem = Automa.SizedMemory(SubString("xbar", 2, 4))
    @test lastindex(mem) === length(mem) === 3
    @test mem[1] === UInt8('b')
    @test mem[2] === UInt8('a')
    @test mem[3] === UInt8('r')
    @test_throws BoundsError mem[0]
    @test_throws BoundsError mem[4]
end

@testset "ByteSet" begin
    include("byteset.jl")
end

@testset "RegExp" begin
    @test_throws ArgumentError("invalid escape sequence: \\o") Automa.RegExp.parse("\\o")
    @test ('+' * re"abc") isa RE
    @test_throws Exception Automa.RegExp.parse("+")
end

@testset "DOT" begin
    re = re"[A-Za-z_][A-Za-z0-9_]*"
    onenter!(re, :enter)
    onexit!(re, :exit)
    nfa = Automa.re2nfa(re)
    @test startswith(Automa.nfa2dot(nfa), "digraph")
    dfa = Automa.nfa2dfa(nfa)
    @test startswith(Automa.dfa2dot(dfa), "digraph")
    machine = Automa.compile(re)
    @test startswith(Automa.machine2dot(machine), "digraph")
    @test occursin(r"^Automa\.NFANode\(.*\)$", repr(nfa.start))
    @test occursin(r"^Automa\.DFANode\(.*\)$", repr(dfa.start))
    @test occursin(r"^Automa\.Node\(.*\)$", repr(machine.start))
end

@testset "Null Regex" begin
    re = Automa.RegExp
    for null_regex in [
        re"A" & re"B",
        (re"B" | re"C") \ re"[A-D]",
        !re.rep(re.any()),
        !re"[\x00-\xff]*",
    ]
        @test_throws ErrorException Automa.compile(null_regex)
    end
end

@testset "Determinacy" begin
    # see https://github.com/BioJulia/Automa.jl/issues/19
    notmach(re) = Automa.machine2dot(Automa.compile(re)) != Automa.machine2dot(Automa.compile(re))
    for re in (re"0?11|0?12", re"0?12|0?1*")
        @test count(_->notmach(re), 1:1000) == 0
    end
end

# Can't have final actions in looping regex
@testset "Looping regex" begin
    nonlooping_regex = [
        re"abc",
        re"a+b",
        re"(a|b)*c",
        re"a|b|c",
    ]

    looping_regex = [
        re"a+"
        re"abc*"
        re"ab(c*)"
        re"(a|b|c)+"
        re"(abc)+"
    ]

    for regex in nonlooping_regex
        onfinal!(regex, :a)
        @test Automa.re2nfa(regex) isa Automa.NFA
    end

    for regex in looping_regex
        onfinal!(regex, :a)
        @test_throws Exception Automa.re2nfa(regex)
    end
end

include("test01.jl")
include("test02.jl")
include("test03.jl")
include("test04.jl")
include("test05.jl")
include("test06.jl")
include("test07.jl")
include("test08.jl")
include("test09.jl")
include("test10.jl")
include("test11.jl")
include("test12.jl")
include("test13.jl")
include("test14.jl")
include("test15.jl")
include("test16.jl")
include("test17.jl")
include("test18.jl")
include("test19.jl")
include("input_error.jl")
include("simd.jl")
include("unicode.jl")
include("validator.jl")
include("tokenizer.jl")

module TestFASTA
using Test
@testset "FASTA" begin
    include("../example/fasta.jl")
    @test records[1].identifier == "NP_003172.1"
    @test records[1].description == "brachyury protein isoform 1 [Homo sapiens]"
    @test records[1].sequence[1:5] == "MSSPG"
    @test records[1].sequence[end-4:end] == "SPPSM"
end
end

module TestNumbers
using Test
@testset "Numbers" begin
    include("../example/numbers.jl")
    @test tokens == [(:dec,"1"),(:hex,"0x0123BEEF"),(:oct,"0o754"),(:float,"3.14"),(:float,"-1e4"),(:float,"+6.022045e23")]
    @test status == :ok
    @test startswith(Automa.machine2dot(machine), "digraph")

    notmach(re) = Automa.machine2dot(Automa.compile(re)) != Automa.machine2dot(Automa.compile(re))
    @test count(_->notmach(numbers), 1:15) == 0
end
end

module TestTokenizer
using Test
@testset "MiniJulia" begin
    include("../example/tokenizer.jl")
    @test tokens[1:14] == [
        ("quicksort", Tokens.identifier),
        ("(", Tokens.lparen),
        ("xs", Tokens.identifier),
        (")", Tokens.rparen),
        (" ", Tokens.spaces),
        ("=", Tokens.equal),
        (" ", Tokens.spaces),
        ("quicksort!", Tokens.identifier),
        ("(", Tokens.lparen),
        ("copy", Tokens.identifier),
        ("(", Tokens.lparen),
        ("xs", Tokens.identifier),
        (")", Tokens.rparen),
        (")", Tokens.rparen)]
    @test tokens[end-5:end] == [
        ("return", Tokens.keyword),
        (" ", Tokens.spaces),
        ("j", Tokens.identifier),
        ("\n", Tokens.newline),
        ("end", Tokens.keyword),
        ("\n", Tokens.newline)]
end
end

module TestStream

using Automa
using TranscodingStreams
using Test

# Test 1
machine = let
    line = re"[^\r\n]*"
    newline = re"\r?\n"
    Automa.compile(line * newline)
end
generate_reader(:readline, machine; errorcode=:(return cs)) |> eval
@testset "Scanning a line" begin
    for (data, state) in [
            ("\n",      :ok),
            ("foo\n",   :ok),
            ("foo\r\n", :ok),
            ("",        :incomplete),
            ("\r",      :incomplete),
            ("foo",     :incomplete),
            ("\r\r",    :error),
            ("\r\nx",   :error),
            ("foo\nx",  :error),]
        s = readline(NoopStream(IOBuffer(data)))
        if state == :ok
            @test s == 0
        elseif state == :incomplete
            @test s > 0
        else
            @test s < 0
        end
    end
end

# Test 2
machine = let
    alphanum = re"[A-Za-z0-9]+"
    onenter!(alphanum, :start_alphanum)
    onexit!(alphanum, :end_alphanum)
    whitespace = re"[ \t\r\n\f]*"
    Automa.compile(whitespace * alphanum * whitespace)
end
actions = Dict(
   :start_alphanum => :(@mark; start_alphanum = @relpos(p)),
   :end_alphanum   => :(end_alphanum = @relpos(p-1)),
)
initcode = :(start_alphanum = end_alphanum = 0)
returncode = :(return cs == 0 ? String(data[@abspos(start_alphanum):@abspos(end_alphanum)]) : "")
generate_reader(
    :stripwhitespace,
    machine,
    actions=actions,
    initcode=initcode,
    returncode=returncode,
    errorcode=:(return "")
) |> eval

@testset "Stripping whitespace" begin
    for (data, value) in [
            ("x", "x"),
            (" foo ", "foo"),
            ("  \r\n123\n  ", "123"),
            ("   abc123   ", "abc123"),
            ("", ""),
            ("  12+3 ", ""),
           ]
        for bufsize in [1:5; 100]
            @test stripwhitespace(NoopStream(IOBuffer(data), bufsize=bufsize)) == value
        end
    end
end

@testset "Incorrect action names" begin
    machine = let
        a = re"abc"
        onenter!(a, [:foo, :bar])
        b = re"bcd"
        onall!(b, :qux)
        precond!(b, :froom)
        c = re"x*"
        onexit!(c, Symbol[])
        Automa.compile(Automa.RegExp.cat(c, a | b))
    end
    ctx = Automa.CodeGenContext(generator=:goto)
    actions = Dict(
        :foo => quote nothing end,
        :bar => quote nothing end,
        :qux => quote nothing end,
        :froom => quote 1 == 1.0 end
    )

    # Just test whether it throws or not
    @test Automa.generate_exec_code(ctx, machine, nothing) isa Any
    @test Automa.generate_exec_code(ctx, machine, :debug) isa Any
    @test Automa.generate_exec_code(ctx, machine, actions) isa Any
    @test_throws Exception Automa.generate_exec_code(ctx, machine, Dict{Symbol, Expr}())
    delete!(actions, :froom)
    @test_throws Exception Automa.generate_exec_code(ctx, machine, actions)
    actions[:froom] = quote nothing end
    actions[:missing_symbol] = quote nothing end
    @test_throws Exception Automa.generate_exec_code(ctx, machine, actions)
    @test Automa.generate_exec_code(ctx, machine, :debug) isa Any
end

@testset "Invalid actions keys" begin
    @test_throws Exception let
        a = re"abc"
        Automa.RegExp.actions!(a)[:badkey] = [:foo]
        Automa.compile(a)
    end

    @test let
        a = re"abc"
        Automa.RegExp.actions!(a)[:enter] = [:foo]
        Automa.compile(a)
    end isa Any
end

# Three-column BED file format.
cat = Automa.RegExp.cat
rep = Automa.RegExp.rep
machine = let
    chrom = re"[^\t]+"
    onexit!(chrom, :chrom)
    chromstart = re"[0-9]+"
    onexit!(chromstart, :chromstart)
    chromend = re"[0-9]+"
    onexit!(chromend, :chromend)
    record = cat(chrom, '\t', chromstart, '\t', chromend)
    onenter!(record, :mark)
    bed = rep(cat(record, re"\r?\n"))
    Automa.compile(bed)
end
#write("bed.dot", Automa.machine2dot(machine))
#run(`dot -Tsvg -o bed.svg bed.dot`)
actions = Dict(
    :mark => :(@mark; mark = @relpos(p)),
    :chrom => :(chrom = @relpos(p-1)),
    :chromstart => :(chromstart = @relpos(p-1)),
    :chromend => :(chromend = @relpos(p-1); found = true; @escape)
)
initcode = :(cs = state; mark = chrom = chromstart = chromend = 0; found = false)
loopcode = :(found && @goto __return__)
returncode = quote
    if found
        return (
            String(data[@abspos(mark):@abspos(chrom)]),
            parse(Int, String(data[@abspos(chrom)+2:@abspos(chromstart)])),
            parse(Int, String(data[@abspos(chromstart)+2:@abspos(chromend)]))),
            cs
    else
        return ("", -1, 0), cs
    end
end
generate_reader(:readrecord!, machine, arguments=(:(state::Int),), actions=actions, initcode=initcode, loopcode=loopcode, returncode=returncode) |> eval
ctx = Automa.CodeGenContext(
    vars=Automa.Variables(:pointerindex, :p_ending, :p_fileend, :current_state, :buffer, gensym(), gensym(), :ts_buffer),
    generator=:goto,
)
generate_reader(:readrecord2!, machine, context=ctx, arguments=(:(state::Int),), actions=actions, initcode=initcode, loopcode=loopcode, returncode=returncode) |> eval

@testset "Three-column BED (stateful)" begin
    for reader in (readrecord!, readrecord2!)
        stream = NoopStream(IOBuffer("""chr1\t10\t200\n"""))
        state = 1
        val, state = readrecord!(stream, state)
        @test val == ("chr1", 10, 200)
        val, state = readrecord!(stream, state)
        @test val == ("", -1, 0)
        @test state == 0
        stream = NoopStream(IOBuffer("""1\t10\t200000\nchr12\t0\t21000\r\nchrM\t123\t12345\n"""))
        state = 1
        val, state = readrecord!(stream, state)
        @test val == ("1", 10, 200000)
        val, state = readrecord!(stream, state)
        @test val == ("chr12", 0, 21000)
        val, state = readrecord!(stream, state)
        @test val == ("chrM", 123, 12345)
        val, state = readrecord!(stream, state)
        @test val == ("", -1, 0)
        @test state == 0
    end
end

# FASTA
mutable struct Record
    data::Vector{UInt8}
    identifier::UnitRange{Int}
    description::UnitRange{Int}
    sequence::UnitRange{Int}
end

function Record()
    return Record(UInt8[], 1:0, 1:0, 1:0)
end

function initialize!(record::Record)
    empty!(record.data)
    record.identifier = record.description = record.sequence = 1:0
    return record
end

machine = let re = Automa.RegExp
    newline = re"\r?\n"

    identifier = re"[!-~]*"
    onenter!(identifier, :pos)
    onexit!(identifier, :identifier)

    description = re"[!-~][ -~]*"
    onenter!(description, :pos)
    onexit!(description, :description)

    header = re.cat('>', identifier, re.opt(re" " * description))
    onexit!(header, :header)

    letters = re"[A-Za-z*-]*"
    onenter!(letters, [:mark, :pos])
    onexit!(letters, :letters)

    sequence = re.cat(letters, re.rep(newline * letters))

    record = re.cat(header, newline, sequence)
    onenter!(record, :mark)
    onexit!(record, :record)

    fasta = re.rep(record)

    Automa.compile(fasta)
end

actions = Dict(
    :mark => :(@mark),
    :pos => :(pos = @relpos(p)),
    :identifier => :(record.identifier = pos:@relpos(p-1)),
    :description => :(record.description = pos:@relpos(p-1)),
    :header => :(append!(record.data, data[@markpos():p-1]); push!(record.data, UInt8('\n'))),
    :letters => quote
        if isempty(record.sequence)
            record.sequence = length(record.data)+1:length(record.data)
        end
        record.sequence = first(record.sequence):last(record.sequence)+p-@abspos(pos)
        append!(record.data, data[@abspos(pos):p-1])
    end,
    :record => quote
        found = true
        @escape
    end
)
initcode = quote
    cs = state
    pos = 0
    found = false
    initialize!(record)
end
loopcode = quote
    found && @goto __return__
end
context = Automa.CodeGenContext(generator=:goto)
generate_reader(
    :readrecord!,
    machine,
    arguments=(:(state::Int), :(record::$(Record)),),
    actions=actions,
    context=context,
    initcode=initcode,
    loopcode=loopcode,
) |> eval

@testset "Streaming FASTA" begin
    stream = NoopStream(IOBuffer(""))
    state = 1
    record = Record()
    @test readrecord!(stream, state, record) == 0

    stream = NoopStream(IOBuffer("""
    >seq1 hogehoge
    ACGT
    TGCA
    """), bufsize=10)
    state = 1
    record = Record()
    @test readrecord!(stream, state, record) == 0
    @test String(record.data[record.identifier]) == "seq1"
    @test String(record.data[record.description]) == "hogehoge"
    @test String(record.data[record.sequence]) == "ACGTTGCA"

    stream = NoopStream(IOBuffer("""
    >seq1 1st sequence
    NANANANA
    >seq2 2nd sequence
    -----AAA
    GGGGG---
    """), bufsize=10)
    state = 1
    record = Record()
    state = readrecord!(stream, state, record)
    @test state > 0
    @test String(record.data[record.identifier]) == "seq1"
    @test String(record.data[record.description]) == "1st sequence"
    @test String(record.data[record.sequence]) == "NANANANA"
    state = readrecord!(stream, state, record)
    @test state == 0
    @test String(record.data[record.identifier]) == "seq2"
    @test String(record.data[record.description]) == "2nd sequence"
    @test String(record.data[record.sequence]) == "-----AAAGGGGG---"

    stream = NoopStream(IOBuffer("""
    >seq1 1st sequence

    N
    ANANANA
    >seq2 2nd sequence
    -----AAA

    GGGG

    G---


    """), bufsize=10)
    state = 1
    record = Record()
    state = readrecord!(stream, state, record)
    @test state > 0
    @test String(record.data[record.identifier]) == "seq1"
    @test String(record.data[record.description]) == "1st sequence"
    @test String(record.data[record.sequence]) == "NANANANA"
    state = readrecord!(stream, state, record)
    @test state == 0
    @test String(record.data[record.identifier]) == "seq2"
    @test String(record.data[record.description]) == "2nd sequence"
    @test String(record.data[record.sequence]) == "-----AAAGGGGG---"
end

end

using Automa
using Automa.RegExp: @re_str
const re = Automa.RegExp

ab = re"ab*"
ab.when = :cond
c = re"c"
pattern = re.cat(ab, c)

write("preconditions.dot", Automa.machine2dot(Automa.compile(pattern)))
run(`dot -Tpng -o src/figure/preconditions.png preconditions.dot`)

# Regular Expression
# ==================

module RegExp

using Automa: ByteSet

# Head: What kind of regex, like cat, or rep, or opt etc.
# args: the content of the regex itself. Maybe should be type stable?
# actions: Julia code to be executed when matching the regex. See Automa docs
# when: a Precondition that is checked when every byte in the regex is matched.
# See comments on Precondition struct
"""
    RE(s::AbstractString)

Automa regular expression (regex) that is used to match a sequence of input bytes.
Regex should preferentially be constructed using the `@re_str` macro: `re"ab+c?"`.
Regex can be combined with other regex, strings or chars with `*`, `|`, `&` and `\\`:
* `a * b` matches inputs that matches first `a`, then `b`
* `a | b` matches inputs that matches `a` or `b`
* `a & b` matches inputs that matches `a` and `b`
* `a \\ b` matches input that mathes `a` but not `b`
* `!a` matches all inputs that does not match `a`.

Set actions to regex with [`onenter!`](@ref), [`onexit!`](@ref), [`onall!`](@ref)
and [`onfinal!`](@ref), and preconditions with [`precond!`](@ref).

# Example
```julia
julia> regex = (re"a*b?" | opt('c')) * re"[a-z]+";

julia> regex = rep1((regex \\ "aba") & !re"ca");

julia> regex isa RE
true

julia> compile(regex) isa Automa.Machine
true
```

See also: [`@re_str`](@ref), [`compile`](@ref Main.Automa.compile)
"""
mutable struct RE
    head::Symbol
    args::Vector
    actions::Union{Nothing, Dict{Symbol, Vector{Symbol}}}
    precond_all::Union{Tuple{Symbol, Bool}, Nothing}
    precond_enter::Union{Tuple{Symbol, Bool}, Nothing}
end

function RE(head::Symbol, args::Vector)
    return RE(head, args, nothing, nothing, nothing)
end

RE(s::AbstractString) = parse(string(s))
RE(c::AbstractChar) = primitive(Char(c))

function actions!(re::RE)
    x = re.actions
    if x === nothing
        x = Dict{Symbol, Vector{Symbol}}()
        re.actions = x
    end
    x
end

"""
    onenter!(re::RE, a::Union{Symbol, Vector{Symbol}}) -> re

Set action(s) `a` to occur when reading the first byte of regex `re`.
If multiple actions are set by passing a vector, execute the actions in order.

See also: [`onexit!`](@ref), [`onall!`](@ref), [`onfinal!`](@ref)

# Example
```julia
julia> regex = re"ab?c*";

julia> regex2 = onenter!(regex, :entering_regex);

julia> regex === regex2
true
```
"""
onenter!(re::RE, v::Vector{Symbol}) = (actions!(re)[:enter] = v; re)
onenter!(re::RE, s::Symbol) = onenter!(re, [s])

"""
    onexit!(re::RE, a::Union{Symbol, Vector{Symbol}}) -> re

Set action(s) `a` to occur when reading the first byte no longer part of regex
`re`, or if experiencing an expected end-of-file.
If multiple actions are set by passing a vector, execute the actions in order.

See also: [`onenter!`](@ref), [`onall!`](@ref), [`onfinal!`](@ref)

# Example
```julia
julia> regex = re"ab?c*";

julia> regex2 = onexit!(regex, :exiting_regex);

julia> regex === regex2
true
```
"""
onexit!(re::RE, v::Vector{Symbol}) = (actions!(re)[:exit] = v; re)
onexit!(re::RE, s::Symbol) = onexit!(re, [s])

"""
    onfinal!(re::RE, a::Union{Symbol, Vector{Symbol}}) -> re

Set action(s) `a` to occur when the last byte of regex `re`.
If `re` does not have a definite final byte, e.g. `re"a(bc)*"`, where more "bc"
can always be added, compiling the regex will error after setting a final action.
If multiple actions are set by passing a vector, execute the actions in order.

See also: [`onenter!`](@ref), [`onall!`](@ref), [`onexit!`](@ref)

# Example
```julia
julia> regex = re"ab?c";

julia> regex2 = onfinal!(regex, :entering_last_byte);

julia> regex === regex2
true

julia> compile(onfinal!(re"ab?c*", :does_not_work))
ERROR: [...]
```
"""
onfinal!(re::RE, v::Vector{Symbol}) = (actions!(re)[:final] = v; re)
onfinal!(re::RE, s::Symbol) = onfinal!(re, [s])

"""
    onall!(re::RE, a::Union{Symbol, Vector{Symbol}}) -> re

Set action(s) `a` to occur when reading any byte part of the regex `re`.
If multiple actions are set by passing a vector, execute the actions in order.

See also: [`onenter!`](@ref), [`onexit!`](@ref), [`onfinal!`](@ref)

# Example
```julia
julia> regex = re"ab?c*";

julia> regex2 = onall!(regex, :reading_re_byte);

julia> regex === regex2
true
```
"""
onall!(re::RE, v::Vector{Symbol}) = (actions!(re)[:all] = v; re)
onall!(re::RE, s::Symbol) = onall!(re, [s])

"""
    precond!(re::RE, s::Symbol; [when=:enter], [bool=true]) -> re

Set `re`'s precondition to `s`. Before any state transitions to `re`, or inside
`re`, the precondition code `s` is checked to be `bool` before the transition is taken.

`when` controls if the condition is checked when the regex is entered (if `:enter`),
or at every state transition inside the regex (if `:all`)

# Example
```julia
julia> regex = re"ab?c*";

julia> regex2 = precond!(regex, :some_condition);

julia> regex === regex2
true
```
"""
function precond!(re::RE, s::Symbol; when::Symbol=:enter, bool::Bool=true)
    if when === :enter
        re.precond_enter = (s, bool)
    elseif when === :all
        re.precond_all = (s, bool)
    else
        error("`precond!` only takes :enter or :all in third position")
    end
    re
end

const Primitive = Union{RE, ByteSet, UInt8, UnitRange{UInt8}, Char, String, Vector{UInt8}}

function primitive(re::RE)
    return re
end

function primitive(set::ByteSet)
    return RE(:set, [set])
end

function primitive(byte::UInt8)
    return RE(:byte, [byte])
end

function primitive(range::UnitRange{UInt8})
    return RE(:range, [range])
end

function primitive(char::Char)
    return RE(:char, [char])
end

function primitive(str::String)
    return RE(:str, [str])
end

function primitive(bs::AbstractVector{UInt8})
    return RE(:bytes, collect(bs))
end

function cat(xs::Primitive...)
    return RE(:cat, [map(primitive, xs)...])
end

function alt(x::Primitive, xs::Primitive...)
    return RE(:alt, [primitive(x), map(primitive, xs)...])
end

function rep(x::Primitive)
    return RE(:rep, [primitive(x)])
end

function rep1(x::Primitive)
    return RE(:rep1, [primitive(x)])
end

function opt(x::Primitive)
    return RE(:opt, [primitive(x)])
end

function isec(x::Primitive, y::Primitive)
    return RE(:isec, [primitive(x), primitive(y)])
end

function diff(x::Primitive, y::Primitive)
    return RE(:diff, [primitive(x), primitive(y)])
end

function neg(x::Primitive)
    return RE(:neg, [primitive(x)])
end

function any()
    return primitive(0x00:0xff)
end

function ascii()
    return primitive(0x00:0x7f)
end

function space()
    return primitive(ByteSet([UInt8(c) for c in "\t\v\f\n\r "]))
end

Base.:*(re1::RE, re2::RE) = cat(re1, re2)
Base.:|(re1::RE, re2::RE) = alt(re1, re2)
Base.:&(re1::RE, re2::RE) = isec(re1, re2)
Base.:\(re1::RE, re2::RE) = diff(re1, re2)

for f in (:*, :|, :&, :\)
    @eval Base.$(f)(x::Union{AbstractString, AbstractChar}, re::RE) = $(f)(RE(x), re)
    @eval Base.$(f)(re::RE, x::Union{AbstractString, AbstractChar}) = $(f)(re, RE(x)) 
end

Base.:!(re::RE) = neg(re)

"""
    @re_str -> RE

Construct an Automa regex of type `RE` from a string.
Note that due to Julia's raw string escaping rules, `re"\\\\"` means a single backslash, and so does `re"\\\\\\\\"`, while `re"\\\\\\\\\\""` means a backslash, then a quote character.

Examples:
```julia
julia> re"ab?c*[def][^ghi]+" isa RE
true 
```

See also: [`RE`](@ref)
"""
macro re_str(str::String)
    parse(str)
end

const METACHAR = raw".*+?()[]\|-^"

# Parse a regular expression string using the shunting-yard algorithm.
function parse(str_::AbstractString)
    str = String(str_)
    # stacks
    operands = RE[]
    operators = Symbol[]

    function pop_and_apply!()
        op = pop!(operators)
        if op == :rep || op == :rep1 || op == :opt
            arg = pop!(operands)
            push!(operands, RE(op, [arg]))
        elseif op == :alt
            arg2 = pop!(operands)
            arg1 = pop!(operands)
            push!(operands, RE(:alt, [arg1, arg2]))
        elseif op == :cat
            arg2 = pop!(operands)
            arg1 = pop!(operands)
            push!(operands, RE(:cat, [arg1, arg2]))
        else
            error(op)
        end
    end

    cs = iterate(str)
    if cs === nothing
        return RE(:cat, [])
    end
    need_cat = false
    while cs !== nothing
        c, s = cs
        # @show c operands operators
        if need_cat && c ∉ ('*', '+', '?', '|', ')')
            while !isempty(operators) && prec(:cat) ≤ prec(last(operators))
                pop_and_apply!()
            end
            push!(operators, :cat)
        end
        need_cat = c ∉ ('|', '(')
        if c == '*'
            while !isempty(operators) && prec(:rep) ≤ prec(last(operators))
                pop_and_apply!()
            end
            push!(operators, :rep)
        elseif c == '+'
            while !isempty(operators) && prec(:rep1) ≤ prec(last(operators))
                pop_and_apply!()
            end
            push!(operators, :rep1)
        elseif c == '?'
            while !isempty(operators) && prec(:opt) ≤ prec(last(operators))
                pop_and_apply!()
            end
            push!(operators, :opt)
        elseif c == '|'
            while !isempty(operators) && prec(:alt) ≤ prec(last(operators))
                pop_and_apply!()
            end
            push!(operators, :alt)
        elseif c == '('
            push!(operators, :lparen)
        elseif c == ')'
            while !isempty(operators) && last(operators) != :lparen
                pop_and_apply!()
            end
            pop!(operators)
        elseif c == '['
            class, cs = parse_class(str, s)
            push!(operands, class)
            continue
        elseif c == '.'
            push!(operands, any())
        elseif c == '\\'
            if iterate(str, s) === nothing
                c = '\\'
            else
                c, s = unescape(str, s)
            end
            push!(operands, primitive(c))
        else
            push!(operands, primitive(c))
        end
        cs = iterate(str, s)
    end

    while !isempty(operators)
        pop_and_apply!()
    end

    @assert length(operands) == 1
    return first(operands)
end

# Operator's precedence.
function prec(op::Symbol)
    if op == :rep || op == :rep1 || op == :opt
        return 3
    elseif op == :cat
        return 2
    elseif op == :alt
        return 1
    elseif op == :lparen
        return 0
    else
        @assert false
    end
end

# Convert this to ASCII byte.
# Also accepts e.g. '\xff', but not a multi-byte Char
function as_byte(c::Char)
    u = reinterpret(UInt32, c)
    if u & 0x00ffffff != 0
        error("Char '$c' cannot be expressed as a single byte")
    else
        UInt8(u >> 24)
    end
end

# This parses things in square brackets, like [A-Za-z]
# When this function is entered, the initial '[' has already been
# consumed.
function parse_class(str, s)
    # The bool here is whether it's escaped
    chars = Tuple{Bool, Char}[]
    cs = iterate(str, s)
    # Main loop: Get all the characters into the `chars` variable
    while cs !== nothing
        c, s = cs
        if c == ']'
            # We are done with the class. Skip the ] char and break out.
            cs = iterate(str, s)
            break
        # Handle escape character
        elseif c == '\\'
            # If \ is the final char, throw error
            if iterate(str, s) === nothing
                error("missing ]")
            end
            # Else get the next char as escaped
            c, s = unescape(str, s)
            push!(chars, (true, c))
        else
            # Ordinary char: Just add it unescaped
            push!(chars, (false, c))
        end
        cs = iterate(str, s)
    end
    # If the first char is non-escaped ^, set head as cclass, meaning
    # inverted class, and remove the first char.
    if !isempty(chars) && !first(chars)[1] && first(chars)[2] == '^'
        head = :cclass
        popfirst!(chars)
    else
        head = :class
    end
    if isempty(chars)
        error("empty class")
    end

    args = []
    while !isempty(chars)
        c = popfirst!(chars)[2]
        # If the next two chars are "-X" for any X, then this is a range.
        # Create the right range and pop out the "-X"
        if length(chars) ≥ 2 && first(chars) == (false, '-')
            push!(args, as_byte(c):as_byte(chars[2][2]))
            popfirst!(chars)
            popfirst!(chars)
        else
            push!(args, as_byte(c):as_byte(c))
        end
    end
    return RE(head, args), cs
end

function unescape(str::String, s::Int)
    invalid() = throw(ArgumentError("invalid escape sequence"))
    ishex(b) = '0' ≤ b ≤ '9' || 'A' ≤ b ≤ 'F' || 'a' ≤ b ≤ 'f'
    cs = iterate(str, s)
    cs === nothing && invalid()
    c, s = cs
    if c == 'a'
        return '\a', s
    elseif c == 'b'
        return '\b', s
    elseif c == 't'
        return '\t', s
    elseif c == 'n'
        return '\n', s
    elseif c == 'v'
        return '\v', s
    elseif c == 'r'
        return '\r', s
    elseif c == 'f'
        return '\f', s
    elseif c == '0'
        return '\0', s
    elseif c ∈ METACHAR
        return c, s
    elseif c == 'x'
        cs1 = iterate(str, s)
        (cs1 === nothing || !ishex(cs1[1])) && invalid()
        cs2 = iterate(str, cs1[2])
        (cs2 === nothing || !ishex(cs2[1])) && invalid()
        c1, c2 = cs1[1], cs2[1]
        return first(unescape_string("\\x$(c1)$(c2)")), cs2[2]
    elseif c == 'u' || c == 'U'
        throw(ArgumentError("escaped Unicode sequence is not supported"))
    else
        throw(ArgumentError("invalid escape sequence: \\$(c)"))
    end
end

# This converts from compound regex to foundational regex.
# For example, rep1(x) is equivalent to x * rep(x).
function shallow_desugar(re::RE)
    head = re.head
    args = re.args
    if head == :rep1
        return RE(:cat, [args[1], rep(args[1])])
    elseif head == :opt
        return RE(:alt, [args[1], RE(:cat, [])])
    elseif head == :neg
        return RE(:diff, [rep(any()), args[1]])
    elseif head == :byte
        return RE(:set, [ByteSet(args[1])])
    elseif head == :range
        return RE(:set, [ByteSet(args[1])])
    elseif head == :class
        return RE(:set, [foldl(union, map(ByteSet, args), init=ByteSet())])
    elseif head == :cclass
        return RE(:set, [foldl(setdiff, map(ByteSet, args), init=ByteSet(0x00:0xff))])
    elseif head == :char
        bytes = convert(Vector{UInt8}, codeunits(string(args[1])))
        return RE(:cat, [RE(:set, [ByteSet(b)]) for b in bytes])
    elseif head == :str
        bytes = convert(Vector{UInt8}, codeunits(args[1]))
        return RE(:cat, [RE(:set, [ByteSet(b)]) for b in bytes])
    elseif head == :bytes
        return RE(:cat, [RE(:set, [ByteSet(b)]) for b in args])
    else
        if head ∉ (:set, :cat, :alt, :rep, :isec, :diff)
            error("cannot desugar ':$(head)'")
        end
        return RE(head, args)
    end
end

# Create a deep copy of the regex without any actions
function strip_actions(re::RE)
    args = [arg isa RE ? strip_actions(arg) : arg for arg in re.args]
    RE(re.head, args, Dict{Symbol, Vector{Symbol}}(), re.precond_enter, re.precond_all)
end

# Create a deep copy with the only actions being a :newline action
# on the \n chars
function set_newline_actions(re::RE)::RE
    # Normalise the regex first to make it simpler to work with
    if re.head ∈ (:rep1, :opt, :neg, :byte, :range, :class, :cclass, :char, :str, :bytes)
        re = shallow_desugar(re)
    end
    # After desugaring, the only type of regex that can directly contain a newline is the :set type
    # if it has that, we add a :newline action
    if re.head == :set
        set = only(re.args)::ByteSet
        if UInt8('\n') ∈ set
            re1 = RE(:set, [ByteSet(UInt8('\n'))], Dict(:enter => [:newline]), re.precond_enter, re.precond_all)
            if length(set) == 1
                re1
            else
                re2 = RE(:set, [setdiff(set, ByteSet(UInt8('\n')))], Dict{Symbol, Vector{Symbol}}(), re.precond_enter, re.precond_all)
                re1 | re2
            end
        else
            re
        end
    else
        args = [arg isa RE ? set_newline_actions(arg) : arg for arg in re.args]
        RE(re.head, args, Dict{Symbol, Vector{Symbol}}(), re.precond_enter, re.precond_all)
    end
end


end

module Test14

using Automa
using Test

@testset "Test14" begin
    a = re"a*"
    machine = compile(a)

    ctx = CodeGenContext(generator=:table)
    @eval function validate_table(data)
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine))
        return p, cs
    end

    ctx = CodeGenContext(generator=:goto)
    @eval function validate_goto(data)
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine))
        return p, cs
    end

    @test validate_table(b"")   == validate_goto(b"")
    @test validate_table(b"a")  == validate_goto(b"a")
    @test validate_table(b"b")  == validate_goto(b"b")
    @test validate_table(b"ab") == validate_goto(b"ab")
end

end

"""
    Tokenizer{E, D, C}

Lazy iterator of tokens of type `E` over data of type `D`.
Tokenizers are usually created with the [`tokenize`](@ref) function, and their iterator behaviour
are defined by [`make_tokenizer`](@ref).

`Tokenizer` works on any buffer-like object that defines `pointer` and `sizeof`.
When iterated, it will return a `Tuple{Integer, Integer, E}`:

  * The first value in the tuple is the 1-based starting index of the token in the buffer
  * The second is the length of the token in bytes
  * The third is the token.

Un-tokenizable data will be emitted as the "error token" which must also be of type `E`.

The `Int` parameter `C` allows multiple tokenizers to be created with
the otherwise same type parameters.

See also: [`make_tokenizer`](@ref)
"""
struct Tokenizer{E,D,C}
    data::D
end

# By default, the counter C is 1
Tokenizer{E}(data) where {E} = Tokenizer{E,typeof(data),1}(data)
Base.IteratorSize(::Type{Tokenizer{E,D,C}}) where {E,D,C} = Base.SizeUnknown()
Base.eltype(::Type{Tokenizer{E,D,C}}) where {E,D,C} = Tuple{Int,Int32,E}

"""
    tokenize(::Type{E}, data, version=1) -> Tokenizer

Create a `Tokenizer{E, typeof(data), version}`, iterating tokens of type `E`
over `data`.

See also: [`Tokenizer`](@ref), [`make_tokenizer`](@ref), [`compile`](@ref)

# Examples
```jldoctest
julia> tokenize(UInt32, "hello")
Tokenizer{UInt32, String, 1}("hello")

julia> tokenize(Int8, [1, 2, 3], 3)
Tokenizer{Int8, Vector{Int64}, 3}([1, 2, 3])
```
"""
tokenize(::Type{E}, data, version=1) where {E} = Tokenizer{E,typeof(data),version}(data)

"""
    TokenizerMachine

Struct representing a `Machine` created for tokenization.
Machines used for tokenization contain distinct actions and are not to be used for notmal Automa codegen.
`TokenizerMachine`s contain two public fields: `machine::Machine` and `n_tokens::Int`.

You can manually create `TokenizerMachine`s with `compile(::Vector{RE})`, or more conveniently
with [`make_tokenizer`](@ref).
"""
struct TokenizerMachine
    machine::Machine
    n_tokens::Int
end

# Currently, actions are added to final byte. This usually inhibits SIMD,
# because the end position must be updated every byte.
# It would be faster to add actions to :exit, but then the action will not actually
# trigger when a regex is exited with an "invalid byte" - the beginning of a new regex.
# I'm not quite sure how to handle this.
"""
    make_tokenizer(
        machine::TokenizerMachine;
        tokens::Tuple{E, AbstractVector{E}}= [ integers ],
        goto=true, version=1
    ) where E

Create code which when evaluated, defines `Base.iterate(::Tokenizer{E, D, \$version})`.
`tokens` is a tuple of:

* the error token, which will be emitted for data that cannot be tokenized, and
* a vector of non-error tokens of length `machine.n_tokens`.

Most users should instead use the more convenient method `make_tokenizer(tokens)`.

# Example usage
```jldoctest
julia> machine = compile([re"a", re"b"]);

julia> make_tokenizer(machine; tokens=(0x00, [0x01, 0x02])) |> eval

julia> iter = tokenize(UInt8, "abxxxba"); typeof(iter)
Tokenizer{UInt8, String, 1}

julia> collect(iter)
5-element Vector{Tuple{Int64, Int32, UInt8}}:
 (1, 1, 0x01)
 (2, 1, 0x02)
 (3, 3, 0x00)
 (6, 1, 0x02)
 (7, 1, 0x01)
```

Any actions inside the input regexes will be ignored.

If `goto` (default), use the faster, but more complex goto code generator.\\
The `version` number will set the last parameter of the `Tokenizer`,
which allows you to create different tokenizers for the same element type.

See also: [`Tokenizer`](@ref), [`tokenize`](@ref), [`compile`](@ref)
"""
function make_tokenizer(
    machine::TokenizerMachine;
    tokens::Tuple{E,AbstractVector{E}}=(UInt32(0), UInt32(1):UInt32(machine.n_tokens)),
    goto::Bool=true,
    version::Int=1
) where {E}
    (error_token, nonerror_tokens) = tokens
    # Check that tokens are unique
    if length(nonerror_tokens) != machine.n_tokens
        error("Tokenizer has $(machine.n_actions) actions, but only got $(length(nonerror_tokens)) tokens")
    end
    if length(push!(Set(nonerror_tokens), error_token)) != length(nonerror_tokens) + 1
        error("Tokens and nonerror tokens must be unique")
    end
    ctx = if goto
        Automa.CodeGenContext(generator=:goto)
    else
        Automa.DefaultCodeGenContext
    end
    vars = ctx.vars
    # In these actions, store enter token and exit token.
    actions = Dict{Symbol,Expr}()
    for action_name in action_names(machine.machine)
        # The action for every token's final byte is to say: "This is where the token ends, and this is
        # what kind it is"
        m = match(r"^__token_(\d+)$", String(action_name))
        m === nothing && error(
            "Action $action_name found in Machine passed to `make_tokenizer`. ",
            "`make_tokenizer` only supports machines generated by `compile(::Vector{RE})`."
        )
        actions[action_name] = quote
            stop = $(vars.p)
            token = $(nonerror_tokens[parse(Int, something(only(m.captures)))])
        end
    end
    return quote
        function Base.iterate(tokenizer::$(Tokenizer){$E,D,$version}, state=(1, Int32(1), $error_token)) where {D}
            data = tokenizer.data
            (start, len, token) = state
            start > sizeof(data) && return nothing
            if token !== $error_token
                return (state, (start + len, Int32(0), $error_token))
            end
            $(generate_init_code(ctx, machine.machine))
            token_start = start
            stop = 0
            token = $error_token
            while true
                $(vars.p) = token_start
                # Every time we try to find a token, we reset the machine's state to 1, i.e. we carry
                # no memory between each token.
                $(vars.cs) = 1
                $(generate_exec_code(ctx, machine.machine, actions))
                $(vars.cs) = 1

                # There are only a few possibilities for why it stopped execution, we handle
                # each of them here.
                # If a token was found:
                if token !== $error_token
                    found_token = (token_start, (stop - token_start + 1) % Int32, token)
                    # If a token was found, but there are some error data, we emit the error data first,
                    # then set the state to be nonzero so the token is emitted next iteration
                    if start < token_start
                        error_state = (start, (token_start - start) % Int32, $error_token)
                        return (error_state, found_token)
                        # If no error data, simply emit the token with a zero state
                    else
                        return (found_token, (stop + 1, Int32(0), $error_token))
                    end
                else
                    # If no token was found and EOF, emit an error token for the rest of the data
                    if $(vars.p) > $(vars.p_end)
                        error_state = (start, ($(vars.p) - start) % Int32, $error_token)
                        return (error_state, ($(vars.p_end) + 1, Int32(0), $error_token))
                        # If no token, and also not EOF, we continue, looking at next byte
                    else
                        token_start += 1
                    end
                end
            end
        end
    end
end

"""
    make_tokenizer(
        tokens::Union{
            AbstractVector{RE},
            Tuple{E, AbstractVector{Pair{E, RE}}}
        };
        goto::Bool=true,
        version::Int=1,
        unambiguous=false
    ) where E

Convenience function for both compiling a `TokenizerMachine`, then running `make_tokenizer` on it.
In other words, this function returns code that when run, defines `iterate` for
`Tokenizer{\$E, D, \$version} where D`.

If tokens are a tuple, the first element is the error token, and the next
is a vector of `token => regex` pairs.
If `tokens` is an `AbstractVector{RE}` `v`, the tokens defaults to `UInt32`, and it behaves as if
it was `(UInt32(0), [UInt32(i)=>r for (i,r) in pairs(v)])`, i.e. `UInt32(0)` is the error token.

# Example
```jldoctest
julia> make_tokenizer([re"abc", re"def"]) |> eval

julia> collect(tokenize(UInt32, "abcxyzdef123"))
4-element Vector{Tuple{Int64, Int32, UInt32}}:
 (1, 3, 0x00000001)
 (4, 3, 0x00000000)
 (7, 3, 0x00000002)
 (10, 3, 0x00000000)

julia> make_tokenizer((0, collect(pairs([re"x", re"y"]))); version=5) |> eval

julia> iter = tokenize(Int, "xyaby", 5)
Tokenizer{Int64, String, 5}("xyaby")

julia> collect(iter)
4-element Vector{Tuple{Int64, Int32, Int64}}:
 (1, 1, 1)
 (2, 1, 2)
 (3, 2, 0)
 (5, 1, 2)
```
"""
function make_tokenizer(
    tokens::Union{
        <:AbstractVector{RegExp.RE},
        <:Tuple{E,AbstractVector{Pair{E,RegExp.RE}}}
    };
    goto::Bool=true,
    version::Int=1,
    unambiguous=false
) where {E}
    (regex, _tokens) = if tokens isa AbstractVector
        (Vector(tokens)::Vector, (UInt32(0), UInt32(1):UInt32(length(tokens))))
    else
        ([last(i) for i in last(tokens)]::Vector, (first(tokens), map(first, last(tokens))))
    end
    make_tokenizer(
        compile(regex; unambiguous=unambiguous);
        tokens=_tokens,
        goto=goto,
        version=version
    )
end

"""
    compile(tokens::Vector{RE}; unambiguous=false)::TokenizerMachine

Compile the regex `tokens` to a tokenizer machine.
The machine can be passed to `make_tokenizer`.

The keyword `unambiguous` decides which of multiple matching tokens is emitted:
If `false` (default), the longest token is emitted. If multiple tokens have the
same length, the one with the highest index is returned.
If `true`, `make_tokenizer` will error if any possible input text can be broken
ambiguously down into tokens.

See also: [`Tokenizer`](@ref), [`make_tokenizer`](@ref), [`tokenize`](@ref)
"""
function compile(
    tokens::Vector{RegExp.RE};
    unambiguous=false
)::TokenizerMachine
    tokens = map(enumerate(tokens)) do (i, regex)
        onfinal!(RegExp.strip_actions(regex), Symbol(:__token_, i))
    end
    # We need the predefined actions here simply because it allows us to add priority to the actions.
    # This is necessary to guarantee that tokens are disambiguated in the correct order.
    predefined_actions = Dict{Symbol,Action}()
    for i in eachindex(tokens)
        predefined_actions[Symbol(:__token_, i)] = Action(Symbol(:__token_, i), 1000 + i)
    end
    # We intentionally set unambiguous=true. With the current construction of
    # this tokenizer, this will cause the longest token to be matched, i.e. for
    # the regex "ab" and "a", the text "ab" will emit only the "ab" regex.
    # Here, the NFA (i.e. the final regex we match) is a giant alternation statement between each of the tokens,
    # i.e. input is token1 or token2 or ....
    nfa = re2nfa(RegExp.RE(:alt, tokens), predefined_actions)
    TokenizerMachine(nfa2machine(nfa; unambiguous=unambiguous), length(tokens))
end

# A tokenizer of octal, decimal, hexadecimal and floating point numbers
# =====================================================================

using Automa

# Describe patterns in regular expression.
oct      = re"0o[0-7]+"
dec      = re"[-+]?[0-9]+"
hex      = re"0x[0-9A-Fa-f]+"
prefloat = re"[-+]?([0-9]+\.[0-9]*|[0-9]*\.[0-9]+)"
float    = prefloat | ((prefloat | re"[-+]?[0-9]+") * re"[eE][-+]?[0-9]+")
number   = oct | dec | hex | float
numbers  = opt(number) * rep(re" +" * number) * re" *"

# Register action names to regular expressions.
onenter!(number, :mark)
onexit!(oct, :oct)
onexit!(dec, :dec)
onexit!(hex, :hex)
onexit!(float, :float)

# Compile a finite-state machine.
machine = compile(numbers)

# This generates a SVG file to visualize the state machine.
# write("numbers.dot", Automa.machine2dot(machine))
# run(`dot -Tpng -o numbers.png numbers.dot`)

# Bind an action code for each action name.
actions = Dict(
    :mark  => :(mark = p),
    :oct   => :(emit(:oct)),
    :dec   => :(emit(:dec)),
    :hex   => :(emit(:hex)),
    :float => :(emit(:float)),
)

# Generate a tokenizing function from the machine.
context = CodeGenContext()
@eval function tokenize(data::String)
    tokens = Tuple{Symbol,String}[]
    mark = 0
    $(Automa.generate_init_code(context, machine))
    emit(kind) = push!(tokens, (kind, data[mark:p-1]))
    $(Automa.generate_exec_code(context, machine, actions))
    return tokens, cs == 0 ? :ok : cs < 0 ? :error : :incomplete
end

tokens, status = tokenize("1 0x0123BEEF 0o754 3.14 -1e4 +6.022045e23")

# Test codegencontext
@testset "CodeGenContext" begin
    @test_throws ArgumentError Automa.CodeGenContext(generator=:fdjfhkdj)
    @test_throws ArgumentError Automa.CodeGenContext(generator=:goto, getbyte=identity)
end

using Automa

@testset "SIMD generator" begin
    regex = let
        seq = re"[A-Z]+"
        name = re"[a-z]+"
        rec = re">"  * name * re"\n" * seq
        opt(rec) * rep(re"\n" * rec)
    end

    context = CodeGenContext(generator=:goto)

    eval(generate_buffer_validator(:is_valid_fasta, regex; goto=true))

    s1 = ">seq\nTAGGCTA\n>hello\nAJKGMP"
    s2 = ">seq1\nTAGGC"
    s3 = ">verylongsequencewherethesimdkicksinmakeitevenlongertobesure\nQ"

    for (seq, isvalid) in [(s1, true), (s2, false), (s3, true)]
        @test is_valid_fasta(seq) isa (isvalid ? Nothing : Integer)
    end
end
    

"""
    generate_reader(funcname::Symbol, machine::Automa.Machine; kwargs...)

Generate a streaming reader function of the name `funcname` from `machine`.

The generated function consumes data from a stream passed as the first argument
and executes the machine with filling the data buffer.

This function returns an expression object of the generated function.  The user
need to evaluate it in a module in which the generated function is needed.

# Keyword Arguments
- `arguments`: Additional arguments `funcname` will take (default: `()`).
    The default signature of the generated function is `(stream::TranscodingStream,)`,
    but it is possible to supply more arguments to the signature with this keyword argument.
- `context`: Automa's codegenerator (default: `Automa.CodeGenContext()`).
- `actions`: A dictionary of action code (default: `Dict{Symbol,Expr}()`).
- `initcode`: Initialization code (default: `:()`).
- `loopcode`: Loop code (default: `:()`).
- `returncode`: Return code (default: `:(return cs)`).
- `errorcode`: Executed if `cs < 0` after `loopcode` (default error message)

See the source code of this function to see how the generated code looks like
"""
function generate_reader(
        funcname::Symbol,
        machine::Machine;
        arguments=(),
        context::CodeGenContext=DefaultCodeGenContext,
        actions::Dict{Symbol,Expr}=Dict{Symbol,Expr}(),
        initcode::Expr=:(),
        loopcode::Expr=:(),
        returncode::Expr=:(return $(context.vars.cs)),
        errorcode::Expr=generate_input_error_code(context, machine)
)
    # Add a `return` to the return expression if the user forgot it
    if returncode.head != :return
        returncode = Expr(:return, returncode)
    end
    # Create the function signature
    functioncode = :(function $(funcname)(stream::$(TranscodingStream)) end)
    for arg in arguments
        push!(functioncode.args[1].args, arg)
    end
    # Expands special Automa pseudomacros. When not inside the machine execution,
    # at_eof and cs is meaningless, and when both are set to nothing, @escape
    # will error at parse time
    function rewrite(ex::Expr)
        rewrite_special_macros(;
            ctx=context,
            ex=ex,
            at_eof=nothing,
            cs=nothing
        )
    end
    vars = context.vars
    functioncode.args[2] = quote
        $(vars.buffer) = stream.state.buffer1
        $(vars.data) = $(vars.buffer).data
        $(generate_init_code(context, machine))
        $(rewrite(initcode))
        # Overwrite is_eof for Stream, since we don't know the real EOF
        # until after we've actually seen the stream eof
        $(vars.is_eof) = false

        # Code between __exec__ and the bottom is repeated in a loop,
        # in order to continuously read data, filling in new data to the buffer
        # once it runs out.
        # When the buffer is filled, data in the buffer may shift, which necessitates
        # us updating `p` and `p_end`.
        # Hence, they need to be redefined here.
        @label __exec__
        # The eof call here is what refills the buffer, if the buffer is used up,
        # eof will try refilling the buffer before returning true
        $(vars.is_eof) = eof(stream)
        $(vars.p) = $(vars.buffer).bufferpos
        $(vars.p_end) = $(vars.buffer).marginpos - 1
        $(generate_exec_code(context, machine, actions))
        
        # Advance the buffer, hence advancing the stream itself
        $(vars.buffer).bufferpos = $(vars.p)

        $(rewrite(loopcode))

        if $(vars.cs) < 0
            $(rewrite(errorcode))
        end

        # If the machine errored, or we're past the end of the stream, actually return.
        # Else, keep looping.
        if $(vars.cs) == 0 || ($(vars.is_eof) && $(vars.p) > $(vars.p_end))
            @label __return__
            $(rewrite(returncode))
        end
        @goto __exec__
    end
    return functioncode
end

"""
    generate_io_validator(funcname::Symbol, regex::RE; goto::Bool=false)

**NOTE: This method requires TranscodingStreams to be loaded**

Create code that, when evaluated, defines a function named `funcname`.
This function takes an `IO`, and checks if the data in the input conforms
to the regex, without executing any actions.
If the input conforms, return `nothing`.
Else, return `(byte, (line, col))`, where `byte` is the first invalid byte,
and `(line, col)` the 1-indexed position of that byte.
If the invalid byte is a `\\n` byte, `col` is 0 and the line number is incremented.
If the input errors due to unexpected EOF, `byte` is `nothing`, and the line and column
given is the last byte in the file.

If `goto`, the function uses the faster but more complicated `:goto` code.

See also: [`generate_buffer_validator`](@ref)
"""
function generate_io_validator(
    funcname::Symbol,
    regex::RegExp.RE;
    goto::Bool=false
    )
    ctx = if goto
        CodeGenContext(generator=:goto)
    else
        DefaultCodeGenContext
    end
    vars = ctx.vars
    returncode = quote
        return if iszero(cs)
            nothing
        else
            # The column must be cleared cols. If we're EOF, all bytes have
            # already been cleared by the buffer when attempting to get more bytes.
            # If not, we add the bytes still in the buffer to the column
            col = cleared_cols
            col += ($(vars.p) - p_newline) * !$(vars.is_eof)
            # Report position of last byte before EOF if EOF.
            error_byte = if $(vars.p) > $(vars.p_end)
                nothing
            else
                $(vars.byte)
            end
            # If errant byte was a newline, instead of counting it as last
            # byte on a line (which would be inconsistent), count it as first
            # byte on a new line
            line_num += error_byte == UInt8('\n')
            col -= error_byte == UInt8('\n')
            (error_byte, (line_num, col))
        end
    end
    initcode = quote
        # Unmark buffer in case it's been marked before hand
        @unmark()
        line_num = 1
        # Keep track of how many columns since newline that has
        # been cleared from the buffer
        cleared_cols = 0
        # p value of last newline _in the current buffer_.
        p_newline = 0
    end
    loopcode = quote
        # If we're about to clear the buffer (ran out of buffer, did not error),
        # then update cleared_cols, and since the buffer is about to be cleared,
        # remove p_newline
        if $(vars.cs) > 0 && $(vars.p) > $(vars.p_end) && !$(vars.is_eof)
            cleared_cols += $(vars.p) - p_newline - 1
            p_newline = 0
        end
    end
    machine = compile(RegExp.set_newline_actions(regex))
    actions = if :newline ∈ machine_names(machine)
        Dict{Symbol, Expr}(:newline => quote
                line_num += 1
                cleared_cols = 0
                p_newline = $(vars.p)
            end
        )
    else
        Dict{Symbol, Expr}()
    end
    function_code = generate_reader(
        funcname,
        machine;
        context=ctx,
        initcode=initcode,
        loopcode=loopcode,
        actions=actions,
        returncode=returncode,
        errorcode=:(@goto __return__),
    )
    return quote
        """
            $($(funcname))(io::IO)

        Checks if the data in `io` conforms to the given regex specified at function definition time.
        If the input conforms, return `nothing`.
        Else return `(byte, (line, col))` where `byte` is the first invalid byte,
        and `(line, col)` the 1-indexed position of that byte.
        If the invalid byte is a `\n` byte, `col` is 0.
        If the input errors due to unexpected EOF, `byte` is `nothing`, and the line and column
        given is the last byte in the file.
        """
        $function_code

        $(funcname)(io::$(IO)) = $(funcname)($(NoopStream)(io))
    end 
end

function debug_machine(machine::Automa.Machine)
    cloned_nodes = [Automa.Node(i) for i in 1:machine.n_states]
    for node in Automa.traverse(machine.start)
        for (edge, child) in node.edges
            cloned_edge = Automa.Edge(
                edge.labels,
                edge.precond,
                Automa.ActionList(copy(edge.actions.actions))
            )
            isempty(cloned_edge.actions) || @assert -1 < minimum(edge.actions.actions) do action
                action.order
            end
            push!(cloned_edge.actions, Automa.Action(:debug, -1))
            push!(cloned_nodes[node.state].edges, (cloned_edge, cloned_nodes[child.state]))
        end
    end
    Automa.Machine(
        cloned_nodes[1],
        length(cloned_nodes),
        copy(machine.final_states),
        copy(machine.eof_actions)   
    )
end

function create_debug_function(machine::Automa.Machine; ascii::Bool=false,
    ctx::Union{Automa.CodeGenContext, Nothing}=nothing
)
    ctx = ctx === nothing ? Automa.CodeGenContext() : ctx
    logsym = gensym()
    action_dict = Dict(map(collect(Automa.action_names(machine))) do name
        name => quote
            push!(last($logsym)[3], $(QuoteNode(name)))
        end
    end)
    @assert !haskey(action_dict, :debug) "Machine can't contain action :debug"
    action_dict[:debug] = quote
        push!($logsym, ($(ctx.vars.byte), $(ctx.vars.cs), Symbol[])
        )
    end
    debugger = debug_machine(machine)
    quote
        function debug_compile($(ctx.vars.data)::Union{String, Vector{UInt8}})
            $logsym = $(if ascii
                quote Tuple{Char, Int, Vector{Symbol}}[] end
            else
                quote Tuple{UInt8, Int, Vector{Symbol}}[] end
            end)
            $(Automa.generate_init_code(ctx, debugger))
            p_end = sizeof($(ctx.vars.data))
            is_eof = true
            $(Automa.generate_exec_code(ctx, debugger, action_dict))
            ($(ctx.vars.cs), $logsym)
        end
    end
end

function debug_execute(re::Automa.RegExp.RE, data::Vector{UInt8}; ascii=false)
    machine = Automa.compile(re, optimize=false)
    s = machine.start
    cs = s.state
    result = Tuple{Union{Nothing, ascii ? Char : UInt8}, Int, Vector{Symbol}}[]
    for d in data
        try
            e, s = Automa.findedge(s, d)
            cs = s.state
            push!(result, (d, cs, Automa.action_names(e.actions)))
        catch ex
            if !isa(ex, ErrorException)
                rethrow()
            end
            cs = -cs
            break
        end
    end
    if cs ∈ machine.final_states && haskey(machine.eof_actions, s.state)
        push!(result, (nothing, 0, Automa.action_names(machine.eof_actions[s.state])))
    end
    if cs > 0
        if cs ∈ machine.final_states
            cs = 0
        else
            cs = -cs
        end
    end
    return cs, result
end

function debug_execute(re::Automa.RegExp.RE, data::String; ascii=false)
    debug_execute(re, collect(codeunits(data)); ascii=ascii)
end

module Test10

using Automa
const re = Automa.RegExp
using Test

@testset "Test10" begin
    machine = compile(re.primitive(0x61))
    @test Automa.execute(machine, "a")[1] == 0
    @test Automa.execute(machine, "b")[1] < 0

    machine = compile(re.primitive(0x61:0x62))
    @test Automa.execute(machine, "a")[1] == 0
    @test Automa.execute(machine, "b")[1] == 0
    @test Automa.execute(machine, "c")[1] < 0

    machine = compile(re.primitive('a'))
    @test Automa.execute(machine, "a")[1] == 0
    @test Automa.execute(machine, "b")[1] < 0

    machine = compile(re.primitive('樹'))
    @test Automa.execute(machine, "樹")[1] == 0
    @test Automa.execute(machine, "儒")[1] < 0

    machine = compile(re.primitive("ジュリア"))
    @test Automa.execute(machine, "ジュリア")[1] == 0
    @test Automa.execute(machine, "パイソン")[1] < 0

    machine = compile(re.primitive([0x61, 0x62, 0x72]))
    @test Automa.execute(machine, "abr")[1] == 0
    @test Automa.execute(machine, "acr")[1] < 0

    machine = compile(re"[^A-Z]")
    @test Automa.execute(machine, "1")[1] == 0
    @test Automa.execute(machine, "A")[1] < 0
    @test Automa.execute(machine, "a")[1] == 0

    machine = compile(re"[A-Z]+" & re"FOO?")
    @test Automa.execute(machine, "FO")[1] == 0
    @test Automa.execute(machine, "FOO")[1] == 0
    @test Automa.execute(machine, "foo")[1] < 0

    machine = compile(re"[A-Z]+" \ re"foo")
    @test Automa.execute(machine, "FOO")[1] == 0
    @test Automa.execute(machine, "foo")[1] < 0

    machine = compile(!re"foo")
    @test Automa.execute(machine, "bar")[1] == 0
    @test Automa.execute(machine, "foo")[1] < 0

    machine = compile(re.rep("a"))
    @test Automa.execute(machine, "aaa")[1] == 0
    @test Automa.execute(machine, "aYa")[1] < 0
end

end

# Non-deterministic Finite Automaton
# ==================================

struct NFANode
    edges::Vector{Tuple{Edge,NFANode}}
end

function NFANode()
    return NFANode(Tuple{Edge,NFANode}[])
end

function Base.show(io::IO, node::NFANode)
    print(io, summary(node), "(<", length(node.edges), " edges", '@', objectid(node), ">)")
end

# An NFA contains a start and final nodes, which are not the same, as per
# the textbook definition.
# This NFA is an nfa with epsilon transitions.
struct NFA
    start::NFANode
    final::NFANode

    function NFA(start::NFANode, final::NFANode)
        @assert start !== final
        return new(start, final)
    end
end

# epsilon transition
const eps = ByteSet()

function iseps(e::Edge)
    return isempty(e.labels)
end

const ACCEPTED_KEYS = [:enter, :exit, :all, :final]

function re2nfa(re::RegExp.RE, predefined_actions::Dict{Symbol,Action}=Dict{Symbol,Action}())
    actions = Dict{Tuple{RegExp.RE,Symbol},Action}()
    action_order = 1

    function make_action_list(re, names)
        list = ActionList()
        for name in names
            if haskey(predefined_actions, name)  # pick up a predefined action
                action = predefined_actions[name]
            elseif haskey(actions, (re, name))
                action = actions[(re, name)]
            else
                action = Action(name, action_order)
                actions[(re, name)] = action
                action_order += 1
            end
            push!(list, action)
        end
        return list
    end

    # Thompson's construction.
    function rec!(start, re)
        if re.actions !== nothing
            for k in keys(re.actions)
                @assert k ∈ ACCEPTED_KEYS
            end
        end

        if !isnothing(re.actions) && haskey(re.actions, :enter)
            start_in = NFANode()
            push!(start.edges, (Edge(eps, make_action_list(re, re.actions[:enter])), start_in))
        else
            start_in = start
        end

        re′ = RegExp.shallow_desugar(re)
        head = re′.head
        args = re′.args

        if head == :set
            @assert length(args) == 1
            final_in = NFANode()
            push!(start_in.edges, (Edge(args[1]), final_in))
        elseif head == :cat
            f = start_in
            for arg in args
                f = rec!(f, arg)
            end
            if f == start_in
                final_in = NFANode()
                push!(start_in.edges, (Edge(eps), final_in))
            else
                final_in = f
            end
        elseif head == :alt
            @assert length(args) > 0
            final_in = NFANode()
            for arg in args
                s = NFANode()
                f = rec!(s, arg)
                push!(start_in.edges, (Edge(eps), s))
                push!(       f.edges, (Edge(eps), final_in))
            end
        elseif head == :rep
            @assert length(args) == 1
            s = NFANode()
            f = rec!(s, args[1])
            final_in = NFANode()
            push!(start_in.edges, (Edge(eps), s))
            push!(start_in.edges, (Edge(eps), final_in))
            push!(       f.edges, (Edge(eps), s))
            push!(       f.edges, (Edge(eps), final_in))
        elseif head == :isec || head == :diff
            @assert length(args) == 2
            final_in = NFANode()
            s1 = NFANode()
            f1 = rec!(s1, args[1])
            push!(start_in.edges, (Edge(eps), s1))
            push!(      f1.edges, (Edge(eps), final_in))
            s2 = NFANode()
            f2 = rec!(s2, args[2])
            push!(start_in.edges, (Edge(eps), s2))
            push!(      f2.edges, (Edge(eps), final_in))
            if head == :isec
                revoke = s -> f1 ∉ s.nfanodes || f2 ∉ s.nfanodes
            else  # re.head == :diff
                revoke = s -> f2 ∈ s.nfanodes
            end
            nfa = dfa2nfa(revoke_finals(revoke, nfa2dfa(NFA(start_in, final_in), false)))
            push!(start_in.edges, (Edge(eps), nfa.start))
            final_in = nfa.final
        else
            error("unsupported operation: $(head)")
        end

        if !isnothing(re.actions) && haskey(re.actions, :all)
            as = make_action_list(re, re.actions[:all])
            for s in traverse(start), (e, _) in s.edges
                if !iseps(e)
                    union!(e.actions, as)
                end
            end
        end

        if !isnothing(re.actions) && haskey(re.actions, :final)
            as = make_action_list(re, re.actions[:final])
            for s in traverse(start), (e, t) in s.edges
                if !iseps(e) && final_in ∈ epsilon_closure(t)
                    # Ugly hack: The tokenizer ATM relies on adding actions to the final edge
                    # of tokens. It's fine that they are repeated in that particular case.
                    # Therefore it can't error for token actions.
                    # It should probably be fixed in tokenizer.jl, by emitting the token on the
                    # :exit edge, and changing the codegen for tokenizer to compensate.
                    if any(action -> !startswith(String(action.name), "__token"), as) && any(i -> i === s, traverse(t))
                        error(
                            "Regex has final action(s): [", join([repr(i.name) for i in as], ", "),
                            "], but regex is looping (e.g. `re\"a+\"`), so has no final input."
                        )
                    end
                    union!(e.actions, as)
                end
            end
        end

        if !isnothing(re.actions) && haskey(re.actions, :exit)
            final = NFANode()
            push!(final_in.edges, (Edge(eps, make_action_list(re, re.actions[:exit])), final))
        else
            final = final_in
        end

        # Add preconditions: The enter precondition is only added to the edge leading
        # into this regex's NFA, whereas the all precondition is added to all edges.
        # We do not add it to eps edges, since these are NFA artifacts, and will be
        # removed during compilation to DFA anyway: The salient part is that the non-eps
        # edges have preconditions.
        if re.precond_enter !== nothing
            (name, bool) = re.precond_enter
            for e in traverse_first_noneps(start)
                push!(e.precond, (name => (bool ? TRUE : FALSE)))
            end
        end
        if re.precond_all !== nothing
            (name, bool) = re.precond_all
            for s in traverse(start), (e, _) in s.edges
                if !iseps(e)
                    push!(e.precond, (name => (bool ? TRUE : FALSE)))
                end
            end
        end

        return final
    end

    nfa_start = NFANode()
    nfa_final::NFANode = rec!(nfa_start, re)
    return remove_dead_nodes(NFA(nfa_start, nfa_final))
end

# Return the set of the first non-epsilon edges reachable from the node
function traverse_first_noneps(node::NFANode)::Set{Edge}
    result = Set{Edge}()
    stack = [node]
    seen = Set(stack)
    while !isempty(stack)
        node = pop!(stack)
        for (edge, child) in node.edges
            if iseps(edge)
                if !in(child, seen)
                    push!(stack, child)
                    push!(seen, child)
                end
            else
                push!(result, edge)
            end
        end
    end
    result
end

# Removes both dead nodes, i.e. nodes from which there is no path to
# the final node, and also unreachable nodes, i.e. nodes that cannot be
# reached from the start node.
function remove_dead_nodes(nfa::NFA)
    # Get a dict Node => Set of nodes that point to Node.
    backrefs = Dict(nfa.start => Set{NFANode}())
    for s in traverse(nfa.start), (_, t) in s.edges
        push!(get!(() -> Set{NFANode}(), backrefs, t), s)
    end

    # Automa could support null regex like `re"A" & re"B"`, but it's trouble,
    # and it's useless for the user, who would probably prefer an error.
    # We throw this error here and not on NFA construction so the user can visualise
    # the NFA and find the error in their regex
    if !haskey(backrefs, nfa.final)
        error(
            "NFA matches the empty set Ø, and therefore consists of only dead nodes. " *
            "Automa currently does not support converting null NFAs to DFAs. " *
            "Double check your regex, or inspect the NFA."
        )
    end

    # Mark nodes as alive, if the final state can be reached from them.
    alive = Set{NFANode}()
    unvisited = [nfa.final]
    while !isempty(unvisited)
        s = pop!(unvisited)
        push!(alive, s)
        for t in backrefs[s]
            if t ∉ alive
                push!(unvisited, t)
            end
        end
    end

    # If this is not true, we threw the big error above.
    @assert nfa.start ∈ alive
    @assert nfa.final ∈ alive

    # Map from old to new node.
    newnodes = Dict{NFANode,NFANode}()
    new(s) = get!(() -> NFANode(), newnodes, s)
    isvisited(s) = haskey(newnodes, s)
    unvisited = [nfa.start]

    # Now make a new NFA that only contain nodes marked alive in the previous step.
    # since we make this new NFA by traversing from the start node, we also skip
    # unreachable nodes
    while !isempty(unvisited)
        s = pop!(unvisited)
        s′ = new(s)
        for (e, t) in s.edges
            if t ∈ alive
                if !isvisited(t)
                    push!(unvisited, t)
                end
                push!(s′.edges, (e, new(t)))
            end
        end
    end

    # The following code will remove any nodes that
    # have just a single eps edge with no actions or preconditions.
    # TODO: Never create these nodes in the first place
    function is_useless_eps(node::NFANode)::Bool
        node === new(nfa.start) && return false
        node === new(nfa.final) && return false
        length(node.edges) == 1 || return false
        edge = first(only(node.edges))
        iseps(edge) || return false
        isempty(edge.actions.actions) || return false
        isempty(edge.precond.names) || return false
        return true
    end

    unvisited = [new(nfa.start)]
    visited = Set{NFANode}()
    while !isempty(unvisited)
        node = pop!(unvisited)
        push!(visited, node)
        for (i, (e, child)) in enumerate(node.edges)
            original_child = child
            while is_useless_eps(child)
                child = last(only(child.edges))
            end
            in(child, visited) || push!(unvisited, child)
            if child !== original_child
                node.edges[i] = (e, child)
            end
        end
    end

    return NFA(new(nfa.start), new(nfa.final))
end

module Validator

using Automa
using TranscodingStreams: NoopStream
using Test

@testset "Validator" begin
    regex = re"a(bc)*|(def)|x+" | re"def" | re"x+"
    eval(Automa.generate_buffer_validator(:foobar, regex; goto=false))
    eval(Automa.generate_buffer_validator(:barfoo, regex; goto=true))

    eval(Automa.generate_io_validator(:io_bar, regex; goto=false))
    eval(Automa.generate_io_validator(:io_foo, regex; goto=true))

    for good_data in [
        "def"
        "abc"
        "abcbcbcbcbc"
        "x"
        "xxxxxx"
    ]
        @test foobar(good_data) ===
            barfoo(good_data) ===
            io_foo(IOBuffer(good_data)) ===
            io_bar(IOBuffer(good_data)) ===
            io_bar(NoopStream(IOBuffer(good_data))) ===
            nothing
    end

    for bad_data in [
        "",
        "abcabc",
        "abcbb",
        "abcbcb",
        "defdef",
        "xabc"
    ]
        @test foobar(bad_data) ===
            barfoo(bad_data) !==
            nothing

        @test io_foo(IOBuffer(bad_data)) ==
            io_bar(IOBuffer(bad_data)) ==
            io_bar(NoopStream(IOBuffer(bad_data))) !=
            nothing
    end
end

@testset "Multiline validator" begin
    regex = re"(>[a-z]+\n)+"
    eval(Automa.generate_io_validator(:io_bar_2, regex; goto=false))
    eval(Automa.generate_io_validator(:io_foo_2, regex; goto=true))

    let data = ">abc"
        @test io_bar_2(IOBuffer(data)) == io_foo_2(IOBuffer(data)) == (nothing, (1, 4))
    end

    let data = ">abc:a"
        @test io_bar_2(IOBuffer(data)) == io_foo_2(IOBuffer(data)) == (UInt8(':'), (1, 5))
    end

    let data = ">"
        @test io_bar_2(IOBuffer(data)) == io_foo_2(IOBuffer(data)) == (nothing, (1, 1))
    end

    let data = ""
        @test io_bar_2(IOBuffer(data)) == io_foo_2(IOBuffer(data)) == (nothing, (1, 0))
    end

    let data = ">abc\n>def\n>ghi\n>j!"
        @test io_bar_2(IOBuffer(data)) == io_foo_2(IOBuffer(data)) == (UInt8('!'), (4, 3))
    end

    let data = ">abc\n;"
        @test io_bar_2(IOBuffer(data)) == io_foo_2(IOBuffer(data)) == (UInt8(';'), (2, 1))
    end 
end

@testset "Reported column" begin
    regex = re"([a-z][a-z]+)(\n[a-z][a-z]+)*"
    eval(Automa.generate_io_validator(:io_foo_3, regex; goto=false))

    function test_reported_pos(data)
        # Test with a small buffer size
        io = NoopStream(IOBuffer(data); bufsize=8)
        y = io_foo_3(io)
        y === nothing ? nothing : last(y)
    end

    for (data, result) in [
        ("abcd", nothing),
        ('a'^10 * '!', (1, 11)),
        ('a'^10 * "\nabc!", (2, 4)),
        ("abcdef\n\n", (3, 0)),
        ('a'^8 * '!', (1, 9)),
        ('a'^8 * "\n" * 'a'^20 * '!', (2, 21)),
        ('a'^7 * '!', (1, 8)),
        ('a'^8, nothing),
        ("abc!", (1, 4)),
        ("", (1, 0)),
        ("a", (1, 1)),
        ("ab\na", (2, 1)),
        ("ab\naa\n\n", (4, 0))
    ]
        @test test_reported_pos(data) == result
    end
end

end # module

# Deterministic Finite Automaton
# ==============================

struct DFANode
    edges::Vector{Tuple{Edge,DFANode}}
    final::Bool
    eof_actions::ActionList
    nfanodes::Set{NFANode}
end

function DFANode(final::Bool, eof_actions::ActionList, nodes::Set{NFANode})
    return DFANode(Tuple{Edge,DFANode}[], final, eof_actions, nodes)
end

function DFANode(final::Bool, nodes::Set{NFANode})
    return DFANode(final, ActionList(), nodes)
end

function Base.show(io::IO, node::DFANode)
    print(io, summary(node), "(<", length(node.edges), " edges", '@', objectid(node), ">)")
end

struct DFA
    start::DFANode
end

# Check if the DFA is really deterministic or not.
function validate(dfa::DFA)
    for s in traverse(dfa.start)
        for i in 1:lastindex(s.edges), j in 1:i-1
            ei = s.edges[i][1]
            ej = s.edges[j][1]
            if overlaps(ei, ej)
                error("found non-deterministic edges")
            end
        end
    end
end

function nfa2dfa(nfa::NFA, unambiguous::Bool=true)
    newnodes = Dict{Set{NFANode},DFANode}()
    new(S) = get!(newnodes, S, DFANode(nfa.final ∈ S, S))
    isvisited(S) = haskey(newnodes, S)
    S = epsilon_closure(nfa.start)
    start = new(S)
    unvisited = [S]
    while !isempty(unvisited)
        # TODO: support fail
        S = pop!(unvisited)
        S_actions = accumulate_actions(S)
        s′ = new(S)

        if s′.final
            union!(s′.eof_actions, S_actions[nfa.final])
        end

        # accumulate edges and preconditions
        labels = Vector{ByteSet}()
        preconds = Set{Symbol}()
        for s in S, (e, t) in s.edges
            if !iseps(e)
                push!(labels, e.labels)
                union!(preconds, precondition_names(e.precond))
            end
        end

        # append DFA edges and nodes
        pn = collect(preconds)
        for label in disjoint_split(labels)
            # This enumeration will not finish in reasonable time when there
            # are too many preconditions.
            edges = Dict{Tuple{DFANode,ActionList},Vector{UInt64}}()
            for pv in UInt64(0):UInt64((1 << length(pn)) - 1)
                T = Set{NFANode}()
                actions = ActionList()
                for s in S, (e, t) in s.edges
                    if !isdisjoint(e.labels, label) && satisfies(e, pn, pv)
                        push!(T, t)
                        union!(actions, e.actions)
                        union!(actions, S_actions[s])
                    end
                end
                if !isempty(T)
                    T = epsilon_closure(T)
                    if !isvisited(T)
                        push!(unvisited, T)
                    end
                    push!(get!(edges, (new(T), actions), UInt64[]), pv)
                end
            end
            for ((t′, actions), pvs) in edges
                pn′, pvs′ = remove_redundant_preconds(pn, pvs)
                for pv′ in pvs′
                    push!(s′.edges, (Edge(label, make_precond(pn′, pv′), actions), t′))
                end
            end
        end
    end
    # Each key represents a set of NFANodes that collapses to one DFANode.
    # If any set contain conflicting possible actions, raise an error.
    unambiguous && validate_nfanodes(newnodes, start)
    return remove_dead_nodes(DFA(start))
end

function epsilon_closure(node::NFANode)
    return epsilon_closure(Set([node]))
end

function epsilon_closure(nodes::Set{NFANode})
    closure = Set{NFANode}()
    unvisited = copy(nodes)
    while !isempty(unvisited)
        s = pop!(unvisited)
        push!(closure, s)
        for (e, t) in s.edges
            if iseps(e) && t ∉ closure
                push!(unvisited, t)
            end
        end
    end
    return closure
end

"Find the nodes in this set where no other node in the set has an edge to it"
function gettop(S::Set{NFANode})
    top = copy(S)
    for s in S
        for (e, t) in s.edges
            if iseps(e)
                delete!(top, t)
            end
        end
    end
    return top
end

"Find paths from top nodes through epsilon edges, keeping track of actions taken."
function get_epsilon_paths(tops::Set{NFANode})
    paths = Tuple{Union{Nothing, Edge}, NFANode, Vector{Symbol}}[]
    heads = [(node, Symbol[]) for node in tops]
    visited = Set{NFANode}()
    while !isempty(heads)
        node, actions = pop!(heads)
        if iszero(length(node.edges))
            push!(paths, (nothing, node, actions))
        end
        for (edge, child) in node.edges
            if iseps(edge)
                if !in(node, visited)
                    push!(heads, (child, append!(copy(actions), [a.name for a in edge.actions])))
                end
            else
                append!(actions, [a.name for a in edge.actions])
                push!(paths, (edge, node, actions))
            end
        end
        push!(visited, node)
    end
    return paths
end

"Compute the shortest input to reach any given DFANode"
function shortest_input(start::DFANode)::Dict{DFANode, String}
    printable = Automa.ByteSet(0x21:0x78)
    result = Dict(start => "")
    # Breadth first search
    current_generation = Set([start])
    next_generation = Set{DFANode}()
    while !isempty(current_generation)
        for parent in current_generation
            parent_bytes = result[parent]
            for (edge, child) in parent.edges
                haskey(result, child) && continue
                # If possible, grab a printable byte
                printable_edges = intersect(printable, edge.labels)
                byte = first(isempty(printable_edges) ? edge.labels : printable_edges)
                result[child] = String(push!(Vector{UInt8}(parent_bytes), byte))
                push!(next_generation, child)
            end
        end
        (current_generation, next_generation) = (next_generation, current_generation)
        next_generation = Set{DFANode}()
    end
    result
end

function validate_paths(
    paths::Vector{Tuple{Union{Nothing, Edge}, NFANode, Vector{Symbol}}},
    dfanode::DFANode,
    start::DFANode,
    strings_to::Dict{DFANode, String}
)
    # If they have the same actions, there is no ambiguity
    all(actions == paths[1][3] for (e, n, actions) in paths) && return nothing
    for i in 1:length(paths) - 1
        edge1, node1, actions1 = paths[i]
        for j in i+1:length(paths)
            edge2, node2, actions2 = paths[j]
            # If either ends with EOF, they don't have same conditions and we can continue
            # If only one is an EOF, they are distinct
            (edge1 === nothing) ⊻ (edge2 === nothing) && continue
            # If they have same actions, there is no conflict
            actions1 == actions2 && continue
            eof = (edge1 === nothing) & (edge2 === nothing)
            
            if !eof
                # If they are real edges but do not overlap, or there are conflicting
                # preconditions, there is no conflict
                overlaps(edge1::Edge, edge2::Edge) || continue
            end

            # Now we know there is an ambiguity, so we just need to create
            # an informative error
            act1 = isempty(actions1) ? "nothing" : string(actions1)
            act2 = isempty(actions2) ? "nothing" : string(actions2)
            input_until_now = repr(strings_to[dfanode])
            final_input = if eof
                "EOF"
            else
                repr(Char(first(intersect((edge1::Edge).labels, (edge2::Edge).labels))))
            end
            error(
                "Ambiguous NFA.\nAfter inputs $input_until_now, observing $final_input " *
                "lead to conflicting action sets $act1 and $act2"
            )
        end
    end
end

function validate_nfanodes(
    newnodes::Dict{Set{NFANode}, DFANode},
    start::DFANode
)
    # Sort all DFA nodes by how short a string can be used to reach it, in order
    # to display the shortest possible conflict if any is found.
    strings_to = shortest_input(start)
    pairs = sort!(collect(newnodes); by=i -> ncodeunits(strings_to[i[2]]))
    for (nfanodes, dfanode) in pairs
        # First get "tops", that's the starting epsilon nodes that cannot be
        # reached by another epsilon node. All paths lead from those
        tops = gettop(nfanodes)
        
        # Quick path: If only one path, there can be no ambiguity
        length(tops) == 1 && all(length(node.edges) == 1 for node in nfanodes) && continue

        # Now we transverse all possible epsilon-paths and keep track of the actions
        # taken along the way
        paths = get_epsilon_paths(tops)

        # If any two paths have different actions, and can be reached with the same
        # byte, the DFA's actions cannot be resolved, and we raise an error
        validate_paths(paths, dfanode, start, strings_to)
    end
end

function disjoint_split(sets::Vector{ByteSet})
    # TODO: maybe too slow when length(sets) is large
    cut(s1, s2) = (intersect(s1, s2), setdiff(s1, s2))
    disjsets = [ByteSet(0x00:0xff)]
    disjsets′ = ByteSet[]
    for x in sets
        for y in disjsets
            y1, y2 = cut(y, x)
            if !all(isdisjoint(z, y1) for z in sets)
                push!(disjsets′, y1)
            end
            if !all(isdisjoint(z, y2) for z in sets)
                push!(disjsets′, y2)
            end
        end
        disjsets, disjsets′ = disjsets′, disjsets
        empty!(disjsets′)
    end
    return disjsets
end

function accumulate_actions(S::Set{NFANode})
    top = gettop(S)
    @assert !isempty(top)
    actions = Dict(s => ActionList() for s in S)
    visited = Set{NFANode}()
    unvisited = top
    while !isempty(unvisited)
        s = pop!(unvisited)
        push!(visited, s)
        for (e, t) in s.edges
            if iseps(e)
                @assert !isconditioned(e.precond)
                union!(actions[t], e.actions)
                union!(actions[t], actions[s])
                if t ∉ visited
                    push!(unvisited, t)
                end
            end
        end
    end
    return actions
end

function satisfies(edge::Edge, names::Vector{Symbol}, pv::UInt64)
    for (n, v) in edge.precond
        i = findfirst(isequal(n), names)
        @assert i !== nothing
        @assert 0 < i ≤ 64
        vi = bitat(pv, i)
        if !(v == BOTH || (v == TRUE && vi) || (v == FALSE && !vi))
            return false
        end
    end
    return true
end

function remove_redundant_preconds(names::Vector{Symbol}, pvs::Vector{UInt64})
    mask(n) = ((1 << n) - 1) % UInt64
    newnames = Symbol[]
    pvs = copy(pvs)
    left = length(names)
    for name in names
        sort!(pvs)
        fnd = findfirst(pv -> bitat(pv, left), pvs)
        k = ifelse(fnd === nothing, 0, fnd) # TODO: See if there is a more elegant way of doing this.
        if (k - 1) * 2 == length(pvs)
            redundant = true
            for i in 1:k-1
                m = mask(left - 1)
                if pvs[i] & m != pvs[i+k-1] & m
                    redundant = false
                    break
                end
            end
        else
            redundant = false
        end
        if redundant
            left -= 1
            for i in 1:lastindex(pvs)
                # remove the redundant bit
                pvs[i] = pvs[i] & mask(left)
            end
        else
            push!(newnames, name)
            for i in 1:lastindex(pvs)
                # circular left shift
                pvs[i] = ((pvs[i] << 1) & mask(left)) | bitat(pvs[i], left)
            end
        end
    end
    return newnames, unique(pvs)
end

function make_precond(names::Vector{Symbol}, pv::UInt64)
    precond = Precondition()
    for (i, n) in enumerate(names)
        push!(precond, n => bitat(pv, i) ? TRUE : FALSE)
    end
    return precond
end

function bitat(x::UInt64, i::Integer)
    return ((x >> (i - 1)) & 1) == 1
end

function reduce_nodes(dfa::DFA)
    equivalents = get_equivalent(collect(traverse(dfa.start)))
    newnodes = Dict{Set{DFANode},DFANode}()
    new(S) = get!(newnodes, S) do
        s = first(S)
        return DFANode(s.final, s.eof_actions, foldl((x, s) -> union(x, s.nfanodes), S, init=Set{NFANode}()))
    end
    isvisited(T) = haskey(newnodes, T)
    S = equivalents[dfa.start]
    start = new(S)
    unvisited = [S]
    while !isempty(unvisited)
        S = pop!(unvisited)
        s′ = new(S)
        for (e, t) in first(S).edges
            T = equivalents[t]
            if !isvisited(T)
                push!(unvisited, T)
            end

            # Here, add the old edge to the new DFA. If an equivalent edge already
            # exists, instead add the labels of the old edge to the existing one.
            existing_edge = false
            for (i, (e´, t´)) in enumerate(s′.edges)
                if t´ == new(T) && e´.precond == e.precond && e´.actions == e.actions
                    newlabels = union(e.labels, e´.labels)
                    newedge = Edge(newlabels, e.precond, e.actions)
                    s′.edges[i] = (newedge, t´)
                    existing_edge = true
                    break
                end
            end
            existing_edge || push!(s′.edges, (e, new(T)))
        end
    end
    return DFA(start)
end

function get_groupof(v::Vector{DFANode})
    # These are sets of the outgoing bytes from every node
    labels = Dict(s => foldl((x, y) -> union(x, y[1].labels), s.edges, init=ByteSet()) for s in v)
    
    # First we create groups of nodes that MAY be identical based on quick-to-compute
    # characteristics. This narrows down the number of comparisons needed later.
    # Nodes may be equal if the have the same outgoing bytes, same final node and same
    # EOF actions.
    groupof = Dict{DFANode,Vector{DFANode}}()
    for s1 in v
        unique = true
        for group in values(groupof)
            s2 = first(group)
            if s1.final == s2.final && labels[s1] == labels[s2] && s1.eof_actions == s2.eof_actions
                push!(group, s1)
                groupof[s1] = group
                unique = false
                break
            end
        end
        unique && (groupof[s1] = [s1])
    end
    return groupof
end

function equivalent_pairs(groupof, v)
    # Here, we check each pair in each group. If they share an edge with an overlapping byte,
    # compatible preconditions, but the edge have different actions or leads no a non-equivalent
    # node, they're different. Because a parent's nonequivalence relies on the status of
    # its children, we need to update the parents every time we update a node.
    equivalent_pairs = Set{Tuple{DFANode,DFANode}}()
    for group in values(groupof), s1 in group, s2 in group
        push!(equivalent_pairs, (s1, s2))
    end
    
    # Get a node => vector of parents of node dict
    parentsof = Dict{DFANode,Vector{DFANode}}()
    for s in v, (e,c) in s.edges
        if haskey(parentsof, c)
            push!(parentsof[c], s)
        else
            parentsof[c] = [s]
        end
    end
    unupdated = Set(v)
    while !isempty(unupdated)
        s1 = pop!(unupdated)
        group = groupof[s1]
        for s2 in group
            (s1 == s2 || (s1, s2) ∉ equivalent_pairs) && continue
            for (e1, t1) in s1.edges, (e2, t2) in s2.edges
                if overlaps(e1, e2) && ((t1, t2) ∉ equivalent_pairs || e1.actions != e2.actions)
                    delete!(equivalent_pairs, (s1, s2))
                    haskey(parentsof, s1) && union!(unupdated, parentsof[s1])
                    break
                end
            end
        end
    end
    return equivalent_pairs
end

function split_group(group::Vector{DFANode}, pairs)
    remaining = copy(group)
    result = Vector{DFANode}[]
    nonequivalents = DFANode[]
    while !isempty(remaining)
        s1 = first(remaining)
        equivalents = DFANode[]
        for s2 in remaining
            (s1, s2) ∈ pairs ? push!(equivalents, s2) : push!(nonequivalents, s2)
        end
        push!(result, equivalents)
        (nonequivalents, remaining) = (remaining, nonequivalents)
        empty!(nonequivalents)
    end
    return result
end

"Creates a DFANode => Set{DFANode} dict with equivalent nodes for every node in v"
function get_equivalent(v::Vector{DFANode})
    groupof = get_groupof(v)
    pairs = equivalent_pairs(groupof, v)
    groups = collect(keys(IdDict{Vector{DFANode},Nothing}(v => nothing for v in values(groupof))))
    result = Dict{DFANode,Set{DFANode}}()
    for group in groups
        for subgroup in split_group(group, pairs)
            S = Set(subgroup)
            for node in subgroup
                result[node] = S
            end
        end
    end
    return result
end

function overlaps(e1::Edge, e2::Edge)
    return !(isdisjoint(e1.labels, e2.labels) || conflicts(e1.precond, e2.precond))
end

function revoke_finals(p::Function, dfa::DFA)
    newnodes = Dict{DFANode,DFANode}()
    new(s) = get!(newnodes, s) do
        return DFANode(s.final && !p(s), s.eof_actions, s.nfanodes)
    end
    for s in traverse(dfa.start)
        s′ = new(s)
        for (e, t) in s.edges
            push!(s′.edges, (e, new(t)))
        end
    end
    return DFA(new(dfa.start))
end

function dfa2nfa(dfa::DFA)
    newnodes = Dict{DFANode,NFANode}()
    new(s) = get!(newnodes, s, NFANode())
    final = NFANode()
    for s in traverse(dfa.start)
        s′ = new(s)
        for (e, t) in s.edges
            push!(s′.edges, (e, new(t)))
        end
        if s.final
            push!(s′.edges, (Edge(eps, s.eof_actions), final))
        end
    end
    start = NFANode()
    push!(start.edges, (Edge(eps), new(dfa.start)))
    return NFA(start, final)
end

function remove_dead_nodes(dfa::DFA)
    backrefs = Dict(dfa.start => Set{DFANode}())
    for s in traverse(dfa.start), (_, t) in s.edges
        push!(get!(backrefs, t, Set{DFANode}()), s)
    end

    alive = Set{DFANode}()
    unvisited = [s for s in keys(backrefs) if s.final]
    while !isempty(unvisited)
        s = pop!(unvisited)
        push!(alive, s)
        for t in backrefs[s]
            if t ∉ alive
                push!(unvisited, t)
            end
        end
    end
    @assert dfa.start ∈ alive

    newnodes = Dict{DFANode,DFANode}()
    new(s) = get!(newnodes, s, DFANode(s.final, s.eof_actions, s.nfanodes))
    isvisited(s) = haskey(newnodes, s)
    unvisited = [dfa.start]
    while !isempty(unvisited)
        s = pop!(unvisited)
        s′ = new(s)
        for (e, t) in s.edges
            if t ∈ alive
                if !isvisited(t)
                    push!(unvisited, t)
                end
                push!(s′.edges, (e, new(t)))
            end
        end
    end

    return DFA(new(dfa.start))
end

module Test01

using Automa
using Test

@testset "Test01" begin
    re = re""
    onenter!(re, :enter)
    onexit!(re, :exit)
    machine = Automa.compile(re)
    @test occursin(r"^Automa.Machine\(<.*>\)$", repr(machine))

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        code = Automa.generate_code(ctx, machine, :debug)
        validate = @eval function (data)
            logger = Symbol[]
            $(code)
            return cs == 0, logger
        end
        @test validate(b"") == (true, [:enter, :exit])
        @test validate(b"a") == (false, Symbol[])
    end
end

end

using Automa
using BenchmarkTools
using Random: seed!

seed!(1234)
data = String(vcat([push!(rand(b"ACGTacgt", 59), UInt8('\n')) for _ in 1:1000]...))

VISUALIZE = false
function writesvg(name, machine)
    dot = joinpath(@__DIR__, "$(name).dot")
    svg = joinpath(@__DIR__, "$(name).svg")
    info("writing $(dot)")
    write(dot, Automa.machine2dot(machine))
    info("writing $(svg)")
    run(`dot -Tsvg -o $(svg) $(dot)`)
end


# Case 1
# ------

println("Case 1 ", raw"([A-z]*\r?\n)*")
match(data) = occursin(r"^(:?[A-z]*\r?\n)*$", data)
@assert match(data)
println("PCRE:                 ", @benchmark match(data))

machine = Automa.compile(re"([A-z]*\r?\n)*")
VISUALIZE && writesvg("case1", machine)
context = Automa.CodeGenContext()
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl:            ", @benchmark match(data))

context = Automa.CodeGenContext(generator=:goto)
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl (goto):     ", @benchmark match(data))


# Case 2
# ------

println()
println("Case 2 ", raw"([A-Za-z]*\r?\n)*")
match(data) = occursin(r"^(:?[A-Za-z]*\r?\n)*$", data)
@assert match(data)
println("PCRE:                 ", @benchmark match(data))

machine = Automa.compile(re"([A-Za-z]*\r?\n)*")
VISUALIZE && writesvg("case2", machine)
context = Automa.CodeGenContext()
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl:            ", @benchmark match(data))

context = Automa.CodeGenContext(generator=:goto)
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl (goto):     ", @benchmark match(data))


# Case 3
# ------

println()
println("Case 3 ", raw"([ACGTacgt]*\r?\n)*")
match(data) = occursin(r"^(:?[ACGTacgt]*\r?\n)*$", data)
@assert match(data)
println("PCRE:                 ", @benchmark match(data))

machine = Automa.compile(re"([ACGTacgt]*\r?\n)*")
VISUALIZE && writesvg("case3", machine)
context = Automa.CodeGenContext()
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl:            ", @benchmark match(data))

context = Automa.CodeGenContext(generator=:goto)
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl (goto):     ", @benchmark match(data))


# Case 4
# ------

println()
println("Case 4 ", raw"([A-Za-z\*-]*\r?\n)*")
match(data) = occursin(r"^(:?[A-Za-z\*-]*\r?\n)*$", data)
@assert match(data)
println("PCRE:                 ", @benchmark match(data))

machine = Automa.compile(re"([A-Za-z\*-]*\r?\n)*")
VISUALIZE && writesvg("case4", machine)
context = Automa.CodeGenContext()
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl:            ", @benchmark match(data))

context = Automa.CodeGenContext(generator=:goto)
@eval function match(data)
    $(Automa.generate_code(context, machine))
    return cs == 0
end
@assert match(data)
println("Automa.jl (goto):     ", @benchmark match(data))

module Test19

using Automa
using Test

@testset "Test19" begin
    # Ambiguous enter statement
    A = re"XY"
    B = re"XZ"
    onenter!(A, :enter_A)
    @test_throws ErrorException compile(A | B)
    @test compile(A | B, unambiguous=false) isa Automa.Machine

    # Ambiguous, but no action in ambiguity
    A = re"XY"
    onexit!(A, :exit_A)
    @test compile(A | B) isa Automa.Machine

    A = re"aa"
    B = re"a+"
    @test compile(A | B) isa Automa.Machine

    onenter!(A, :enter_A)
    @test_throws ErrorException compile(A | B)
    @test compile(A | B, unambiguous=false) isa Automa.Machine

    A = re"aa"
    onexit!(A, :exit_A)
    @test_throws ErrorException compile(A | B)
    @test compile(A | B, unambiguous=false) isa Automa.Machine

    # Harder test case
    A = re"AAAAB"
    B = re"A+C"
    onexit!(A, :exit_A)
    onexit!(B, :exit_B)
    @test compile(A | B) isa Automa.Machine

    # Test that conflicting edges can be known to be distinct
    # with different conditions.
    A = re"XY"
    precond!(A, :cond)
    B = re"XZ"
    precond!(B, :cond, when=:enter, bool=false)
    onenter!(A, :enter_A)
    @test compile(A | B, unambiguous=true) isa Automa.Machine
end

end

# A simple and practical FASTA file parser
# ========================================

using Automa

# Create a machine of FASTA.
fasta_machine = let
    # First, describe FASTA patterns in regular expression.
    newline     = re"\r?\n"
    identifier  = re"[!-~]*"
    description = re"[!-~][ -~]*"
    letters     = re"[A-Za-z*-]+"
    sequence    = letters * rep(newline * letters)
    record      = '>' * identifier * opt(' ' * description) * newline * sequence
    fasta       = opt(record) * rep(newline * record) * rep(newline)

    # Second, bind action names to each regular expression.
    onenter!(identifier,  :mark)
    onexit!( identifier,  :identifier)
    onenter!(description, :mark)
    onexit!( description, :description)
    onenter!(letters,     :mark)
    onexit!( letters,     :letters)
    onenter!(record,      :record)

    # Finally, compile the final FASTA pattern into a state machine.
    compile(fasta)
end

# It is useful to visualize the state machine for debugging.
# write("fasta.dot", Automa.machine2dot(fasta_machine))
# run(`dot -Tsvg -o fasta.svg fasta.dot`)

# Bind Julia code to each action name (see the `parse_fasta` function defined below).
fasta_actions = Dict(
    :mark        => :(mark = p),
    :identifier  => :(identifier = String(data[mark:p-1]); mark = 0),
    :description => :(description = iszero(mark) ? nothing : String(data[mark:p-1])),
    :letters     => quote
        linelen = p - mark
        length(buffer) < seqlen + linelen && resize!(buffer, seqlen + linelen)
        GC.@preserve data buffer unsafe_copyto!(pointer(buffer) + seqlen, pointer(data, mark), linelen)
        seqlen += linelen
    end,
    :record      => quote
        record_seen && push!(records, FASTARecord(identifier, description, String(buffer[1:seqlen])))
        seqlen = 0
        record_seen = true
    end
)

# Define a type to store a FASTA record.
struct FASTARecord
    identifier::String
    description::Union{Nothing, String}
    sequence::String
end

# Generate a parser function from `fasta_machine` and `fasta_actions`.
context = CodeGenContext(generator=:goto)
@eval function parse_fasta(data::AbstractVector{UInt8})
    # Initialize variables you use in the action code.
    records = FASTARecord[]
    mark = 0
    seqlen = 0
    record_seen = false
    identifier = ""
    description = nothing
    buffer = UInt8[]

    # Generate code for initialization and main loop
    $(generate_code(context, fasta_machine, fasta_actions))
    record_seen && push!(records, FASTARecord(identifier, description, String(buffer[1:seqlen])))

    # Finally, return records accumulated in the action code.
    return records
end
parse_fasta(s::Union{String, SubString{String}}) = parse_fasta(codeunits(s))
parse_fasta(io::IO) = parse_fasta(read(io))

# Run the FASTA parser.
data = """>NP_003172.1 brachyury protein isoform 1 [Homo sapiens]
MSSPGTESAGKSLQYRVDHLLSAVENELQAGSEKGDPTERELRVGLEESELWLRFKELTNEMIVTKNGRR
MFPVLKVNVSGLDPNAMYSFLLDFVAADNHRWKYVNGEWVPGGKPEPQAPSCVYIHPDSPNFGAHWMKAP
VSFSKVKLTNKLNGGGQIMLNSLHKYEPRIHIVRVGGPQRMITSHCFPETQFIAVTAYQNEEITALKIKY
NPFAKAFLDAKERSDHKEMMEEPGDSQQPGYSQWGWLLPGTSTLCPPANPHPQFGGALSLPSTHSCDRYP
TLRSHRSSPYPSPYAHRNNSPTYSDNSPACLSMLQSHDNWSSLGMPAHPSMLPVSHNASPPTSSSQYPSL
WSVSNGAVTPGSQAAAVSNGLGAQFFRGSPAHYTPLTHPVSAPSSSGSPLYEGAAAATDIVDSQYDAAAQ
GRLIASWTPVSPPSM
>sp|P01308|INS_HUMAN Insulin OS=Homo sapiens OX=9606 GN=INS PE=1 SV=1
MALWMRLLPLLALLALWGPDPAAAFVNQHLCGSHLVEALYLVCGERGFFYTPKTRREAED
LQVGQVELGGGPGAGSLQPLALEGSLQKRGIVEQCCTSICSLYQLENYCN
"""
records = parse_fasta(data)

# Uncomment to benchmark
# let
#     data2 = repeat(data, 10_000)
#     seconds = (@timed parse_fasta(data2)).time
#     MBs = (sizeof(data2) / 1e6) / seconds
#     println("Parsed FASTA at $(round(MBs; digits=2)) MB/s")
# end

module Test07

using Automa
using Test

@testset "Test07" begin
    re1 = re"a.*b"
    machine = Automa.compile(re1)
    ctx = Automa.CodeGenContext()
    @eval function ismatch1(data)
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine))
        return cs == 0
    end
    @test ismatch1(b"ab")
    @test ismatch1(b"azb")
    @test ismatch1(b"azzzb")
    @test !ismatch1(b"azzz")
    @test !ismatch1(b"zzzb")

    re2 = re"a\.*b"
    machine = Automa.compile(re2)
    ctx = Automa.CodeGenContext()
    @eval function ismatch2(data)
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine))
        return cs == 0
    end
    @test ismatch2(b"ab")
    @test ismatch2(b"a.b")
    @test ismatch2(b"a...b")
    @test !ismatch2(b"azzzb")
    @test !ismatch2(b"a...")
    @test !ismatch2(b"...b")

    re3 = re"a\.\*b"
    machine = Automa.compile(re3)
    ctx = Automa.CodeGenContext()
    @eval function ismatch3(data)
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine))
        return cs == 0
    end
    @test ismatch3(b"a.*b")
    @test !ismatch3(b"a...b")
end

end

module TestInputError

using Automa
using Test

@testset "Input error" begin
    machine = compile(re"xyz")
    @eval function test_input_error(data)
        $(generate_code(machine))
    end

    @test_throws Exception test_input_error("a")
end

end # module

using Automa

DIR = joinpath(dirname(dirname(Base.pathof(Automa))), "docs/src/figure")
ispath(DIR) || mkdir(DIR)

function regex_png(regex, path)
    open("/tmp/re.dot", "w") do io
        println(io, Automa.nfa2dot(Automa.re2nfa(regex)))
    end
    run(pipeline(`dot -Tpng /tmp/re.dot`, stdout=path))
end

function dot_png(dot, path)
    open("/tmp/re.dot", "w") do io
        println(io, dot)
    end
    run(pipeline(`dot -Tpng /tmp/re.dot`, stdout=path))
end    

regex_png(re"a", "$DIR/simple.png")
regex_png(re"(\+|-)?(0|1)*", "$DIR/larger.png")

dot = """
digraph {
  graph [ rankdir = LR ];
  A [ shape = circle ];
 A -> B [ label = "ϵ" ];
  B [ shape = doublecircle ];
}
"""

dot_png(dot, "$DIR/cat.png")

dot = """
digraph {
  graph [ rankdir = LR ];
  A [ shape = circle ];
  B [ shape = circle ];
  1 [ shape = circle ];
  2 [ shape = doublecircle ];
  1 -> A [ label = "ϵ" ];
  1 -> B [ label = "ϵ" ];
  A -> 2 [ label = "ϵ" ];
  B -> 2 [ label = "ϵ" ];
}
"""

dot_png(dot, "$DIR/alt.png")

dot = """
digraph {
  graph [ rankdir = LR ];
  A [ shape = circle ];
  1 [ shape = circle ];
  2 [ shape = doublecircle ];
  1 -> A [ label = "ϵ" ];
  1 -> 2 [ label = "ϵ" ];
  A -> 2 [ label = "ϵ" ];
  A -> A [ label = "ϵ" ];
}
"""

dot_png(dot, "$DIR/kleenestar.png")

open("/tmp/re.dot", "w") do io
    nfa = Automa.re2nfa(re"(\+|-)?(0|1)*")
    dfa = Automa.nfa2dfa(nfa)
    println(io, Automa.dfa2dot(dfa))
end
run(pipeline(`dot -Tpng /tmp/re.dot`, stdout="$DIR/large_dfa.png"))

open("/tmp/re.dot", "w") do io
    machine = compile(re"(\+|-)?(0|1)*")
    println(io, Automa.machine2dot(machine))
end
run(pipeline(`dot -Tpng /tmp/re.dot`, stdout="$DIR/large_machine.png"))

 using PrecompileTools: @compile_workload

@compile_workload begin
let
    goto_ctx = CodeGenContext(generator=:goto)
    table_ctx = CodeGenContext(generator=:table)
        
    # Create a buffer validator
    regex = let
        name = onexit!(onenter!(re"[^\t\r\n]+", :mark), :name)
        field = onexit!(onenter!(re"[^\t\r\n]+", :mark), :field)
        nameline = name * rep('\t' * name)
        record = onexit!(field * rep('\t' * field), :record)
        nameline * re"\r?\n" * record * rep(re"\r?\n" * record) * rep(re"\r?\n")
    end
    generate_buffer_validator(:foo, regex; goto=true)
    generate_buffer_validator(:foo, regex; goto=false)

    # Create an ordinary parser
    machine = compile(regex)
    actions = Dict(
        :mark => :(pos = p),
        :name => :(push!(headers, String(data[pos:p-1]))),
        :field => quote
            n_fields += 1
            push!(fields, String(data[pos:p-1]))
        end,
        :record => quote
            n_fields == length(headers) || error("Malformed TSV")
            n_fields = 0
        end
    )

    generate_code(goto_ctx, machine, actions)
    generate_code(table_ctx, machine, actions)

    # Create a tokenizer
    tokens = [
        re"[A-Za-z_][0-9A-Za-z_!]*!",
        re"\(",
        re"\)",
        re",",
        re"abc",
        re"\"",
        re"[\t\f ]+",
    ];
    make_tokenizer(tokens; goto=true)
    make_tokenizer(tokens; goto=false)
end
end

module Test15

using Automa
using Test

@testset "Test15" begin
    a = re"a+"
    onenter!(a, :enter)
    onall!(a, :all)
    onexit!(a, :exit)
    b = re"b+"
    onenter!(b, :enter)
    onall!(b, :all)
    onexit!(b, :exit)
    ab = Automa.RegExp.cat(a, b)

    machine = Automa.compile(ab)
    last, actions = Automa.execute(machine, "ab")
    @test last == 0
    @test actions == [:enter, :all, :exit, :enter, :all, :exit]

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        validate = @eval function (data)
            logger = Symbol[]
            $(Automa.generate_code(ctx, machine, :debug))
            return logger, cs == 0 ? :ok : cs < 0 ? :error : :incomplete
        end
        @test validate(b"ab") == ([:enter, :all, :exit, :enter, :all, :exit], :ok)
    end
end

end

# SizedMemory
# ===========

struct SizedMemory
    ptr::Ptr{UInt8}
    len::UInt
end

"""
    SizedMemory(data)

Create a `SizedMemory` object from `data`.

`data` must implement `Automa.pointerstart` and `Automa.pointerend` methods.
These are used to get the range of the contiguous data memory of `data`.  These
have default methods which uses `Base.pointer` and `Base.sizeof` methods.  For
example, `String` and `Vector{UInt8}` support these `Base` methods.

Note that it is user's responsibility to keep the `data` object alive during
`SizedMemory`'s lifetime because it does not have a reference to the object.
"""
function SizedMemory(data, len::Integer=(pointerend(data) + 1) - pointerstart(data))
    return SizedMemory(pointerstart(data), len)
end

"""
    pointerstart(data)::Ptr{UInt8}

Return the start position of `data`.

The default implementation is `convert(Ptr{UInt8}, pointer(data))`.
"""
function pointerstart(data)::Ptr{UInt8}
    return convert(Ptr{UInt8}, pointer(data))
end

"""
    pointerend(data)::Ptr{UInt8}

Return the end position of `data`.

The default implementation is `Automa.pointerstart(data) + sizeof(data) - 1`.
"""
function pointerend(data)::Ptr{UInt8}
    return pointerstart(data) + sizeof(data) - 1
end

function Base.checkbounds(mem::SizedMemory, i::Integer)
    if 1 ≤ i ≤ mem.len
        return
    end
    throw(BoundsError(i))
end

function Base.getindex(mem::SizedMemory, i::Integer)
    @boundscheck checkbounds(mem, i)
    return unsafe_load(mem.ptr, i)
end

function Base.lastindex(mem::SizedMemory)
    return Int(mem.len)
end

function Base.length(mem::SizedMemory)
    return Int(mem.len)
end

# Precondition
# ============

# See comments on Precondition.
primitive type Value 8 end

const NONE  = reinterpret(Value, 0x00)
const TRUE  = reinterpret(Value, 0x01)
const FALSE = reinterpret(Value, 0x02)
const BOTH  = reinterpret(Value, 0x03)

function Base.convert(::Type{UInt8}, v::Value)
    return reinterpret(UInt8, v)
end

function Base.convert(::Type{Value}, b::UInt8)
    return reinterpret(Value, b)
end

function Base.:|(v1::Value, v2::Value)
    return convert(Value, convert(UInt8, v1) | convert(UInt8, v2))
end

function Base.:&(v1::Value, v2::Value)
    return convert(Value, convert(UInt8, v1) & convert(UInt8, v2))
end

# A Precondition is a list of conditions. Each condition has a symbol, which is used to
# look up in a dict for an Expr object like :(a > 1) that should evaluate to a Bool.
# This allows Automa to add if/else statements in generated code, like
# if (a > 1) && (b < 5) for a Precondition with two symbols.
# The Value is whether the condition is negated.
# Automa's optimization of the graph may negate, or manipulate the expressions using
# boolean logic.
# There are four options for expr E:
# 1. E & !E  (i.e. always false. This code is never even generated, just a literal false is)
# 2. E (i.e. the pure condition)
# 3. !E (i.e. the negated condition)
# 4. E | !E (i.e. always true. Like 1., this is encoded as a literal `true` in generated code).
struct Precondition
    names::Vector{Symbol}
    values::Vector{Value}
end

function Precondition()
    return Precondition(Symbol[], Value[])
end

function Base.:(==)(p1::Precondition, p2::Precondition)
    return p1.names == p2.names && p1.values == p2.values
end

function Base.getindex(precond::Precondition, name::Symbol)
    i = findfirst(n -> n == name, precond.names)
    if i === nothing
        return BOTH
    else
        return precond.values[i]
    end
end

function Base.push!(precond::Precondition, kv::Pair{Symbol,Value})
    name, value = kv
    i = findfirst(n -> n == name, precond.names)
    if i === nothing
        push!(precond.names, name)
        push!(precond.values, value)
    else
        precond.values[i] |= value
    end
    return precond
end

function precondition_names(precond::Precondition)
    return copy(precond.names)
end

function conflicts(precond1::Precondition, precond2::Precondition)
    for (n1, v1) in precond1
        if (v1 & precond2[n1]) == NONE
            return true
        end
    end
    return false
end

function Base.iterate(precond::Precondition, i=1)
    if i > length(precond.names)
        return nothing
    end
    return (precond.names[i], precond.values[i]), i + 1
end

function isconditioned(precond::Precondition)
    for v in precond.values
        if v != BOTH
            return true
        end
    end
    return false
end

module Test11

using Automa
using Test

@testset "Test11" begin
    @test_throws Exception precond!(re"A", :foo; when=:never)

    a = re"[a-z]+"
    precond!(a, :le)
    a = rep1(a)
    onexit!(a, :one)
    b = re"[a-z]+[0-9]+"
    onexit!(b, :two)
    c = re"[A-Z][a-z]+"
    precond!(c, :le, when=:all)
    onexit!(c, :three)

    machine = compile((a | b | c) * '\n')
    actions = Dict(
        :one => :(push!(logger, :one)),
        :two => :(push!(logger, :two)),
        :three => :(push!(logger, :three)),
        :le  => :(p ≤ n))

    ctx = CodeGenContext(generator=:table)
    @test_throws ErrorException Automa.generate_exec_code(ctx, machine, actions)

    for clean in (true, false)
        ctx = CodeGenContext(generator=:goto, clean=clean)
        validate = @eval function (data, n)
            logger = Symbol[]
            $(Automa.generate_init_code(ctx, machine))
            $(Automa.generate_exec_code(ctx, machine, actions))
            return logger, cs == 0 ? :ok : cs < 0 ? :error : :incomplete
        end
        # p > n
        @test validate(b"a\n", 0) == ([], :error)
        # p == n
        @test validate(b"a\n", 1) == ([:one], :ok)
        # p == n
        @test validate(b"a1\n", 1) == ([:two], :ok)
        # p == n on enter, but not after first
        @test validate(b"Aa\n", 1) == ([], :error)
        @test validate(b"Aaa\n", 3) == ([:three], :ok)
        @test validate("A\n", 1) == ([], :error)
        @test validate("aa", 2) == ([], :incomplete)
        # matches b
        @test validate(b"aa1\n", 1) == ([:two], :ok)
        # Matches a
        @test validate(b"aa\n", 2) == ([:one], :ok)
        # Matches b
        @test validate(b"aa1\n", 2) == ([:two], :ok)
        # Matches neither
        @test validate(b"1\n", 1) == ([], :error)
    end
end

end

module Unicode

using Automa
using Test

@testset "Unicode" begin
    passes(machine::Automa.Machine, text) = iszero(first(Automa.execute(machine, text)))

    # No non-ASCII in character sets
    # This is not on principle, we just havne't implemented it yet,
    # and want to make sure we don't produce wrong results.
    @test_throws Exception re.parse("[ø]")

    # Unicode chars work like concatenated
    machine = compile(re"øæ")
    @test !passes(machine, "æ")
    @test !passes(machine, "ø")
    @test passes(machine, "øæ")
    @test passes(machine, collect(codeunits("øæ")))

    # Byte ranges
    machine = compile(re"[\x1a-\x29\xaa-\xf0]+")
    @test passes(machine, "\xd0\xe9")
    @test !passes(machine, "")
    @test passes(machine, "\x20\xaa\xf0")
    @test !passes(machine, "\x20\xaa\xf1")
end

end # module

module Test05

using Automa
using Test

@testset "Test05" begin
    re = Automa.RegExp

    keyword = re"if|else|end|while"
    ident = re.diff(re"[a-z]+", keyword)
    token = re.alt(keyword, ident)

    onexit!(keyword, :keyword)
    onexit!(ident, :ident)

    machine = Automa.compile(token)

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        code = Automa.generate_code(ctx, machine, :debug)
        validate = @eval function (data)
            logger = Symbol[]
            $(code)
            return cs == 0, logger
        end
        @test validate(b"if") == (true, [:keyword])
        @test validate(b"else") == (true, [:keyword])
        @test validate(b"end") == (true, [:keyword])
        @test validate(b"while") == (true, [:keyword])
        @test validate(b"e") == (true, [:ident])
        @test validate(b"eif") == (true, [:ident])
        @test validate(b"i") == (true, [:ident])
        @test validate(b"iff") == (true, [:ident])
        @test validate(b"1if") == (false, [])
    end
end

end

module Test16

using Automa
using Test

@testset "Test16" begin
    re = re"A+(B+C)*(D|E)+"
    machine = Automa.compile(re)
    ctx = Automa.CodeGenContext(generator=:goto)
    code = 
    validate = @eval function (data)
        $(Automa.generate_init_code(ctx, machine))
        $(Automa.generate_exec_code(ctx, machine))
        return cs == 0
    end
    @test validate(b"ABCD")
    @test validate(b"AABCD")
    @test validate(b"AAABBCD")
    @test validate(b"AAAABCD")
    @test validate(b"AAAABBBBBCD")
    @test validate(b"AAAAAAAAAAAAAABBBBBCBCBBBBBBBBCDE")
    @test validate(b"AAAAAAAAAAAAAABBBBBCBCBBBBBBBBCDEDDDDDDEDEDDDEEEEED")
end

end

# Action
# ======

# The name is used by the user to refer to actions in the action_dict.
# The order is the order in which actions assigned to the same transition
# is executed
struct Action
    name::Symbol
    order::Int
end

# An action list type.
# * Action names are unique.
# * Actions are sorted by its order.
struct ActionList
    actions::Vector{Action}

    function ActionList(actions::Vector{Action}=Action[])
        list = new(Action[])
        union!(list, actions)
        return list
    end
end

function Base.:(==)(l1::ActionList, l2::ActionList)
    if length(l1) != length(l2)
        return false
    end
    for i in 1:lastindex(l1.actions)
        if l1.actions[i].name != l2.actions[i].name
            return false
        end
    end
    return true
end

function Base.hash(list::ActionList, h::UInt)
    for a in list
        h = xor(h, hash(a.name))
    end
    return h
end

function Base.push!(list::ActionList, action::Action)
    i = findfirst(a -> a.name == action.name, list.actions)
    if i !== nothing
        if action.order < list.actions[i].order
            list.actions[i] = action  # replace
        end
    else
        push!(list.actions, action)
    end
    sort!(list.actions, by=a->a.order)
    return list
end

function Base.union!(list::ActionList, actions::Union{ActionList,Vector{Action}})
    for a in actions
        push!(list, a)
    end
    return list
end

function Base.length(list::ActionList)
    return length(list.actions)
end

function Base.iterate(list::ActionList, i=1)
    if i > length(list.actions)
        return nothing
    end
    return list.actions[i], i + 1
end

function action_names(list::ActionList)
    return [a.name for a in list.actions]
end

module TestByteSet

using Automa: Automa, ByteSet
using Test


function test_membership(members)
    bs = ByteSet(members)
    refset = Set{UInt8}([UInt8(i) for i in  members])
    @test refset == Set{UInt8}(collect(bs))
    @test all(i -> in(i, bs), refset)
end

function test_inversion(bs)
    inv = ~bs
    all = true
    for i in 0x00:0xff
        all &= (in(i, bs) ⊻ in(i, inv))
    end
    @test all
end

@testset "Instantiation" begin
    @test isempty(ByteSet())
    @test iszero(length(ByteSet()))

    for set in ["hello", "kdjy82zxxcbnpw", [0x00, 0x1a, 0xff, 0xf8, 0xd2]]
        test_membership(set)
    end
end

@testset "Min/max" begin
    @test_throws ArgumentError maximum(ByteSet())
    @test_throws ArgumentError minimum(ByteSet())
    @test minimum(ByteSet("xylophone")) == UInt8('e')
    @test maximum(ByteSet([0xa1, 0x0f, 0x4e, 0xf1, 0x40, 0x39])) == 0xf1
end

@testset "Contiguity" begin
    @test Automa.is_contiguous(ByteSet(0x03:0x41))
    @test Automa.is_contiguous(ByteSet())
    @test Automa.is_contiguous(ByteSet(0x51))
    @test Automa.is_contiguous(ByteSet(0xc1:0xd2))
    @test Automa.is_contiguous(ByteSet(0x00:0xff))

    @test !Automa.is_contiguous(ByteSet([0x12:0x3a; 0x3c:0x4a]))
    @test !Automa.is_contiguous(ByteSet([0x01, 0x02, 0x04, 0x05]))
end

@testset "Inversion" begin
    test_inversion(ByteSet())
    test_inversion(ByteSet(0x00:0xff))
    test_inversion(ByteSet([0x04, 0x06, 0x91, 0x92]))
    test_inversion(ByteSet(0x54:0x71))
    test_inversion(ByteSet(0x12:0x11))
    test_inversion(ByteSet("abracadabra"))
end

@testset "Set operations" begin
    sets = map(ByteSet, [
        [],
        [0x00:0xff;],
        [0x00:0x02; 0x04; 0x19],
        [0x01; 0x03; 0x09; 0xa1; 0xa1],
        [0x41:0x8f; 0xd1:0xe1; 0xa0:0xf0],
        [0x81:0x89; 0xd0:0xd0]
    ])
    ssets = map(Set, sets)
    for (s1, ss1) in zip(sets, ssets), (s2, ss2) in zip(sets, ssets)
        for f in [union, intersect, symdiff, setdiff]
            @test Set(f(s1, s2)) == f(ss1, ss2)
        end
        @test isdisjoint(s1, s2) == isdisjoint(ss1, ss2)
    end
end

end # module

module Automa

using TranscodingStreams: TranscodingStreams, TranscodingStream, NoopStream

include("byteset.jl")

# Encode a byte set into a sequence of non-empty ranges.
function range_encode(set::ByteSet)
    result = UnitRange{UInt8}[]
    it = iterate(set)
    it === nothing && return result
    start, state = it
    lastbyte = byte = start
    it = iterate(set)
    while it !== nothing
        byte, state = it
        if byte > lastbyte + 1
            push!(result, start:lastbyte)
            start = byte
        end
        lastbyte = byte
        it = iterate(set, state)
    end
    push!(result, start:byte)
    return result
end

include("re.jl")
include("precond.jl")
include("action.jl")
include("edge.jl")
include("nfa.jl")
include("dfa.jl")
include("machine.jl")
include("traverser.jl")
include("dot.jl")
include("memory.jl")
include("codegen.jl")
include("tokenizer.jl")
include("stream.jl")

using .RegExp: RE, @re_str, opt, rep, rep1, onenter!, onexit!, onall!, onfinal!, precond!

include("workload.jl")

# This list of exports lists the API
export CodeGenContext,
    Variables,
    Tokenizer,
    tokenize,
    compile,

    # user-facing generator functions
    generate_buffer_validator,
    generate_init_code,
    generate_exec_code,
    generate_code,
    generate_reader,
    generate_io_validator,
    make_tokenizer,

    # cat and alt is not exported in favor of * and |
    RE,
    @re_str,
    opt,
    rep,
    rep1,
    onexit!,
    onenter!,
    onall!,
    onfinal!,
    precond!,

    # Debugging functionality
    machine2dot

end # module

module Test02

using Automa
using Test

@testset "Test02" begin
    a = rep('a')
    b = 'b' * rep('b')
    ab = a * b
    abc = ab * 'c'

    onenter!(a, :enter_a)
    onexit!(a, :exit_a)
    onenter!(b, :enter_b)
    onexit!(b, :exit_b)
    onenter!(ab, :enter_ab)
    onexit!(ab, :exit_ab)
    onfinal!(abc, :final_abc)

    machine = Automa.compile(ab | abc)

    last, actions = Automa.execute(machine, "abc")
    @test last == 0
    @test actions == [:enter_ab,:enter_a,:exit_a,:enter_b,:exit_b,:exit_ab, :final_abc]

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        code = (Automa.generate_code(ctx, machine, :debug))
        validate = @eval function (data)
            logger = Symbol[]
            $(code)
            return cs == 0, logger
        end
        @test validate(b"b") == (true, [:enter_ab,:enter_a,:exit_a,:enter_b,:exit_b,:exit_ab])
        @test validate(b"a") == (false, [:enter_ab,:enter_a])
        @test validate(b"ab") == (true, [:enter_ab,:enter_a,:exit_a,:enter_b,:exit_b,:exit_ab])
        @test validate(b"abb") == (true, [:enter_ab,:enter_a,:exit_a,:enter_b,:exit_b,:exit_ab])
        @test validate(b"aabc") == (true, [:enter_ab, :enter_a, :exit_a, :enter_b, :exit_b, :exit_ab, :final_abc])
    end
end

end

using Documenter
using Automa

DocMeta.setdocmeta!(Automa, :DocTestSetup, :(using Automa); recursive=true)

#include("create_pngs.jl")

makedocs(
    sitename = "Automa.jl",
    modules = [Automa],
    pages = [
        "Home" => "index.md",
        "Theory" => "theory.md",
        "Regex" => "regex.md",
        "Validators" => "validators.md",
        "Tokenizers" => "tokenizer.md",
        "Parsing buffers" => "parser.md",
        "Customizing codegen" => "custom.md",
        "Parsing IOs" => "io.md",
        "Creating readers" => "reader.md",
        "Debugging Automa" => "debugging.md",
        ],
    format = Documenter.HTML(
        prettyurls = get(ENV, "CI", nothing) == "true"
    ),
    checkdocs = :exports
)

deploydocs(
    repo = "github.com/BioJulia/Automa.jl.git",
    push_preview = true 
)

struct ByteSet <: AbstractSet{UInt8}
    data::NTuple{4, UInt64}
    ByteSet(x::NTuple{4, UInt64}) = new(x)
end

ByteSet() = ByteSet((UInt64(0), UInt64(0), UInt64(0), UInt64(0)))
Base.length(s::ByteSet) = mapreduce(count_ones, +, s.data)
Base.isempty(s::ByteSet) = s === ByteSet()

function ByteSet(it)
    a = b = c = d = UInt64(0)
    for i in it
        vi = convert(UInt8, i)
        if vi < 0x40
            a |= UInt(1) << ((vi - 0x00) & 0x3f)
        elseif vi < 0x80
            b |= UInt(1) << ((vi - 0x40) & 0x3f)
        elseif vi < 0xc0
            c |= UInt(1) << ((vi - 0x80) & 0x3f)
        else
            d |= UInt(1) << ((vi - 0xc0) & 0x3f)
        end
    end
    ByteSet((a, b, c, d))
end

function Base.minimum(s::ByteSet)
    y = iterate(s)
    y === nothing ? Base._empty_reduce_error() : first(y)
end

function Base.maximum(s::ByteSet)
    offset = 0x03 * UInt8(64)
    for i in 0:3
        @inbounds bits = s.data[4 - i]
        iszero(bits) && continue
        return ((3-i)*64 + (64 - leading_zeros(bits)) - 1) % UInt8
    end
    Base._empty_reduce_error()
end

function Base.in(byte::UInt8, s::ByteSet)
    i, o = divrem(byte, UInt8(64))
    @inbounds !(iszero(s.data[i & 0x03 + 0x01] >>> (o & 0x3f) & UInt(1)))
end

@inline function Base.iterate(s::ByteSet, state=UInt(0))
    ioffset, offset = divrem(state, UInt(64))
    n = UInt(0)
    while iszero(n)
        ioffset > 3 && return nothing
        n = s.data[ioffset + 1] >>> offset
        offset *= !iszero(n)
        ioffset += 1
    end
    tz = trailing_zeros(n)
    result = (64 * (ioffset - 1) + offset + tz) % UInt8
    (result, UInt(result) + UInt(1))
end

function Base.:~(s::ByteSet)
    a, b, c, d = s.data
    ByteSet((~a, ~b, ~c, ~d))
end

is_contiguous(s::ByteSet) = isempty(s) || (maximum(s) - minimum(s) + 1 == length(s))

Base.union(a::ByteSet, b::ByteSet) = ByteSet(map(|, a.data, b.data))
Base.intersect(a::ByteSet, b::ByteSet) = ByteSet(map(&, a.data, b.data))
Base.symdiff(a::ByteSet, b::ByteSet) = ByteSet(map(⊻, a.data, b.data))
Base.setdiff(a::ByteSet, b::ByteSet) = ByteSet(map((i,j) -> i & ~j, a.data, b.data))
Base.isdisjoint(a::ByteSet, b::ByteSet) = isempty(intersect(a, b))

module Test06

using Automa
using Test

@testset "Test06" begin
    re = Automa.RegExp

    foo = re.cat("foo")
    foos = re.rep(re.cat(foo, re" *"))
    onexit!(foo, :foo)
    actions = Dict(:foo => :(push!(ret, state.p:p-1); @escape))

    machine = Automa.compile(foos)

    @eval mutable struct MachineState
        p::Int
        cs::Int
        function MachineState(data)
            $(Automa.generate_init_code(machine))
            return new(p, cs)
        end
    end

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        run! = @eval function (state, data)
            ret = []
            $(Automa.generate_init_code(machine))
            p = state.p
            cs = state.cs
            $(Automa.generate_exec_code(machine, actions))
            state.p = p
            state.cs = cs
            return ret
        end
        data = b"foo foofoo   foo"
        state = MachineState(data)
        @test run!(state, data) == [1:3]
        @test run!(state, data) == [5:7]
        @test run!(state, data) == [9:10]
        @test run!(state, data) == [12:16]
        @test run!(state, data) == []
        @test run!(state, data) == []
    end
end

end

# DOT Language
# ============

function nfa2dot(nfa::NFA)
    out = IOBuffer()
    println(out, "digraph {")
    println(out, "  graph [ rankdir = LR ];")
    println(out, "  0 -> 1;")
    println(out, "  0 [ shape = point ];")
    serials = Dict(s => i for (i, s) in enumerate(traverse(nfa.start)))
    for s in keys(serials)
        println(out, "  $(serials[s]) [ shape = $(s == nfa.final ? "doublecircle" : "circle") ];")
        for (e, t) in s.edges
            println(out, " $(serials[s]) -> $(serials[t]) [ label = \"$(edge2str(e))\" ];")
        end
    end
    println(out, "}")
    return String(take!(out))
end

function dfa2dot(dfa::DFA)
    out = IOBuffer()
    println(out, "digraph {")
    println(out, "  graph [ rankdir = LR ];")
    println(out, "  start -> 1;")
    println(out, "  start [ shape = point ];")
    serials = Dict(s => i for (i, s) in enumerate(traverse(dfa.start)))
    for s in keys(serials)
        println(out, "  $(serials[s]) [ shape = $(s.final ? "doublecircle" : "circle") ];")
        for (e, t) in s.edges
            println(out, "  $(serials[s]) -> $(serials[t]) [ label = \"$(edge2str(e))\" ];")
        end
        if !isempty(s.eof_actions)
            println(out, "  eof$(serials[s]) [ shape = point ];")
            println(out, "  $(serials[s]) -> eof$(serials[s]) [ label = \"$(eof_label(s.eof_actions))\", style = dashed ];")
        end
    end
    println(out, "}")
    return String(take!(out))
end

"""
    machine2dot(machine::Machine)::String

Return a String with a flowchart of the machine in Graphviz (dot) format.
Using `Graphviz`, a command-line tool, the dot file can be converted to various
picture formats.

# Example
```julia
open("/tmp/machine.dot", "w") do io
    println(io, machine2dot(machine))
end
# Requires graphviz to be installed
run(pipeline(`dot -Tsvg /tmp/machine.dot`), stdout="/tmp/machine.svg")
```
"""
function machine2dot(machine::Machine)
    out = IOBuffer()
    println(out, "digraph {")
    println(out, "  graph [ rankdir = LR ];")
    println(out, "  start -> 1;")
    println(out, "  start [ shape = point ];")
    for s in traverse(machine.start)
        println(out, "  $(s.state) [ shape = $(s.state ∈ machine.final_states ? "doublecircle" : "circle") ];")
        for (e, t) in s.edges
            println(out, "  $(s.state) -> $(t.state) [ label = \"$(edge2str(e))\" ];")
        end
        if haskey(machine.eof_actions, s.state) && !isempty(machine.eof_actions[s.state])
            println(out, "  eof$(s.state) [ shape = point ];")
            println(out, "  $(s.state) -> eof$(s.state) [ label = \"$(eof_label(machine.eof_actions[s.state]))\", style = dashed ];")
        end
    end
    println(out, "}")
    return String(take!(out))
end

function edge2str(edge::Edge)
    out = IOBuffer()

    function printbyte(b, inrange)
        # TODO: does this work?
        if inrange && b == UInt8('-')
            print(out, "\\\\-")
        elseif inrange && b == UInt8(']')
            print(out, "\\\\]")
        else
            s = if b ≤ 0x7f
                escape_string(string(Char(b)))
            else
                "\\x" * string(b; base=16)
            end
            print(out, escape_string(s))
        end
    end

    # output labels
    if isempty(edge.labels)
        print(out, 'ϵ')
    elseif length(edge.labels) == 1
        print(out, '\'')
        printbyte(first(edge.labels), false)
        print(out, '\'')
    else
        print(out, '[')
        for r in range_encode(edge.labels)
            if length(r) == 1
                printbyte(first(r), true)
            elseif length(r) == 2
                printbyte(first(r), true)
                printbyte(last(r), true)
            else
                @assert length(r) > 1
                printbyte(first(r), true)
                print(out, '-')
                printbyte(last(r), true)
            end
        end
        print(out, ']')
    end

    # output conditions
    if !isempty(edge.precond)
        print(out, '(')
        join(out, ((value == NONE ? "false" : value == TRUE ? name : value == FALSE ? string("!", name) : "true") for (name, value) in edge.precond), ',')
        print(out, ')')
    end

    # output actions
    if !isempty(edge.actions)
        print(out, '/')
        join(out, action_names(edge.actions), ',')
    end

    return String(take!(out))
end

function eof_label(actions::ActionList)
    out = IOBuffer()
    print(out, "EOF")
    if !isempty(actions)
        print(out, '/')
        join(out, action_names(actions), ',')
    end
    return String(take!(out))
end

# There are other tokenizer tests, e.g. test09 and in runtests
module TestTokenizer

using Automa
using Test

@testset "Tokenizer" begin
    # TODO: This could be a loop over (false, true),
    # but Julia #51267 prevents this for now
    make_tokenizer([
        re"ADF",
        re"[A-Z]+",
        re"[abcde]+",
        re"abc",
        re"ab[a-z]"
    ]; goto=false, version=1) |> eval

    make_tokenizer([
        re"ADF",
        re"[A-Z]+",
        re"[abcde]+",
        re"abc",
        re"ab[a-z]"
    ]; goto=true, version=2) |> eval

    for f in (
        (i -> collect(tokenize(UInt32, i, 1))),
        (i -> collect(tokenize(UInt32, i, 2)))
    )
        # Empty
        @test f("") == []

        # Only error
        @test f("!"^11) == [(1, 11, 0)]

        # Longest token wins
        @test f("abca") == [(1, 4, 3)]
        @test f("ADFADF") == [(1, 6, 2)]
        @test f("AD") == [(1, 2, 2)]

        # Ties are broken with last token
        @test f("ADF") == [(1, 3, 2)]
        @test f("abc") == [(1, 3, 5)]
        @test f("abe") == [(1, 3, 5)]
    end
end

end # module

module Test03

using Automa
using Test

@testset "Test03" begin
    re = Automa.RegExp
    header = re"[ -~]*"
    newline = re"\r?\n"
    sequence = re.rep(re.cat(re"[A-Za-z]*", newline))
    fasta = re.rep(re.cat('>', header, newline, sequence))

    machine = Automa.compile(fasta)

    for generator in (:table, :goto), clean in (true, false)
        ctx = Automa.CodeGenContext(generator=generator, clean=clean)
        init_code = Automa.generate_init_code(ctx, machine)
        exec_code = Automa.generate_exec_code(ctx, machine)
        validate = @eval function (data)
            $(init_code)
            $(exec_code)
            return cs == 0
        end
        @test validate(b"") == true
        @test validate(b">\naa\n") == true
        @test validate(b">seq1\n") == true
        @test validate(b">seq1\na\n") == true
        @test validate(b">seq1\nac\ngt\n") == true
        @test validate(b">seq1\r\nacgt\r\n") == true
        @test validate(b">seq1\nac\n>seq2\ngt\n") == true
        @test validate(b"a") == false
        @test validate(b">") == false
        @test validate(b">seq1\na") == false
        @test validate(b">seq1\nac\ngt") == false
    end
end

end

module Test12

using Automa
using Test

@testset "Test12" begin
    a = re"a*"
    onall!(a, :a)
    machine = compile(a)

    @eval function validate(data)
        logger = Symbol[]
        $(generate_code(CodeGenContext(), machine, :debug))
        return logger, cs == 0 ? :ok : cs < 0 ? :error : :incomplete
    end
    @test validate(b"") == ([], :ok)
    @test validate(b"a") == ([:a], :ok)
    @test validate(b"aa") == ([:a, :a], :ok)
    @test validate(b"aaa") == ([:a, :a, :a], :ok)
    @test validate(b"aaab") == ([:a, :a, :a], :error)
end

end

# Edge
# ====

# An edge connects two nodes in the FSM. The labels is a set of bytes that, if the
# input is in that set, the edge may be taken.
# Precond is like an if-statement, if that condition is fulfilled, take the edge
# The actions is a list of names of Julia code to execute, if edge is taken.
struct Edge
    labels::ByteSet
    precond::Precondition
    actions::ActionList
end

function Edge(labels::ByteSet)
    return Edge(labels, Precondition(), ActionList())
end

function Edge(labels::ByteSet, actions::ActionList)
    return Edge(labels, Precondition(), actions)
end

# Don't override isless, because I don't want to figure out how
# to hash correctly. It's fine, we only use this for sorting in order_machine
# The criterion is arbitrary, but ordering must be transitive,
# and this function must deterministically return a Bool when comparing
# two edges from the same node in a Machine
function in_sort_order(e1::Edge, e2::Edge)
    # First check labels
    lab1, lab2 = e1.labels, e2.labels
    len1, len2 = length(lab1), length(lab2)
    len1 < len2 && return true
    len2 < len1 && return false
    for (i,j) in zip(lab1, lab2)
        i < j && return true
        j < i && return false
    end

    # Then check preconditions
    p1, p2 = e1.precond, e2.precond
    lp1, lp2 = length(p1.names), length(p2.names)
    lp1 < lp2 && return true
    lp2 < lp1 && return false
    for i in 1:min(lp1, lp2)
        isless(p1.names[i], p2.names[i]) && return true
        isless(p2.names[i], p1.names[i]) && return false
        u1, u2 = convert(UInt8, p1.values[i]), convert(UInt8, p2.values[i])
        u1 < u2 && return true
        u2 < u1 && return false
    end

    # A machine should never have two indistinguishable edges
    # so if we reach here, something went wrong.
    error()
end

using Automa

# Create an enum to store the tokens in. I define the enum in its own module
# in order to not clutter the Main namespace with all the variants.
module Tokens
    using Automa
    minijulia = [
        :identifier   => re"[A-Za-z_][0-9A-Za-z_!]*",
        :comma        => re",",
        :colon        => re":",
        :semicolon    => re";",
        :dot          => re"\.",
        :question     => re"\?",
        :equal        => re"=",
        :lparen       => re"\(",
        :rparen       => re"\)",
        :lbracket     => re"\[",
        :rbracket     => re"]",
        :lbrace       => re"{",
        :rbrace       => re"}",
        :dollar       => re"$",
        :and          => re"&&",
        :or           => re"\|\|",
        :typeannot    => re"::",
        :keyword      => re"break|const|continue|else|elseif|end|for|function|if|return|type|using|while",
        :operator     => re"-|\+|\*|/|%|&|\||^|!|~|>|<|<<|>>|>=|<=|=>|==|===",
        :macrocall    => re"@" * re"[A-Za-z_][0-9A-Za-z_!]*",
        :integer      => re"[0-9]+",
        :comment      => re"#[^\r\n]*",
        :char         => '\'' * (re"[ -&(-~]" | ('\\' * re"[ -~]")) * '\'',
        :string       => '"' * rep(re"[ !#-~]" | re"\\\\\"") * '"',
        :triplestring => "\"\"\"" * (re"[ -~]*" \ re"\"\"\"") * "\"\"\"",
        :newline      => re"\r?\n",
        :spaces       => re"[\t ]+",
    ]
    @eval @enum Token error $(first.(minijulia)...)
    export Token
end

using .Tokens: Token

make_tokenizer((
    Tokens.error,
    [Tokens.Token(i) => regex for (i, regex) in enumerate(last.(Tokens.minijulia))]
)) |> eval

code = """
quicksort(xs) = quicksort!(copy(xs))
quicksort!(xs) = quicksort!(xs, 1, length(xs))

function quicksort!(xs, lo, hi)
    if lo < hi
        p = partition(xs, lo, hi)
        quicksort!(xs, lo, p - 1)
        quicksort!(xs, p + 1, hi)
    end
    return xs
end

function partition(xs, lo, hi)
    pivot = div(lo + hi, 2)
    pvalue = xs[pivot]
    xs[pivot], xs[hi] = xs[hi], xs[pivot]
    j = lo
    @inbounds for i in lo:hi-1
        if xs[i] <= pvalue
            xs[i], xs[j] = xs[j], xs[i]
            j += 1
        end
    end
    xs[j], xs[hi] = xs[hi], xs[j]
    return j
end
"""

# For convenience, let's convert it to (string, token) tuples
# even though it's inefficient to store them as individual strings
tokens = map(tokenize(Token, code)) do (start, len, token)
    (code[start:start+len-1], token)
end

using Automa
using Automa.RegExp: @re_str
const re = Automa.RegExp

ab = re"ab*"
c = re"c"
pattern = re.cat(ab, c)

ab.actions[:enter] = [:enter_ab]
ab.actions[:exit]  = [:exit_ab]
ab.actions[:all]   = [:all_ab]
onfinal!(ab, :final_ab)
c.actions[:enter]  = [:enter_c]
c.actions[:exit]   = [:exit_c]
c.actions[:final]  = [:final_c]

write("actions.dot", Automa.machine2dot(Automa.compile(pattern)))
run(`dot -Tpng -o src/figure/actions.png actions.dot`)

# Node Traverser
# ==============

struct Traverser{T}
    start::T
end

function Base.eltype(::Type{Traverser{T}}) where T
    return T
end

function Base.IteratorSize(::Type{Traverser{T}}) where T
    return Base.SizeUnknown()
end

function traverse(start::Union{NFANode,DFANode,Node})
    return Traverser(start)
end

function Base.iterate(t::Traverser{T}, state=nothing) where T
    if state === nothing
        state = (visited = Set{T}(), unvisited = [t.start])
    end
    if isempty(state.unvisited)
        return nothing
    end
    s = pop!(state.unvisited)
    push!(state.visited, s)
    for (_, t) in s.edges
        if t ∉ state.visited && t ∉ state.unvisited
            push!(state.unvisited, t)
        end
    end
    return s, state
end

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Parsing from an IO
Some file types are gigabytes or tens of gigabytes in size.
For these files, parsing from a buffer may be impractical, as they require you to read in the entire file in memory at once.
Automa enables this by hooking into `TranscodingStreams.jl`, a package that provides a wrapper IO of the type `TranscodingStream`.
Importantly, these streams buffer their input data.
Automa is thus able to operate directly on the input buffers of `TranscodingStream` objects.

Unfortunately, this _significantly_ complicates things compared to parsing from a simple buffer.
The main problem is that, when reading from a buffered stream, the byte array visible from `Automa` is only a small slice of the total input data.
Worse, when the end of the stream is reached, data from the buffer is flushed, i.e. removed from the stream.
To handle this, Automa must reach deep into the implementation details of `TranscodingStreams`, and also break some of its own abstractions.
It's not pretty, but it's what we have.

Practically speaking, parsing from IO is done with the function `Automa.generate_reader`.
Despite its name, this function is NOT directly used to generate objects like `FASTA.Reader`.
Instead, this function produces Julia code (an `Expr` object) that, when evaluated, defines a function that can execute an Automa machine on an IO.
Let me first show the code generated by `generate_reader` in pseudocode format:

```
function { function name }(stream::TranscodingStream, { args... })
    { init code }

    @label __exec__

    p = current buffer position
    p_end = final buffer position

    # the eof call below will first flush any used data from buffer,
    # then load in new data, before checking if it's really eof.
    is_eof = eof(stream)
    execute normal automa parsing of the buffer
    update buffer position to match p

    { loop code }

    if cs < 0 # meaning: erroneous input or erroneous EOF
        { error code }
    end

    if machine errored or reached EOF
        @label __return__
        { return code }
    end
    @goto __exec__
end
```

The content marked `{ function name }`, `{ args... }`, `{ init code }`, `{ loop code }`, `{ error code }` and `{ return code }` are arguments provided to `Automa.generate_reader`.
By providing these, the user can customize the generated function further.

The main difference from the code generated to parse a buffer is the label/GOTO pair `__exec__`, which causes Automa to repeatedly load data into the buffer, execute the machine, then flush used data from the buffer, then execute the machine, and so on, until interrupted.

Importantly, when parsing from a buffer, `p` and `p_end` refer to the position _in the current buffer_.
This may not be the position in the stream, and when the data in the buffer is flushed, it may move the data in the buffer so that `p` now become invalid.
This means you can't simply store a variable `marked_pos` that points to the current value of `p` and expect that the same data is at that position later.
Furthermore, `is_eof` is set to whether the stream has reached EOF.

## Example use
Let's show the simplest possible example of such a function.
We have a `Machine` (which, recall, is a compiled regex) called `machine`, and we want to make a function that returns `true` if a given `IO` contain data that conforms to the regex format specified by the `Machine`.

We will still use the machine from before, just without any actions:

```jldoctest io1; output = false
machine = let
    header = re"[a-z]+"
    seqline = re"[ACGT]+"
    record = re">" * header * '\n' * rep1(seqline * '\n')
    compile(rep(record))
end
@assert machine isa Automa.Machine

# output

```

To create our simple IO reader, we simply need to call `generate_reader`, where the `{ return code }` is a check if `iszero(cs)`, meaning if the machine exited at a proper exit state.
We also need to set `error_code` to an empty expression in order to prevent throwing an error on invalid code. Instead, we want it to go immediately to return - we call this section `__return__`, so we need to `@goto __return__`.
Then, we need to evaluate the code created by `generate_reader` in order to define the function `validate_fasta`

```jldoctest io1
julia> return_code = :(iszero(cs));

julia> error_code = :(@goto __return__);

julia> eval(generate_reader(:validate_fasta,  machine; returncode=return_code, errorcode=error_code));
```

The generated function `validate_fasta` has the function signature:
`validate_fasta(stream::TranscodingStream)`.
If our input IO is not a `TranscodingStream`, we can wrap it in the relatively lightweight `NoopStream`, which, as the name suggests, does nothing to the data:

```jldoctest io1
julia> io = NoopStream(IOBuffer(">a\nTAG\nTA\n>bac\nG\n"));

julia> validate_fasta(io)
true

julia> validate_fasta(NoopStream(IOBuffer("random data")))
false
```

## Reading a single record

!!! danger
    The following code is only for demonstration purposes.
    It has one important flaw, which will be addressed in a later section, so do not copy-paste it for serious work.

There are a few more subtleties related to the `generate_reader` function.
Suppose we instead want to create a function that reads a single FASTA record from an IO.
In this case, it's no good that the function created from `generate_reader` will loop until the IO reaches EOF - we need to find a way to stop it after reading a single record.
We can do this with the pseudomacro `@escape`, as shown below.

We will reuse our `Seq` struct and our `Machine` from the "parsing from a buffer" section of this tutorial:

```jldoctest io2; output = false
struct Seq
    name::String
    seq::String
end

machine = let
    header = onexit!(onenter!(re"[a-z]+", :mark_pos), :header)
    seqline = onexit!(onenter!(re"[ACGT]+", :mark_pos), :seqline)
    record = onexit!(re">" * header * '\n' * rep1(seqline * '\n'), :record)
    compile(rep(record))
end
@assert machine isa Automa.Machine

# output
```

The code below contains `@escape` in the `:record` action - meaning: Break out of machine execution.

```jldoctest io2; output = false
actions = Dict{Symbol, Expr}(
    :mark_pos => :(pos = p),
    :header => :(header = String(data[pos:p-1])),
    :seqline => :(append!(seqbuffer, data[pos:p-1])),

    # Only this action is different from before!
    :record => quote
        seq = Seq(header, String(seqbuffer))
        found_sequence = true
        # Reset p one byte if we're not at the end
        p -= !(is_eof && p > p_end)
        @escape
    end
)
@assert actions isa Dict

# output
```

`@escape` is not actually a real macro, but what Automa calls a "pseudomacro".
It is expanded during Automa's own compiler pass _before_ Julia's lowering.
The `@escape` pseudomacro is replaced with code that breaks it out of the executing machine, without reaching EOF or an invalid byte.

Let's see how I use `generate_reader`, then I will explain each part:

```jldoctest io2; output = false
generate_reader(
    :read_record,
    machine;
    actions=actions,
    initcode=quote
        seqbuffer = UInt8[]
        pos = 0
        found_sequence = false
        header = ""
    end,
    loopcode=quote
        if (is_eof && p > p_end) || found_sequence
            @goto __return__
        end
    end,
    returncode=:(found_sequence ? seq : nothing)
) |> eval

# output
read_record (generic function with 1 method)
```

In the `:record`, action, a few new things happen.
* First, I set the flag `found_sequence = false`.
  In the loop code, I look for this flag to signal that the function should return.
  Remember, the loop code happens after machine execution, which can mean either that the execution was broken out of by `@escape`, or than the buffer ran out and need to be refilled.
  I could just return the sequence directly in the action, but then I would skip a bunch of the code generated by `generate_reader` which sets the buffer state correctly, _so this is never adviced_.
  Instead, in the _loop code_, which executes after the buffer has been flushed, I check for this flag, and goes to `__return__` if necessary.
  I could also just return directly in the loopcode, but I prefer only having one place to retun from the function.
* I use `@escape` to break out of the machine, i.e. stop machine execution
* Finally, I decrement `p`, if and only if the machine has not reached EOF (which happens when `is_eof` is true, meaning the last part of the IO has been buffered, and `p > p_end`, meaning the end of the buffer has been reached).
  This is because, the first record ends when the IO reads the second `>` symbol.
  If I then were to read another record from the same IO, I would have already read the `>` symbol.
  I need to reset `p` by 1, so the `>` is also read on the next call to `read_record`.

I can use the function like this:

```jldoctest io2
julia> io = NoopStream(IOBuffer(">a\nT\n>tag\nGAGA\nTATA\n"));

julia> read_record(io)
Seq("a", "T")

julia> read_record(io)
Seq("tag", "GAGATATA")

julia> read_record(io)
```

## Preserving data by marking the buffer
There are several problems with the implementation above: The following code in my actions dict:

```julia
header = String(data[pos:p-1])
```

Creates `header` by accessing the data buffer.
However, when reading an IO, how can I know that the data hasn't shifted around in the buffer between when I defined `pos`?
For example, suppose we have a short buffer of only 8 bytes, and the following FASTA file: `>abcdefghijkl\nA`.
Then, the buffer is first filled with `>abcdefg`.
When entering the header, I execute the action `:mark_position` at `p = 2`, so `pos = 2`.
But now, when I reach the end of the header, the used data in the buffer has been flushed, and the data is now:
`hijkl\nA`, and `p = 14`.
I then try to access `data[2:13]`, which is out of bounds!

Luckily, the buffers of `TranscodingStreams` allow us to "mark" a position to save it.
The buffer will not flush the marked position, or any position after the marked position.
If necessary, it will resize the buffer to be able to load more data while keeping the marked position.

Inside the function generated by `generate_reader`, we can use the zero-argument pseudomacro `@mark()`, which marks the position `p`.
The macro `@markpos()` can then be used to get the marked position, which will point to the same data in the buffer, even after the data in the buffer has been shifted after it's been flushed.
This works because the mark is stored inside the `TranscodingStream` buffer, and the buffer makes sure to update the mark if the content moves.
Hence, we can re-write the actions:

```julia
actions = Dict{Symbol, Expr}(
    :mark_position => :(@mark),
    :header => :(header = String(data[@markpos():p-1])),
    :seqline => :(append!(buffer, data[@markpos():p-1])),

    [:record action omitted...]
)
```

In our example above with the small 8-byte buffer, this is what would happen:
First, the buffer contains the first 8 bytes.
When `p = 2`, the mark is set, and the second byte is marked::

```
content: >abcdefg
mark:     ^
p = 2     ^
```

Then, when `p = 9` the buffer is exhausted, the used data is removed, BUT, the mark stays, so byte 2 is preserved, and only the first byte is removed.
The code in `generate_reader` loops around to `@label __exec__`, which sets p to the current buffer position.
The buffer now looks like this:

```
content: abcdefgh
mark:    ^
p = 8           ^
```

Only 1 byte was cleared, so when `p = 9`, the buffer will be exhausted again.
This time, no data can be cleared, so instead, the buffer is resized to fit more data:

```
content: abcdefghijkl\nA
mark:    ^
p = 9            ^
```

Finally, when we reach the newline `p = 13`, the whole header is in the buffer, and so `data[@markpos():p-1]` will correctly refer to the header (now, `1:12`).

```
content: abcdefghijkl\nA
mark:    ^
p = 13               ^
```

Remember to update the mark, or to clear it with `@unmark()` in order to be able to flush data from the buffer afterwards.

## Reference
```@docs
Automa.generate_reader
Automa.@escape
Automa.@mark
Automa.@unmark
Automa.@markpos
Automa.@bufferpos
Automa.@relpos
Automa.@abspos
Automa.@setbuffer
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Creating a `Reader` type
The use of `generate_reader` as we learned in the previous section "Parsing from an IO" has an issue we need to address:
While we were able to read multiple records from the reader by calling `read_record` multiple times, no state was preserved between these calls, and so, no state can be preserved between reading individual records.
This is also what made it necessary to clumsily reset `p` after emitting each record.

Imagine you have a format with two kinds of records, A and B types.
A records must come before B records in the file.
Hence, while a B record can appear at any time, once you've seen a B record, there can't be any more A records.
When reading records from the file, you must be able to store whether you've seen a B record.

We address this by creating a `Reader` type which wraps the IO being parsed, and which store any state we want to preserve between records.
Let's stick to our [simplified FASTA format](@ref fasta_example) parsing sequences into `Seq` objects:

```jldoctest reader1; output = false
struct Seq
    name::String
    seq::String
end

machine = let
    header = onexit!(onenter!(re"[a-z]+", :mark_pos), :header)
    seqline = onexit!(onenter!(re"[ACGT]+", :mark_pos), :seqline)
    record = onexit!(re">" * header * '\n' * rep1(seqline * '\n'), :record)
    compile(rep(record))
end
@assert machine isa Automa.Machine

# output

```

This time, we use the following `Reader` type:
```jldoctest reader1; output = false
mutable struct Reader{S <: TranscodingStream}
    io::S
    automa_state::Int
end

Reader(io::TranscodingStream) = Reader{typeof(io)}(io, 1)
Reader(io::IO) = Reader(NoopStream(io))

# output
Reader
```

The `Reader` contains an instance of `TranscodingStream` to read from, and stores the Automa state between records.
The beginning state of Automa is always 1.
We can now create our reader function like below.
There are only three differences from the definitions in the previous section:
* I no longer have the code to decrement `p` in the `:record` action - because we can store the Automa state between records such that the machine can handle beginning in the middle of a record if necessary, there is no need to reset the value of `p` in order to restore the IO to the state right before each record.
* I return `(cs, state)` instead of just `state`, because I want to update the Automa state of the Reader, so when it reads the next record, it begins in the same state where the machine left off from the previous state
* In the arguments, I add `start_state`, and in the `initcode` I set `cs` to the start state, so the machine begins from the correct state

```jldoctest reader1; output = false
actions = Dict{Symbol, Expr}(
    :mark_pos => :(@mark),
    :header => :(header = String(data[@markpos():p-1])),
    :seqline => :(append!(seqbuffer, data[@markpos():p-1])),
    :record => quote
        seq = Seq(header, String(seqbuffer))
        found_sequence = true
        @escape
    end
)

generate_reader(
    :read_record,
    machine;
    actions=actions,
    arguments=(:(start_state::Int),),
    initcode=quote
        seqbuffer = UInt8[]
        found_sequence = false
        header = ""
        cs = start_state
    end,
    loopcode=quote
        if (is_eof && p > p_end) || found_sequence
            @goto __return__
        end
    end,
    returncode=:(found_sequence ? (cs, seq) : throw(EOFError()))
) |> eval

# output
read_record (generic function with 1 method)
```

We then create a function that reads from the `Reader`, making sure to update the `automa_state` of the reader:

```jldoctest reader1; output = false
function read_record(reader::Reader)
    (cs, seq) = read_record(reader.io, reader.automa_state)
    reader.automa_state = cs
    return seq
end

# output
read_record (generic function with 2 methods)
```

Let's test it out:

```jldoctest reader1
julia> reader = Reader(IOBuffer(">a\nT\n>tag\nGAG\nATATA\n"));

julia> read_record(reader)
Seq("a", "T")

julia> read_record(reader)
Seq("tag", "GAGATATA")

julia> read_record(reader)
ERROR: EOFError: read end of file
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Automa.jl
Automa is a regex-to-Julia compiler.
By compiling regex to Julia code in the form of `Expr` objects,
Automa provides facilities to create efficient and robust regex-based lexers, tokenizers and parsers using Julia's metaprogramming capabilities. 
You can view Automa as a regex engine that can insert arbitrary Julia code into its input matching process, which will be executed when certain parts of the regex matches an input.

![Schema of Automa.jl](figure/Automa.png)

Automa.jl is designed to generate very efficient code to scan large text data, which is often much faster than handcrafted code.

## Where to start
If you're not familiar with regex engines, start by reading the [theory section](theory.md),
then you might want to read every section from the top.
They're structured like a tutorial, beginning from the simplest use of Automa and moving to more advanced uses.

If you like to dive straight in, you might want to start by reading the examples below, then go through the examples in the `examples/` directory in the Automa repository.

## Examples
### Validate some text is composed only of ASCII alphanumeric characters
```jldoctest; output = false
generate_buffer_validator(:validate_alphanumeric, re"[a-zA-Z0-9]*") |> eval

for s in ["abc", "aU81m", "!,>"]
    println("$s is alphanumeric? $(isnothing(validate_alphanumeric(s)))")
end

# output
abc is alphanumeric? true
aU81m is alphanumeric? true
!,> is alphanumeric? false
```

### Making a lexer
```jldoctest; output = false
tokens = [
    :identifier => re"[A-Za-z_][0-9A-Za-z_!]*",
    :lparens => re"\(",
    :rparens => re"\)",
    :comma => re",",
    :quot => re"\"",
    :space => re"[\t\f ]+",
];
@eval @enum Token errortoken $(first.(tokens)...)
make_tokenizer((errortoken, 
    [Token(i) => j for (i,j) in enumerate(last.(tokens))]
)) |> eval

collect(tokenize(Token, """(alpha, "beta15")"""))

# output
8-element Vector{Tuple{Int64, Int32, Token}}:
 (1, 1, lparens)
 (2, 5, identifier)
 (7, 1, comma)
 (8, 1, space)
 (9, 1, quot)
 (10, 6, identifier)
 (16, 1, quot)
 (17, 1, rparens)
```

### Make a simple TSV file parser
```jldoctest; output = false
machine = let
    name = onexit!(onenter!(re"[^\t\r\n]+", :mark), :name)
    field = onexit!(onenter!(re"[^\t\r\n]+", :mark), :field)
    nameline = name * rep('\t' * name)
    record = onexit!(field * rep('\t' * field), :record)
    compile(nameline * re"\r?\n" * record * rep(re"\r?\n" * record) * rep(re"\r?\n"))
end

actions = Dict(
    :mark => :(pos = p),
    :name => :(push!(headers, String(data[pos:p-1]))),
    :field => quote
        n_fields += 1
        push!(fields, String(data[pos:p-1]))
    end,
    :record => quote
        n_fields == length(headers) || error("Malformed TSV")
        n_fields = 0
    end
)

@eval function parse_tsv(data)
    headers = String[]
    fields = String[]
    pos = n_fields = 0
    $(generate_code(machine, actions))
    (headers, reshape(fields, length(headers), :))
end

header, data = parse_tsv("a\tabc\n12\t13\r\nxyc\tz\n\n")

# output
(["a", "abc"], ["12" "xyc"; "13" "z"])
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Debugging Automa

!!! danger 
    All Automa's debugging tools are NOT part of the API and are subject to change without warning.
    You can use them during development, but do NOT rely on their behaviour in your final code.

Automa is a complicated package, and the process of indirectly designing parsers by first designing a machine can be error prone.
Therefore, it's crucial to have good debugging tooling.

## Revise
Revise is not able to update Automa-generated functions.
To make your feedback loop faster, you can manually re-run the code that defines the Automa functions - usually this is much faster than modifying the package and reloading it.

## Ambiguity check
It is easy to accidentally create a machine where it is undecidable what actions should be taken.
For example:

```jldoctest
machine = let
    alphabet = re"BC"
    band = onenter!(re"BBA", :cool_band)
    compile(re"XYZ A" * (alphabet | band))
end

# output
ERROR: Ambiguous NFA.
[...]
```

Consider what the machine should do once it observes the two first bytes `AB` of the input:
Is the `B` part of `alphabet` (in which case it should do nothing), or is it part of `band` (in which case it should do the action `:cool_band`)? It's impossible to tell.

Automa will not compile this, and will raise the error:
```
ERROR: Ambiguous NFA.
After inputs "XYZ A", observing 'B' lead to conflicting action sets [:cool_band] and nothing
```

Note the error shows an example input which will trigger the ambiguity: `XYZ A`, then `B`.
By simply running the input through in your head, you may discover yourself how the error happens.

In the example above, the error was obvious, but consider this example:

```jldoctest
fasta_machine = let
    header = re"[a-z]+"
    seq_line = re"[ACGT]+"
    sequence = seq_line * rep('\n' * seq_line)
    record = onexit!('>' * header * '\n' * sequence, :emit_record)
    compile(rep(record * '\n') * opt(record))
end

# output
ERROR: Ambiguous NFA.
[...]
```

It's the same problem: After a sequence line you observe `\n`: Is this the end of the sequence, or just a newline before another sequence line?

To work around it, consider when you know _for sure_ you are out of the sequence: It's not before you see a new `>`, or end-of-file.
In a sense, the trailing `\n` really IS part of the sequence.
So, really, your machine should regex similar to this

```jldoctest debug1; output = false
fasta_machine = let
    header = re"[a-z]+"
    seq_line = re"[ACGT]+"
    sequence = rep1(seq_line * '\n')
    record = onexit!('>' * header * '\n' * sequence, :emit_record)

    # A special record that can avoid a trailing newline, but ONLY if it's the last record
    record_eof = '>' * header * '\n' * seq_line * rep('\n' * seq_line) * opt('\n')
    compile(rep(record * '\n') * opt(record_eof))
end
@assert fasta_machine isa Automa.Machine

# output

```

When all else fails, you can also pass `unambiguous=false` to the `compile` function - but beware!
Ambiguous machines has undefined behaviour if you get into an ambiguous situation.

## Create `Machine` flowchart
The function `machine2dot(::Machine)` will return a string with a Graphviz `.dot` formatted flowchart of the machine.
Graphviz can then convert the dot file to an SVG function.

On my computer (with Graphviz and Firefox installed), I can use the following Julia code to display a flowchart of a machine.
Note that `dot` is the command-line name of Graphviz.

```julia
function display_machine(m::Machine)
    open("/tmp/machine.dot", "w") do io
        println(io, Automa.machine2dot(m))
    end
    run(pipeline(`dot -Tsvg /tmp/machine.dot`, stdout="/tmp/machine.svg"))
    run(`firefox /tmp/machine.svg`)
end
```

The following function are Automa internals, but they might help with more advanced debugging:
* `re2nfa` - create an NFA from an Automa regex
* `nfa2dot` - create a dot-formatted string from an nfa
* `nfa2dfa` - create a DFA from an NFA
* `dfa2dot` - create a dot-formatted string from a DFA

## Running machines in debug mode
The function `generate_code` takes an argument `actions`. If this is `:debug`, then all actions in the given `Machine` will be replaced by `:(push!(logger, action_name))`.
Hence, given a FASTA machine, you could create a debugger function:

```jldoctest debug1; output = false
 @eval function debug(data)
    logger = []
    $(generate_code(fasta_machine, :debug))
    logger
end

# output
debug (generic function with 1 method)
```

Then see all the actions executed in order, by doing:

```julia
julia> debug(">abc\nTAG")
4-element Vector{Any}:
 :mark
 :header
 :mark
 :seqline
 :record
```

Note that if your machine relies on its actions to work correctly, for example by actions modifying `p`,
this kind of debugger will not work, as it replaces all actions.

## More advanced debugging
The file `test/debug.jl` contains extra debugging functionality and may be `include`d.
In particular it defines the functions `debug_execute` and `create_debug_function`.

The function of `create_debug_function(::Machine; ascii=false)` is best demonstrated:

```julia
machine = let
    letters = onenter!(re"[a-z]+", :enter_letters)
    compile(onexit!(letters * re",[0-9]," * letters, :exiting_regex))
end
eval(create_debug_function(machine; ascii=true))
(end_state, transitions) = debug_compile("abc,5,d!")
@show end_state
transitions
```

Will create the following output:
```
end state = -6
7-element Vector{Tuple{Char, Int64, Vector{Symbol}}}:
 ('a', 2, [:enter_letters])
 ('b', 2, [])
 ('c', 2, [])
 (',', 3, [])
 ('5', 4, [])
 (',', 5, [])
 ('d', 6, [:enter_letters])
```

Where each 3-tuple in the input corresponds to the input byte (displayed as a `Char` if `ascii` is set to `true`), the Automa state reached on reading the letter, and the actions executed.

The `debug_execute` function works the same as the `debug_compile`, but does not need to be generated first, and can be run directly on an Automa regex:

```julia
julia> debug_execute(re"[A-z]+", "abc1def"; ascii=true)
(-3, Tuple{Union{Nothing, Char}, Int64, Vector{Symbol}}[('a', 2, []), ('b', 3, []), ('c', 3, [])])
```

```@docs
machine2dot
```

# Theory of regular expressions
Most programmers are familiar with _regular expressions_, or _regex_, for short.
What many programmers don't know is that regex have a deep theoretical underpinning, which is leaned on by regex engines to produce highly efficient code.

Informally, a regular expression can be thought of as any pattern that can be constructed from the following atoms:
* The empty string is a valid regular expression, i.e. `re""`
* Literal matching of a single symbol from a finite alphabet, such as a character, i.e. `re"p"`

Atoms can be combined with the following operations, if R and P are two regular expressions:
* Alternation, i.e `R | P`, meaning either match R or P.
* Concatenation, i.e. `R * P`, meaning match first R, then P
* Repetition, i.e. `R*`, meaning match R zero or more times consecutively.

!!! note 
    In Automa, the alphabet is _bytes_, i.e. `0x00:0xff`, and so each symbol is a single byte.
    Multi-byte characters such as `Æ` is interpreted as the two concatenated of two symbols,
    `re"\xc3" * re"\x86"`.
    The fact that Automa considers one input to be one byte, not one character, can become relevant if you instruct Automa to complete an action "on every input".

Popular regex libraries include more operations like `?` and `+`.
These can trivially be constructed from the above mentioned primitives,
i.e. `R?` is `"" | R`,
and `R+` is `RR*`.

Some implementations of regular expression engines, such as PCRE which is the default in Julia as of Julia 1.8,
also support operations like backreferences and lookbehind.
These operations can NOT be constructed from the above atoms and axioms, meaning that PCRE expressions are not regular expressions in the theoretical sense.

The practical importance of theoretically sound regular expressions is that there exists algorithms that can match regular expressions on O(N) time and O(1) space,
whereas this is not true for PCRE expressions, which are therefore significantly slower.

!!! note 
    Automa.jl only supports real regex, and as such does not support e.g. backreferences,
    in order to gurantee fast runtime performance.

To match regex to strings, the regex are transformed to _finite automata_, which are then implemented in code.

## Nondeterministic finite automata
The programmer Ken Thompson, of Unix fame, deviced _Thompson's construction_, an algorithm to constuct a nondeterministic finite automaton (NFA) from a regex.
An NFA can be thought of as a flowchart (or a directed graph), where one can move from node to node on directed edges.
Edges are either labeled `ϵ`, in which the machine can freely move through the edge to its destination node,
or labeled with one or more input symbols, in which the machine may traverse the edge upon consuming said input.

To illustrate, let's look at one of the simplest regex: `re"a"`, matching the letter `a`:

![State diagram showing state 1, edge transition consuming input 'a', leading to "accept state" 2](figure/simple.png)

You begin at the small dot on the right, then immediately go to state 1, the circle marked by a `1`.
By moving to the next state, state 2, you consume the next symbol from the input string, which must be the symbol marked on the edge from state 1 to state 2 (in this case, an `a`).
Some states are "accept states", illustrated by a double circle. If you are at an accept state when you've consumed all symbols of the input string, the string matches the regex.

Each of the operations that combine regex can also combine NFAs.
For example, given the two regex `a` and `b`, which correspond to the NFAs `A` and `B`, the regex `a * b` can be expressed with the following NFA:

![State diagram showing ϵ transition from state A to accept state B](figure/cat.png)

Note the `ϵ` symbol on the edge - this signifies an "epsilon transition", meaning you move directly from `A` to `B` without consuming any symbols.

Similarly, `a | b` correspond to this NFA structure...

![State diagram of the NFA for `a | b`](figure/alt.png)

...and `a*` to this:

![State diagram of the NFA for `a*`](figure/kleenestar.png)

For a larger example, `re"(\+|-)?(0|1)*"` combines alternation, concatenation and repetition and so looks like this:

![State diagram of the NFA for `re"(\+|-)?(0|1)*"`](figure/larger.png)

ϵ-transitions means that there are states from which there are multiple possible next states, e.g. in the larger example above, state 1 can lead to state 2 or state 8.
That's what makes NFAs nondeterministic.

In order to match a regex to a string then, the movement through the NFA must be emulated.
You begin at state 1. When a non-ϵ edge is encountered, you consume a byte of the input data if it matches.
If there are no edges that match your input, the string does not match.
If an ϵ-edge is encountered from state `A` that leads to states `B` and `C`, the machine goes from state `A` to state `{B, C}`, i.e. in both states at once.

For example, if the regex `re"(\+|-)?(0|1)*` visualized above is matched to the string `-11`, this is what happens:
* NFA starts in state 1
* NFA immediately moves to all states reachable via ϵ transition. It is now in state {2, 3, 5, 7, 8, 9, 10}.
* NFA sees input `-`. States {2, 3, 4, 5, 7, 8, 10} do not have an edge with `-` leading out, so these states die.
  Therefore, the machine is in state 9, consumes the input, and moves to state 2.
* NFA immediately moves to all states reachable from state 2 via ϵ transitions, so goes to {3, 4, 5, 7}
* NFA sees input `1`, must be in state 5, moves to state 6, then through ϵ transitions to state {3, 4, 5, 7}
* The above point repeats, NFA is still in state {3, 4, 5, 7}
* Input ends. Since state 3 is an accept state, the string matches.

Using only a regex-to-NFA converter, you could create a simple regex engine simply by emulating the NFA as above.
The existence of ϵ transitions means the NFA can be in multiple states at once which adds unwelcome complexity to the emulation and makes it slower.
Luckily, every NFA has an equivalent _determinisitic finite automaton_, which can be constructed from the NFA using the so-called _powerset construction_.

## Deterministic finite automata
Or DFAs, as they are called, are similar to NFAs, but do not contain ϵ-edges.
This means that a given input string has either zero paths (if it does not match the regex), one, unambiguous path, through the DFA.
In other words, every input symbol _must_ trigger one unambiguous state transition from one state to one other state.

Let's visualize the DFA equivalent to the larger NFA above:

![State diagram of the DFA for `re"(\+|-)?(0|1)*"`](figure/large_dfa.png)

It might not be obvious, but the DFA above accepts exactly the same inputs as the previous NFA.
DFAs are way simpler to simulate in code than NFAs, precisely because at every state, for every input, there is exactly one action.
DFAs can be simulated either using a lookup table of possible state transitions,
or by hardcoding GOTO-statements from node to node when the correct input is matched.
Code simulating DFAs can be ridicuously fast, with each state transition taking less than 1 nanosecond, if implemented well.

Furthermore, DFAs can be optimised.
Two edges between the same nodes with labels `A` and `B` can be collapsed to a single edge with labels `[AB]`, and redundant nodes can be collapsed.
The optimised DFA equivalent to the one above is simply: 

![State diagram of the simpler DFA for `re"(\+|-)?(0|1)*"`](figure/large_machine.png)

Unfortunately, as the name "powerset construction" hints, convering an NFA with N nodes may result in a DFA with up to 2^N nodes.
This inconvenient fact drives important design decisions in regex implementations.
There are basically two approaches:

Automa.jl will just construct the DFA directly, and accept a worst-case complexity of O(2^N).
This is acceptable (I think) for Automa, because this construction happens in Julia's package precompilation stage (not on package loading or usage),
and because the DFAs are assumed to be constants within a package.
So, if a developer accidentally writes an NFA which is unacceptably slow to convert to a DFA, it will be caught in development.
Luckily, it's pretty rare to have NFAs that result in truly abysmally slow conversions to DFA's:
While bad corner cases exist, they are rarely as catastrophic as the O(2^N) would suggest.
Currently, Automa's regex/NFA/DFA compilation pipeline is very slow and unoptimized, but, since it happens during precompile time, it is insignificant compared to LLVM compile times.

Other implementations, like the popular `ripgrep` command line tool, uses an adaptive approach.
It constructs the DFA on the fly, as each symbol is being matched, and then caches the DFA.
If the DFA size grows too large, the cache is flushed.
If the cache is flushed too often, it falls back to simulating the NFA directly.
Such an approach is necessary for `ripgrep`, because the regex -> NFA -> DFA compilation happens at runtime and must be near-instantaneous, unlike Automa, where it happens during package precompilation and can afford to be slow.

## Automa in a nutshell
Automa simulates the DFA by having the DFA create a Julia `Expr`, which is then used to generate a Julia function using metaprogramming.
Like all other Julia code, this function is then optimized by Julia and then LLVM, making the DFA simulations very fast.

Because Automa just constructs Julia functions, we can do extra tricks that ordinary regex engines cannot:
We can splice arbitrary Julia code into the DFA simulation.
Currently, Automa supports two such kinds of code: _actions_, and _preconditions_.

Actions are Julia code that is executed during certain state transitions.
Preconditions are Julia code, that evaluates to a `Bool` value, and which are checked before a state transition.
If a precondition evaluates to `false`, the transition is not taken.

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Text validators
The simplest use of Automa is to simply match a regex.
It's unlikely you are going to want to use Automa for this instead of Julia's built-in regex engine PCRE, unless you need the extra performance that Automa brings over PCRE.
Nonetheless, it serves as a good starting point to introduce Automa.

Suppose we have the FASTA regex [from the regex page](@ref fasta_example):

```jldoctest val1
julia> fasta_regex = let
           header = re"[a-z]+"
           seqline = re"[ACGT]+"
           record = '>' * header * '\n' * rep1(seqline * '\n')
           rep(record)
       end;
```

## Buffer validator
Automa comes with a convenience function `generate_buffer_validator`:

Given a regex (`RE`) like the one above, we can do:

```jldoctest val1
julia> eval(generate_buffer_validator(:validate_fasta, fasta_regex));

julia> validate_fasta
validate_fasta (generic function with 1 method)
```

And we now have a function that checks if some data matches the regex:
```jldoctest val1
julia> validate_fasta(">hello\nTAGAGA\nTAGAG") # missing trailing newline
0

julia> validate_fasta(">helloXXX") # Error at byte index 7
7

julia> validate_fasta(">hello\nTAGAGA\nTAGAG\n") # nothing; it matches
```

## IO validators
For large files, having to read the data into a buffer to validate it may not be possible.
Automa also supports creating IO validators with the `generate_io_validator` function:

This works very similar to `generate_buffer_validator`, but the generated function takes an `IO`, and has a different return value:
* If the data matches, still return `nothing`
* Else, return (byte, (line, column)) where byte is the first errant byte, and (line, column) the position of the byte. If the errant byte is a newline, column is 0. If the input reaches unexpected EOF, byte is `nothing`, and (line, column) points to the last line/column in the IO:

```julia val1
julia> eval(generate_io_validator(:validate_io, fasta_regex));

julia> validate_io(IOBuffer(">hello\nTAGAGA\n"))

julia> validate_io(IOBuffer(">helX"))
(0x58, (1, 5))

julia> validate_io(IOBuffer(">hello\n\n"))
(0x0a, (3, 0))

julia> validate_io(IOBuffer(">hello\nAC"))
(nothing, (2, 2))
```

## Reference
```@docs
Automa.generate_buffer_validator
Automa.generate_io_validator
Automa.compile
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Parsing from a buffer
Automa can leverage metaprogramming to combine regex and Julia code to create parsers.
This is significantly more difficult than simply using validators or tokenizers, but still simpler than parsing from an IO.
Currently, Automa loads data through pointers, and therefore needs data backed by `Array{UInt8}` or `String` or similar - it does not work with types such as `UnitRange{UInt8}`.
Furthermore, be careful about passing strided views to Automa - while Automa can extract a pointer from a strided view, it will always advance the pointer one byte at a time, disregarding the view's stride.

As an example, let's use the simplified FASTA format [introduced in the regex section](@ref fasta_example), with the following format: `re"(>[a-z]+\n([ACGT]+\n)+)*"`.
We want to parse it into a `Vector{Seq}`, where `Seq` is defined as:

```jldoctest parse1
julia> struct Seq
           name::String
           seq::String
       end
```

## Adding actions to regex
To do this, we need to inject Julia code into the regex validator while it is running.
The first step is to add _actions_ to our regex: These are simply names of Julia expressions to splice in,
where the expressions will be executed when the regex is matched.
We can choose the names arbitrarily.

Currently, actions can be added in the following places in a regex:
* With `onenter!`, meaning it will be executed when reading the first byte of the regex
* With `onfinal!`, where it will be executed when reading the last byte of the regex.
  Note that it's not possible to determine the final byte for some regex like `re"X+"`, since
  the machine reads only 1 byte at a time and cannot look ahead. In such cases, an error is raised.
* With `onexit!`, meaning it will be executed on reading the first byte AFTER the regex,
  or when exiting the regex by encountering the end of inputs (only for a regex match, not an unexpected end of input)
* With `onall!`, where it will be executed when reading every byte that is part of the regex.

You can set the actions to be a single action name (represented by a `Symbol`), or a list of action names:
```jldoctest
julia> my_regex = re"ABC";

julia> onenter!(my_regex, [:action_a, :action_b]);

julia> onexit!(my_regex, :action_c);
```

In which case the code named `action_a`, then that named `action_b` will executed in order when entering the regex, and the code named `action_c` will be executed when exiting the regex.

The `onenter!` etc functions return the regex they modify, so the above can be written:
```jldoctest
julia> my_regex = onexit!(onenter!(re"ABC", [:action_a, :action_b]), :action_c);

julia> my_regex isa RE
true
```

When the the following regex's actions are visualized in its corresponding [DFA](theory.md#deterministic-finite-automata):

```julia
regex = let
    ab = re"ab*"
    onenter!(ab, :enter_ab)
    onexit!(ab, :exit_ab)
    onfinal!(ab, :final_ab)
    onall!(ab, :all_ab)
    c = re"c"
    onenter!(c, :enter_c)
    onexit!(c, :exit_c)
    onfinal!(c, :final_c)

    ab * c
end
```

The result DFA looks below.
Here, the edge labeled `'a'/enter_ab,all_ab,final_ab` means that the edge consumes input byte `'a'`, and executes the three actions `enter_ab`, `all_ab` and `final_ab`, in that order. 

![Visualization of regex with actions](figure/actions.png)

## Compiling regex to `Machine`s
In order to create code, the regex must first be compiled to a `Machine`, which is a struct that represents an optimised DFA.
We can do that with `compile(regex)`.
Under the hood, this compiles the regex to an NFA, then compiles the NFA to a DFA, and then optimises the DFA to a `Machine` (see the section on [Automa theory](theory.md)).

Normally, we don't care about the regex directly, but only want the `Machine`.
So, it is idiomatic to compile the regex in the same `let` statement it is being built in:

```jldoctest; output = false
machine = let
    header = re"[a-z]+"
    seqline = re"[ACGT]+"
    record = re">" * header * '\n' * rep1(seqline * '\n')
    compile(rep(record))
end
@assert machine isa Automa.Machine

# output

```

Note that, if this code is placed at top level in a package, the regex will be constructed and compiled to a `Machine` during package precompilation, which greatly helps load times.

## Creating our parser
However, in this case, we don't just need a `Machine` with the regex, we need a `Machine` with the regex _containing the relevant actions_.
To parse a simplified FASTA file into a `Vector{Seq}`, I'm using these four actions:

* When the machine enters into the header, or a sequence line, I want it to mark the position with where it entered into the regex.
  The marked position will be used as the leftmost position where the header or sequence is extracted later.
* When exiting the header, I want to extract the bytes from the marked position in the action above,
  to the last header byte (i.e. the byte before the current byte), and use these bytes as the sequence header
* When exiting a sequence line, I want to do the same:
  Extract from the marked position to one before the current position,
  but this time I want to append the current line to a buffer containing all the lines of the sequence
* When exiting a record, I want to construct a `Seq` object from the header bytes and the buffer with all the sequence lines, then push the `Seq` to the result,

```jldoctest parse1
julia> machine = let
           header = onexit!(onenter!(re"[a-z]+", :mark_pos), :header)
           seqline = onexit!(onenter!(re"[ACGT]+", :mark_pos), :seqline)
           record = onexit!(re">" * header * '\n' * rep1(seqline * '\n'), :record)
           compile(rep(record))
       end;
```

We can now write the code we want executed.
When writing this code, we want access to a few variables used by the machine simulation.
For example, we might want to know at which byte position the machine is when an action is executed.
Currently, the following variables are accessible in the code:

* `byte`: The current input byte as a `UInt8`
* `p`: The 1-indexed position of `byte` in the buffer
* `p_end`: The length of the input buffer
* `is_eof`: Whether the machine has reached the end of the input.
* `cs`: The current state of the machine, as an integer
* `data`: The input buffer
* `mem`: The memory being read from, an `Automa.SizedMemory` object containing a pointer and a length

The actions we want executed, we place in a `Dict{Symbol, Expr}`:
```jldoctest parse1
julia> actions = Dict(
           :mark_pos => :(pos = p),
           :header => :(header = String(data[pos:p-1])),
           :seqline => :(append!(buffer, data[pos:p-1])),
           :record => :(push!(seqs, Seq(header, String(buffer))))
       );
```

For multi-line `Expr`, you can construct them with `quote ... end` blocks.

We can now construct a function that parses our data.
In the code written in the action dict above, besides the variables defined for us by Automa,
we also refer to the variables `buffer`, `header`, `pos` and `seqs`.
Some of these variables are defined in the code above (for example, in the `:(pos = p)` expression),
but we can't necessarily control the order in which Automa will insert these expressions into out final function.
Hence, let's initialize these variables at the top of the function we generate, such that we know for sure they are defined when used - whenever they are used.

The code itself is generated using `generate_code`:

```jldoctest parse1
julia> @eval function parse_fasta(data)
           pos = 0
           buffer = UInt8[]
           seqs = Seq[]
           header = ""
           $(generate_code(machine, actions))
           return seqs
       end
parse_fasta (generic function with 1 method)
```

We can now use it:
```jldoctest parse1
julia> parse_fasta(">abc\nTAGA\nAAGA\n>header\nAAAG\nGGCG\n")
2-element Vector{Seq}:
 Seq("abc", "TAGAAAGA")
 Seq("header", "AAAGGGCG")
```

If we give out function a bad input - for example, if we forget the trailing newline, it throws an error:

```jldoctest parse1
julia> parse_fasta(">abc\nTAGA\nAAGA\n>header\nAAAG\nGGCG")
ERROR: Error during FSM execution at buffer position 33.
Last 32 byte(s) were:

">abc\nTAGA\nAAGA\n>header\nAAAG\nGGCG"

Observed input: EOF at state 5. Outgoing edges:
 * '\n'/seqline
 * [ACGT]

Input is not in any outgoing edge, and machine therefore errored.
```

The code above parses with about 300 MB/s on my laptop.
Not bad, but Automa can do better - read on to learn how to customize codegen.

## Preconditions
You might have noticed a peculiar detail about our FASTA format: It demands a trailing newline after each record.
In other words, `>a\nA` is not a valid FASTA record.

We can easily rewrite the regex such that the last record does not need a trailing `\n`.
But look what happens when we try that:

```jldoctest parse1
julia> machine = let
           header = onexit!(onenter!(re"[a-z]+", :mark_pos), :header)
           seqline = onexit!(onenter!(re"[ACGT]+", :mark_pos), :seqline)
           record = onexit!(re">" * header * '\n' * seqline * rep('\n' * seqline), :record)
           compile(opt(record) * rep('\n' * record) * rep(re"\n"))
       end;
ERROR: Ambiguous NFA.
```

Why does this error? Well, remember that Automa processes one byte at a time, and at each byte, makes a decision on what actions to execute.
Hence, if it sees the input `>a\nA\n`, it does not know what to do when encountering the second `\n`. If the next byte is, e,g. `A`, then it would need to execute the `:seqline` action. If the byte is `>`, it would need to execute first `:seqline`, then `:record`.
Automa can't read ahead, so, the regex is ambiguous and the true behaviour when reading the inputs `>a\nA\n` is undefined.
Therefore, Automa refuses to compile it.

There are several ways to solve this:
* First, you can rewrite the regex to not be ambiguous. This is usually the preferred option: After all, if the regex is ambiguous, you probably made a mistake with the regex
* You can manually diasable the ambiguity check by passing the keyword `unambiguous=false` to `compile`. This will cause the machine to undefined behaviour if an input like `>a\nA\n` is seen, so this is usually a poor idea.
* You can rewrite the actions, such that the action itself uses an if-statement to check what to do. In the example above, you could remove the `:record` action and have the `:seqline` action conditionally emit a record if the next byte was `>`.

Finally, you can use _preconditions_.
A precondition is a symbol, attached to a regex, just like an action.
Just like an action, the symbol is attached to an `Expr` object, but for preconditions this must evaluate to a `Bool`.
If `false`, the regex is not entered.

Let's have an example. The following machine is obviously ambiguous:

```jldoctest parse1
julia> machine = let
           a = onenter!(re"XY", :a)
           b = onenter!(re"XZ", :b)
           compile('A' * (a | b))
       end;
ERROR: Ambiguous NFA.
```

We can add a precondition with `precond!`. Below, `precond!(regex, label)` is equivalent to `precond!(regex, label; when=:enter, bool=true)`. This means "only enter `regex` when the boolean expression `label` evaluates to `bool` (`true`)":

```jldoctest parse1
julia> machine = let
           a = precond!(onenter!(re"XY", :a), :test)
           b = precond!(onenter!(re"XZ", :b), :test; bool=false)
           compile('A' * (a | b))
       end;

julia> machine isa Automa.Machine
true
```

Here, `re"XY"` can only be entered when `:test` is `true`, and `re"XZ"` only when `:test` is `false`.
So, there can be no ambiguous behaviour and the regex compiles fine.

## Reference
```@docs
Automa.onenter!
Automa.onexit!
Automa.onall!
Automa.onfinal!
Automa.precond!
Automa.generate_code
Automa.generate_init_code
Automa.generate_exec_code
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Customizing Automa's code generation
Automa offers a few ways of customising the created code.
Note that the precise code generated by Automa is considered an implementation detail,
and as such is subject to change without warning.
Only the overall behavior, i.e. the "DFA simulation" can be considered stable.

Nonetheless, it is instructive to look at the code generated for the machine in the "parsing from a buffer" [section](@ref "Creating our parser").
I present it here cleaned up and with comments for human inspection.

```julia
# Initialize variables used in the code below
byte::UInt8 = 0x00
p::Int = 1
p_end::Int = sizeof(data)
p_eof::Int = p_end
cs::Int = 1

# Turn the input buffer into SizedMemory, to load data from pointer
GC.@preserve data begin
mem::Automa.SizedMemory = (Automa.SizedMemory)(data)

# For every input byte:
while p ≤ p_end && cs > 0
    # Load byte
    byte = mem[p]

    # Load the action, to execute, if any, by looking up in a table
    # using the current state (cs) and byte
    @inbounds var"##292" = Int((Int8[0 0 … 0 0; 0 0 … 0 0; … ; 0 0 … 0 0; 0 0 … 0 0])[(cs - 1) << 8 + byte + 1])

    # Look up next state. If invalid input, next state is negative current state
    @inbounds cs = Int((Int8[-1 -2 … -5 -6; -1 -2 … -5 -6; … ; -1 -2 … -5 -6; -1 -2 … -5 -6])[(cs - 1) << 8 + byte + 1])

    # Check each possible action looked up above, and execute it
    # if it is not zero
    if var"##292" == 1
        pos = p
    elseif var"##292" == 2
        header = String(data[pos:p - 1])
    elseif if var"##292" == 3
        append!(buffer, data[pos:p - 1])
    elseif var"##292" == 4
        seq = Seq(header, String(buffer))
        push!(seqs, seq)
    end

    # Increment position by 1
    p += 1

    # If we're at end of input, and the current state in in an accept state:
    if p > p_eof ≥ 0 && cs > 0 && (cs < 65) & isodd(0x0000000000000021 >>> ((cs - 1) & 63))
        # What follows is a list of all possible EOF actions.

        # If state is state 6, execute the appropriate action
        # tied to reaching end of input at this state
        if cs == 6
            seq = Seq(header, String(buffer))
            push!(seqs, seq)
            cs = 0

    # Else, if the state is < 0, we have taken a bad input (see where cs was updated)
    # move position back by one to leave it stuck where it found bad input
    elseif cs < 0
        p -= 1
    end

    # If cs is not 0, the machine is in an error state.
    # Gather some information about machine state, then throw an error
    if cs != 0
        cs = -(abs(cs))
        var"##291" = if p_eof > -1 && p > p_eof
            nothing
        else
            byte
        end
        Automa.throw_input_error($machine, -cs, var"##291", mem, p)
    end
end
end # GC.@preserve
```

## Using `CodeGenContext`
The `CodeGenContext` (or ctx, for short) struct is a collection of settings used to customize code creation.
If not passed to the code generator functions, a default `CodeGenContext` is used.

### Variable names
One obvious place to customize is variable names.
In the code above, for example, the input bytes are named `byte`.
What if you have another variable with that name?

The ctx contains a `.vars` field with a `Variables` object, which is just a collection of names used in generated code.
For example, to rename `byte` to `u8` in the generated code, you first create the appropriate ctx,
then use the ctx to make the code.

```julia
ctx = CodeGenContext(vars=Automa.Variables(byte=:u8))
code = generate_code(ctx, machine, actions)
```

### Other options
* The `clean` option strips most linenumber information from the generated code, if set to true.
* `getbyte` is a function that is called like this `getbyte(data, p)` to obtain `byte` in the main loop.
  This is usually just `Base.getindex`, but can be customised to be an arbitrary function.

### Code generator
The code showed at the top of this page is code made with the table code generator.
Automa also supports creating code using the goto code generator instead of the default table generator.
The goto generator creates code with the following properties:
* It is much harder to read than table code
* The code is much larger
* It does not use boundschecking
* It does not allow customizing `getbyte`
* It is much faster than the table generator

Normally, the table generator is good enough, but for performance sensitive applications,
the goto generator can be used.

## Optimising the previous example
Let's try optimising the previous FASTA parsing example.
My original code did 300 MB/s.

To recap, the `Machine` was:

```jldoctest custom1; output = false
machine = let
    header = onexit!(onenter!(re"[a-z]+", :mark_pos), :header)
    seqline = onexit!(onenter!(re"[ACGT]+", :mark_pos), :seqline)
    record = onexit!(re">" * header * '\n' * rep1(seqline * '\n'), :record)
    compile(rep(record))
end
@assert machine isa Automa.Machine

# output

```

The first improvement is to the algorithm itself: Instead of parsing to a vector of `Seq`,
I'm simply going to index the input data, filling up an existing vector of:

```jldoctest custom1; output = false
struct SeqPos
    offset::Int
    hlen::Int32
    slen::Int32
end

# output

```

The idea here is to remove as many allocations as possible.
This will more accurately show the speed of the DFA simulation, which is now the bottleneck.
The actions will therefore be 

```jldoctest custom1; output = false
actions = Dict(
    :mark_pos => :(pos = p),
    :header => :(hlen = p - pos),
    :seqline => :(slen += p - pos),
    :record => quote
        seqpos = SeqPos(offset, hlen, slen)
        nseqs += 1
        seqs[nseqs] = seqpos
        offset += hlen + slen
        slen = 0
    end
);

@assert actions isa Dict

# output

```

With the new variables such as `slen`, we need to update the function code as well:
```jldoctest custom1; output = false
@eval function parse_fasta(data)
    pos = slen = hlen = offset = nseqs = 0
    seqs = Vector{SeqPos}(undef, 400000)
    $(generate_code(machine, actions))
    return seqs
end

# output
parse_fasta (generic function with 1 method)
```

This parses a 45 MB file in about 100 ms in my laptop, that's 450 MB/s.
Now let's try the exact same, except with the code being generated by:

`$(generate_code(CodeGenContext(generator=:goto), machine, actions))`

Now the code parses the same 45 MB FASTA file in 11.14 miliseconds, parsing at about 4 GB/s.

## Reference

```@docs
Automa.CodeGenContext
Automa.Variables
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Tokenizers (lexers)
A _tokenizer_ or a _lexer_ is a program that breaks down an input text into smaller chunks, and classifies them as one of several _tokens_.
For example, consider an imagininary format that only consists of nested tuples of strings containing letters, like this:

```
(("ABC", "v"),(("x", ("pj",(("a", "k")), ("L")))))
```

Any text of this format can be broken down into a sequence of the following tokens:
* Left parenthesis: `re"\("`
* Right parenthesis: `re"\)"`
* Comma: `re","`
* Quote: `re"\""`
* Spaces: `re" +"`
* Letters: `re"[A-Za-z]+"`

Such that e.g. `("XY", "A")` can be represented as the token sequence `lparens, quote, XY, quote, comma, space, quote A quote rparens`.

Breaking the text down to its tokens is called tokenization or lexing.
Note that lexing in itself is not sufficient to parse the format:
Lexing is _context unaware_ and doesn't understand syntax, so e.g. the text `"((A` can be perfectly well tokenized to `quote lparens lparens A`, even if it's invalid syntax.

The purpose of tokenization is to make subsequent parsing easier, because each part of the text has been classified. That makes it easier to, for example, search for letters in the input.
Instead of having to muck around with regex to find the letters, you use regex once to classify all text.

## Making and using a tokenizer
Let's use the example above to create a tokenizer.
The most basic tokenizer defaults to using `UInt32` as tokens: You pass in a list of regex matching each token, then evaluate the resulting code:

```jldoctest tok1
julia> make_tokenizer(
           [re"\(", re"\)", re",", re"\"", re" +", re"[a-zA-Z]+"]
       ) |> eval
```
The `make_tokenizer` function creates Julia code (an `Expr` object) that, when evaluated, defines `Base.iterate` for the `Tokenizer` type.
The code above defined `Base.iterate(::Tokenizer{UInt32, D, 1}) where D` - we'll get back to the different type parameters of `Tokenizer` later.

`Tokenizer`s are most easily created with the `tokenize` function.
To create a `Tokenizer{UInt32}`, we can do call `tokenize(UInt32, data)`:

```jldoctest tok1
julia> iterator = tokenize(UInt32, """("XY", "A")"""); typeof(iterator)
Tokenizer{UInt32, String, 1}
```

Meaning: A `Tokenizer` emitting `UInt32` over `String` data, of version `1`.
Since we used `make_tokenizer` above to define iteration for this kind of tokenizer (one with `UInt32` tokens),
we can iterate this tokenizer.

When we iterate, we get `Tuple{Int64, Int32, UInt32}` elements, with each element being:
* The start index of the token
* The length of the token
* The token itself, in this example `UInt32(1)` for '(', `UInt32(2)` for ')' etc: 

```jldoctest tok1
julia> collect(iterator)
10-element Vector{Tuple{Int64, Int32, UInt32}}:
 (1, 1, 0x00000001)
 (2, 1, 0x00000004)
 (3, 2, 0x00000006)
 (5, 1, 0x00000004)
 (6, 1, 0x00000003)
 (7, 1, 0x00000005)
 (8, 1, 0x00000004)
 (9, 1, 0x00000006)
 (10, 1, 0x00000004)
 (11, 1, 0x00000002)
```

The type of the last element in each tuple comes from the `Tokenizer` type parameter:
We specified `UInt32`, so we get `UInt32` tokens.

Any data which could not be tokenized is given the error token `UInt32(0)`:
```jldoctest tok1
julia> collect(tokenize(UInt32, "XY!!)"))
3-element Vector{Tuple{Int64, Int32, UInt32}}:
 (1, 2, 0x00000006)
 (3, 2, 0x00000000)
 (5, 1, 0x00000002)
```

Both `tokenize` and `make_tokenizer` take an optional argument `version`, which is `1` by default.
This sets the last parameter of the `Tokenizer` struct - for example, `make_tokenizer(tokens::Vector{RE}; version=5)`
defines `Base.iterate` for `Tokenizer{UInt32, D, 5}`.

By letting the user freely choose the value of the last type parameter, this allows you to create multiple different tokenizers with the same element type.

## Using enums as tokens
Using `UInt32` as tokens is not very convenient - so it's possible to use enums to create the tokenizer:

```jldoctest tok2
julia> @enum Token error lparens rparens comma quot space letters

julia> make_tokenizer((error, [
           lparens => re"\(",
           rparens => re"\)",
           comma => re",",
           quot => re"\"",
           space => re" +",
           letters => re"[a-zA-Z]+"
        ])) |> eval

julia> collect(tokenize(Token, "XY!!)"))
3-element Vector{Tuple{Int64, Int32, Token}}:
 (1, 2, letters)
 (3, 2, error)
 (5, 1, rparens)
```

To make it even easier, you can define the enum and the tokenizer in one go:
```jldoctest; output = false
tokens = [
    :lparens => re"\(",
    :rparens => re"\)",
    :comma => re",",
    :quot => re"\"",
    :space => re" +",
    :letters => re"[a-zA-Z]+"
]
@eval @enum Token error $(first.(tokens)...)
make_tokenizer((error, 
    [Token(i) => j for (i,j) in enumerate(last.(tokens))]
)) |> eval

# output

```

## Token disambiguation
It's possible to create a tokenizer where the different token regexes overlap:
```jldoctest
julia> make_tokenizer([re"[ab]+", re"ab*", re"ab"]) |> eval
```

In this case, an input like `ab` will match all three regex.
Which tokens are emitted is determined by two rules:

First, the emitted tokens will be as long as possible.
So, the input `aa` could be emitted as one token of the regex `re"[ab]+"`, two tokens of the same regex, or of two tokens of the regex `re"ab*"`.
In this case, it will be emitted as a single token of `re"[ab]+"`, since that will make the first token as long as possible (2 bytes), whereas the other options would only make it 1 byte long.

Second, tokens with a higher index in the input array beats previous tokens.
So, `a` will be emitted as `re"ab*"`, as its index of 2 beats the previous regex `re"[ab]+"` with the index 1, and `ab` will match the third regex.

If you don't want emitted tokens to depend on these priority rules, you can set the optional keyword `unambiguous=true` in the `make_tokenizer` function, in which case `make_tokenizer` will error if any input text could be broken down into different tokens.
However, note that this may cause most tokenizers to error when being built, as most tokenization processes are ambiguous.

## Reference
```@docs
Automa.Tokenizer
Automa.tokenize
Automa.make_tokenizer
```

```@meta
CurrentModule = Automa
DocTestSetup = quote
    using TranscodingStreams
    using Automa
end
```

# Regex
Automa regex (of the type `Automa.RE`) are conceptually similar to the Julia built-in regex.
They are made using the `@re_str` macro, like this: `re"ABC[DEF]"`.

Automa regex matches individual bytes, not characters. Hence, `re"Æ"` (with the UTF-8 encoding `[0xc3, 0x86]`) is equivalent to `re"\xc3\x86"`, and is considered the concatenation of two independent input bytes.

The `@re_str` macro supports the following content:
* Literal symbols, such as `re"ABC"`, `re"\xfe\xa2"` or `re"Ø"`.
* `|` for alternation, as in `re"A|B"`, meaning "`A` or `B`". 
* Byte sets with `[]`, like `re"[ABC]"`.
  This means any of the bytes in the brackets, e.g. `re"[ABC]"` is equivalent to `re"A|B|C"`.
* Inverted byte sets, e.g. `re"[^ABC]"`, meaning any byte, except those in `re[ABC]`.
* Repetition, with `X*` meaning zero or more repetitions of X.
* `+`, where `X+` means `XX*`, i.e. 1 or more repetitions of X.
* `?`, where `X?` means `X | ""`, i.e. 0 or 1 occurrences of X. It applies to the last element of the regex.
* Parentheses to group expressions, like in `re"A(B|C)?"`.

You can combine regex with the following operations:
* `*` for concatenation, with `re"A" * re"B"` being the same as `re"AB"`.
  Regex can also be concatenated with `Char`s and `String`s, which will cause the chars/strings to be converted to regex first.
* `|` for alternation, with `re"A" | re"B"` being the same as `re"A|B"`
* `&` for intersection of regex, i.e. for regex `A` and `B`, the set of inputs matching `A & B` is exactly the intersection of the inputs match `A` and those matching `B`.
  As an example, `re"A[AB]C+D?" & re"[ABC]+"` is `re"ABC"`.
* `\` for difference, such that for regex `A` and `B`, `A \ B` creates a new regex matching all those inputs that match `A` but not `B`.
* `!` for inversion, such that `!re"[A-Z]"` matches all other strings than those which match `re"[A-Z]"`.
  Note that `!re"a"` also matches e.g. `"aa"`, since this does not match `re"a"`.

Finally, the functions `opt`, `rep` and `rep1` are equivalent to the operators `?`, `*` and `+`, so for eg. `opt(re"a" * rep(re"b") * re"c")` is equivalent to `re"(ab*c)?"`.

## [Example](@id fasta_example)
Suppose we want to create a regex that matches a simplified version of the FASTA format.
This "simple FASTA" format is defined like so:

* The format is a series of zero or more _records_, concatenated
* A _record_ consists of the concatenation of:
    - A leading '>'
    - A header, composed of one or more letters in 'a-z',
    - A newline symbol '\n'
    - A series of one or more _sequence lines_
* A _sequence line_ is the concatenation of:
    - One or more symbols from the alphabet [ACGT]
    - A newline

We can represent this concisely as a regex: `re"(>[a-z]+\n([ACGT]+\n)+)*"`
To make it easier to read,  we typically construct regex incrementally, like such:

```jldoctest; output = false
fasta_regex = let
    header = re"[a-z]+"
    seqline = re"[ACGT]+"
    record = '>' * header * '\n' * rep1(seqline * '\n')
    rep(record)
end
@assert fasta_regex isa RE

# output

```

## Reference
```@docs
RE
@re_str
```
